export declare enum DataSetEvents {
    query = "query",
    count = "count",
    beforeLoad = "beforeLoad",
    beforeAppend = "beforeAppend",
    load = "load",
    append = "append",
    loadFailed = "loadFailed",
    submit = "submit",
    submitSuccess = "submitSuccess",
    submitFailed = "submitFailed",
    select = "select",
    unSelect = "unSelect",
    selectAll = "selectAll",
    unSelectAll = "unSelectAll",
    batchSelect = "batchSelect",
    batchUnSelect = "batchUnSelect",
    selectAllPage = "selectAllPage",
    unSelectAllPage = "unSelectAllPage",
    indexChange = "indexChange",
    update = "update",
    fieldChange = "fieldChange",
    export = "export",
    create = "create",
    beforeRemove = "beforeRemove",
    remove = "remove",
    beforeDelete = "beforeDelete",
    reset = "reset",
    validate = "validate",
    validateSelf = "validateSelf"
}
export declare enum ExportMode {
    server = "server",
    client = "client"
}
export declare enum DataSetSelection {
    single = "single",
    multiple = "multiple"
}
export declare enum DataSetStatus {
    loading = "loading",
    submitting = "submitting",
    ready = "ready"
}
export declare enum DataSetExportStatus {
    exporting = "exporting",
    success = "success",
    progressing = "progressing",
    start = "start",
    failed = "failed"
}
export declare enum RecordStatus {
    delete = "delete",
    update = "update",
    add = "add",
    sync = "sync"
}
export declare enum RecordCachedType {
    selected = "selected",
    delete = "delete",
    update = "update",
    add = "add"
}
export declare enum FieldType {
    auto = "auto",
    boolean = "boolean",
    number = "number",
    currency = "currency",
    string = "string",
    date = "date",
    dateTime = "dateTime",
    week = "week",
    month = "month",
    year = "year",
    time = "time",
    object = "object",
    intl = "intl",
    email = "email",
    url = "url",
    color = "color",
    json = "json",
    attachment = "attachment",
    secret = "secret",
    reactNode = "reactNode",
    bigNumber = "bigNumber"
}
export declare enum SortOrder {
    asc = "asc",
    desc = "desc"
}
export declare enum BooleanValue {
    trueValue = "trueValue",
    falseValue = "falseValue"
}
export declare enum FieldIgnore {
    always = "always",
    clean = "clean",
    never = "never"
}
export declare enum FieldTrim {
    both = "both",
    left = "left",
    right = "right",
    none = "none"
}
export declare enum FieldFormat {
    uppercase = "uppercase",
    lowercase = "lowercase",
    capitalize = "capitalize"
}
export declare enum DataToJSON {
    dirty = "dirty",
    selected = "selected",
    all = "all",
    normal = "normal",
    'dirty-field' = "dirty-field",
    'dirty-self' = "dirty-self",
    'selected-self' = "selected-self",
    'all-self' = "all-self",
    'normal-self' = "normal-self",
    'dirty-field-self' = "dirty-field-self"
}
export declare enum CheckedStrategy {
    SHOW_ALL = "SHOW_ALL",
    SHOW_PARENT = "SHOW_PARENT",
    SHOW_CHILD = "SHOW_CHILD"
}
export declare enum ValidationSelfType {
    minLength = "minLength",
    maxLength = "maxLength"
}
export declare enum DateMode {
    time = "time",
    dateTime = "dateTime",
    week = "week",
    date = "date",
    month = "month",
    year = "year",
    decade = "decade"
}
export declare enum DownloadAllMode {
    readOnly = "readOnly",
    always = "always"
}
