"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ValidationSelfType = exports.SortOrder = exports.RecordStatus = exports.RecordCachedType = exports.FieldType = exports.FieldTrim = exports.FieldIgnore = exports.FieldFormat = exports.ExportMode = exports.DownloadAllMode = exports.DateMode = exports.DataToJSON = exports.DataSetStatus = exports.DataSetSelection = exports.DataSetExportStatus = exports.DataSetEvents = exports.CheckedStrategy = exports.BooleanValue = void 0;
var DataSetEvents;
exports.DataSetEvents = DataSetEvents;

(function (DataSetEvents) {
  DataSetEvents["query"] = "query";
  DataSetEvents["count"] = "count";
  DataSetEvents["beforeLoad"] = "beforeLoad";
  DataSetEvents["beforeAppend"] = "beforeAppend";
  DataSetEvents["load"] = "load";
  DataSetEvents["append"] = "append";
  DataSetEvents["loadFailed"] = "loadFailed";
  DataSetEvents["submit"] = "submit";
  DataSetEvents["submitSuccess"] = "submitSuccess";
  DataSetEvents["submitFailed"] = "submitFailed";
  DataSetEvents["select"] = "select";
  DataSetEvents["unSelect"] = "unSelect";
  DataSetEvents["selectAll"] = "selectAll";
  DataSetEvents["unSelectAll"] = "unSelectAll";
  DataSetEvents["batchSelect"] = "batchSelect";
  DataSetEvents["batchUnSelect"] = "batchUnSelect";
  DataSetEvents["selectAllPage"] = "selectAllPage";
  DataSetEvents["unSelectAllPage"] = "unSelectAllPage";
  DataSetEvents["indexChange"] = "indexChange";
  DataSetEvents["update"] = "update";
  DataSetEvents["fieldChange"] = "fieldChange";
  DataSetEvents["export"] = "export";
  DataSetEvents["create"] = "create";
  DataSetEvents["beforeRemove"] = "beforeRemove";
  DataSetEvents["remove"] = "remove";
  DataSetEvents["beforeDelete"] = "beforeDelete";
  DataSetEvents["reset"] = "reset";
  DataSetEvents["validate"] = "validate";
  DataSetEvents["validateSelf"] = "validateSelf";
})(DataSetEvents || (exports.DataSetEvents = DataSetEvents = {}));

var ExportMode;
exports.ExportMode = ExportMode;

(function (ExportMode) {
  ExportMode["server"] = "server";
  ExportMode["client"] = "client";
})(ExportMode || (exports.ExportMode = ExportMode = {}));

var DataSetSelection;
exports.DataSetSelection = DataSetSelection;

(function (DataSetSelection) {
  DataSetSelection["single"] = "single";
  DataSetSelection["multiple"] = "multiple";
})(DataSetSelection || (exports.DataSetSelection = DataSetSelection = {}));

var DataSetStatus;
exports.DataSetStatus = DataSetStatus;

(function (DataSetStatus) {
  DataSetStatus["loading"] = "loading";
  DataSetStatus["submitting"] = "submitting";
  DataSetStatus["ready"] = "ready";
})(DataSetStatus || (exports.DataSetStatus = DataSetStatus = {}));

var DataSetExportStatus;
exports.DataSetExportStatus = DataSetExportStatus;

(function (DataSetExportStatus) {
  DataSetExportStatus["exporting"] = "exporting";
  DataSetExportStatus["success"] = "success";
  DataSetExportStatus["progressing"] = "progressing";
  DataSetExportStatus["start"] = "start";
  DataSetExportStatus["failed"] = "failed";
})(DataSetExportStatus || (exports.DataSetExportStatus = DataSetExportStatus = {}));

var RecordStatus;
exports.RecordStatus = RecordStatus;

(function (RecordStatus) {
  RecordStatus["delete"] = "delete";
  RecordStatus["update"] = "update";
  RecordStatus["add"] = "add";
  RecordStatus["sync"] = "sync";
})(RecordStatus || (exports.RecordStatus = RecordStatus = {}));

var RecordCachedType;
exports.RecordCachedType = RecordCachedType;

(function (RecordCachedType) {
  RecordCachedType["selected"] = "selected";
  RecordCachedType["delete"] = "delete";
  RecordCachedType["update"] = "update";
  RecordCachedType["add"] = "add";
})(RecordCachedType || (exports.RecordCachedType = RecordCachedType = {}));

var FieldType;
exports.FieldType = FieldType;

(function (FieldType) {
  FieldType["auto"] = "auto";
  FieldType["boolean"] = "boolean";
  FieldType["number"] = "number";
  FieldType["currency"] = "currency";
  FieldType["string"] = "string";
  FieldType["date"] = "date";
  FieldType["dateTime"] = "dateTime";
  FieldType["week"] = "week";
  FieldType["month"] = "month";
  FieldType["year"] = "year";
  FieldType["time"] = "time";
  FieldType["object"] = "object";
  FieldType["intl"] = "intl";
  FieldType["email"] = "email";
  FieldType["url"] = "url";
  FieldType["color"] = "color";
  FieldType["json"] = "json";
  FieldType["attachment"] = "attachment";
  FieldType["secret"] = "secret";
  FieldType["reactNode"] = "reactNode";
  FieldType["bigNumber"] = "bigNumber";
})(FieldType || (exports.FieldType = FieldType = {}));

var SortOrder;
exports.SortOrder = SortOrder;

(function (SortOrder) {
  SortOrder["asc"] = "asc";
  SortOrder["desc"] = "desc";
})(SortOrder || (exports.SortOrder = SortOrder = {}));

var BooleanValue;
exports.BooleanValue = BooleanValue;

(function (BooleanValue) {
  BooleanValue["trueValue"] = "trueValue";
  BooleanValue["falseValue"] = "falseValue";
})(BooleanValue || (exports.BooleanValue = BooleanValue = {}));

var FieldIgnore;
exports.FieldIgnore = FieldIgnore;

(function (FieldIgnore) {
  FieldIgnore["always"] = "always";
  FieldIgnore["clean"] = "clean";
  FieldIgnore["never"] = "never";
})(FieldIgnore || (exports.FieldIgnore = FieldIgnore = {}));

var FieldTrim;
exports.FieldTrim = FieldTrim;

(function (FieldTrim) {
  FieldTrim["both"] = "both";
  FieldTrim["left"] = "left";
  FieldTrim["right"] = "right";
  FieldTrim["none"] = "none";
})(FieldTrim || (exports.FieldTrim = FieldTrim = {}));

var FieldFormat;
exports.FieldFormat = FieldFormat;

(function (FieldFormat) {
  FieldFormat["uppercase"] = "uppercase";
  FieldFormat["lowercase"] = "lowercase";
  FieldFormat["capitalize"] = "capitalize";
})(FieldFormat || (exports.FieldFormat = FieldFormat = {}));

var DataToJSON;
exports.DataToJSON = DataToJSON;

(function (DataToJSON) {
  DataToJSON["dirty"] = "dirty";
  DataToJSON["selected"] = "selected";
  DataToJSON["all"] = "all";
  DataToJSON["normal"] = "normal";
  DataToJSON["dirty-field"] = "dirty-field";
  DataToJSON["dirty-self"] = "dirty-self";
  DataToJSON["selected-self"] = "selected-self";
  DataToJSON["all-self"] = "all-self";
  DataToJSON["normal-self"] = "normal-self";
  DataToJSON["dirty-field-self"] = "dirty-field-self";
})(DataToJSON || (exports.DataToJSON = DataToJSON = {}));

var CheckedStrategy;
exports.CheckedStrategy = CheckedStrategy;

(function (CheckedStrategy) {
  CheckedStrategy["SHOW_ALL"] = "SHOW_ALL";
  CheckedStrategy["SHOW_PARENT"] = "SHOW_PARENT";
  CheckedStrategy["SHOW_CHILD"] = "SHOW_CHILD";
})(CheckedStrategy || (exports.CheckedStrategy = CheckedStrategy = {}));

var ValidationSelfType;
exports.ValidationSelfType = ValidationSelfType;

(function (ValidationSelfType) {
  ValidationSelfType["minLength"] = "minLength";
  ValidationSelfType["maxLength"] = "maxLength";
})(ValidationSelfType || (exports.ValidationSelfType = ValidationSelfType = {}));

var DateMode;
exports.DateMode = DateMode;

(function (DateMode) {
  DateMode["time"] = "time";
  DateMode["dateTime"] = "dateTime";
  DateMode["week"] = "week";
  DateMode["date"] = "date";
  DateMode["month"] = "month";
  DateMode["year"] = "year";
  DateMode["decade"] = "decade";
})(DateMode || (exports.DateMode = DateMode = {}));

var DownloadAllMode;
exports.DownloadAllMode = DownloadAllMode;

(function (DownloadAllMode) {
  DownloadAllMode["readOnly"] = "readOnly";
  DownloadAllMode["always"] = "always";
})(DownloadAllMode || (exports.DownloadAllMode = DownloadAllMode = {}));
//# sourceMappingURL=enum.js.map
