"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = tooShort;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _utils = require("../../utils");

var _ValidationResult = _interopRequireDefault(require("../ValidationResult"));

var _localeContext = require("../../locale-context");

function tooShort(value, validatorBaseProps, getProp) {
  if (!(0, _utils.isEmpty)(value)) {
    var minLength = getProp('minLength');

    if (minLength !== undefined && minLength > 0) {
      var _value$toString = value.toString(),
          length = _value$toString.length;

      if (length < minLength) {
        var injectionOptions = {
          minLength: minLength,
          length: length
        };
        var ruleName = 'tooShort';

        var _ref = getProp('defaultValidationMessages') || {},
            _ref$ruleName = _ref[ruleName],
            validationMessage = _ref$ruleName === void 0 ? (0, _localeContext.$l)('Validator', 'too_short') : _ref$ruleName;

        return new _ValidationResult["default"]({
          validationProps: (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, validatorBaseProps), {}, {
            minLength: minLength
          }),
          validationMessage: validationMessage,
          injectionOptions: injectionOptions,
          value: value,
          ruleName: ruleName
        });
      }
    }
  }

  return true;
}
//# sourceMappingURL=tooShort.js.map
