import { getConfig } from '../configure/utils';
export function getUsefulTooltip(target) {
  switch (target) {
    case 'table-cell':
      return getConfig('tableColumnTooltip');

    case 'button':
      return getConfig('buttonTooltip');

    case 'select-option':
      return getConfig('selectOptionTooltip');

    case 'label':
      return getConfig('labelTooltip');

    default:
  }
}
export function getTooltip(target) {
  var tooltip = getConfig('tooltip');

  if (typeof tooltip === 'function') {
    return tooltip(target);
  }

  return getUsefulTooltip(target) || tooltip;
}
export function getTooltipTheme(target) {
  var tooltipTheme = getConfig('tooltipTheme');

  if (typeof tooltipTheme === 'function') {
    return tooltipTheme(target);
  }

  if (target === 'validation') {
    var validationTooltipTheme = getConfig('validationTooltipTheme');

    if (validationTooltipTheme) {
      return validationTooltipTheme;
    }
  }

  return tooltipTheme;
}
export function getTooltipPlacement(target) {
  var tooltipPlacement = getConfig('tooltipPlacement');

  if (typeof tooltipPlacement === 'function') {
    return tooltipPlacement(target);
  }

  return tooltipPlacement;
}
//# sourceMappingURL=TooltipUtils.js.map
