import { global } from 'choerodon-ui/shared';
export default function isFlexSupported() {
  var FLEX_SUPPORT = global.FLEX_SUPPORT;

  if (FLEX_SUPPORT !== undefined) {
    return FLEX_SUPPORT;
  }

  if (typeof window !== 'undefined' && window.document && window.document.documentElement) {
    var documentElement = window.document.documentElement;
    var support = 'flex' in documentElement.style || 'webkitFlex' in documentElement.style || 'Flex' in documentElement.style || 'msFlex' in documentElement.style;
    global.FLEX_SUPPORT = support;
    return support;
  }

  return false;
}
//# sourceMappingURL=isFlexSupported.js.map
