import raf from 'raf';
import getScroll from './getScroll';
import { easeInOutCubic } from './easings';
export default function scrollTo(to) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var _options$getContainer = options.getContainer,
      getContainer = _options$getContainer === void 0 ? function () {
    return window;
  } : _options$getContainer,
      callback = options.callback,
      _options$duration = options.duration,
      duration = _options$duration === void 0 ? 450 : _options$duration,
      _options$top = options.top,
      top = _options$top === void 0 ? true : _options$top;
  var container = getContainer();
  var scroll = getScroll(container, top);
  var startTime = Date.now();

  var frameFunc = function frameFunc() {
    var timestamp = Date.now();
    var time = timestamp - startTime;
    var nextScroll = easeInOutCubic(time > duration ? duration : time, scroll, to, duration);

    if (top) {
      if (container === window) {
        window.scrollTo(window.pageXOffset, nextScroll);
      } else {
        container.scrollTop = nextScroll;
      }
    } else if (container === window) {
      window.scrollTo(nextScroll, window.pageYOffset);
    } else {
      container.scrollLeft = nextScroll;
    }

    if (time < duration) {
      raf(frameFunc);
    } else if (typeof callback === 'function') {
      callback();
    }
  };

  raf(frameFunc);
}
//# sourceMappingURL=scrollTo.js.map
