import { Component, CSSProperties, ReactNode } from 'react';
import { DropDownProps } from '../dropdown';
import { ListProps } from '../list';
import ConfigContext, { ConfigContextValue } from '../config-provider/ConfigContext';
export interface Route {
    path: string;
    breadcrumbName: string;
}
export interface BreadcrumbProps {
    prefixCls?: string;
    routes?: Route[];
    params?: any;
    separator?: ReactNode;
    itemRender?: (route: any, params: any, routes: Array<any>, paths: Array<string>) => ReactNode;
    style?: CSSProperties;
    className?: string;
    dropdownProps?: Partial<DropDownProps>;
    listProps?: Partial<ListProps>;
}
export default class Breadcrumb extends Component<BreadcrumbProps, any> {
    static displayName: string;
    static get contextType(): typeof ConfigContext;
    static Item: any;
    static defaultProps: {
        separator: string;
    };
    context: ConfigContextValue;
    componentDidMount(): void;
    render(): JSX.Element;
}
