import { ColorCssVarsMap } from '../style/interface';
/**
 * css 变量 注册到 style 标签中
 * @param allCssVarsData css 变量对象(不加--前缀)
 * @param cssVarsPriority css 变量优先级
 * @param styleFlagPrefix style 标签 标识前缀
 */
export declare const registerCssVars: (allCssVarsData: Record<string, any>, cssVarsPriority?: number, styleFlagPrefix?: string) => void;
/**
 * 配置 css 变量
 * @param varsData css 变量对象(不加--前缀)
 * @param cssVarsPriority css 变量优先级
 * @param styleFlagPrefix style 标签 标识前缀
 * @param colorVarsMap 颜色 css vars 级联关系, 默认值为组件库内部变量关系
 */
declare const configCssVars: (varsData: Record<string, any>, cssVarsPriority?: number, styleFlagPrefix?: string, colorVarsMap?: ColorCssVarsMap[]) => void;
export { configCssVars };
