import { ColorCssVarsMap } from '../style/interface';
/**
 * 根据变量名获取变量值
 * @param value 变量名字符串或数组字符串
 * @returns 变量键值对
 */
export declare const getValueByCssVars: (value: string | string[]) => Record<string, any>;
/**
 * 获取颜色变量关系中有子级的父节点名
 * @param colorVarsMap 颜色变量关系
 * @param defaultParentNames
 * @returns
 */
export declare const findColorCssVarsParentNames: (colorVarsMap: ColorCssVarsMap[], defaultParentNames?: string[]) => string[];
/**
 * 根据 css 变量对象生成子级变量，包含自己
 * @param varsData css 变量对象(不加--前缀)
 * @param colorVarsMap 颜色 css vars 级联关系, 默认值为组件库内部变量关系
 * @returns
 */
export declare const getAllCssVars: (varsData: Record<string, any>, colorVarsMap?: ColorCssVarsMap[]) => Record<string, any>;
/**
 * 根据颜色变量关系，生成子级颜色，包含自己
 * @param parentVarName 当前变量名
 * @param color 当前变量对应颜色
 * @param colorVarsMap 颜色 css vars 级联关系, 默认值为组件库内部变量关系
 * @returns
 */
export declare const generateChildrenColor: (parentVarName: string, color: string, colorVarsMap?: ColorCssVarsMap[]) => Record<string, any>;
