import noop from 'lodash/noop';
import { LabelLayout, ShowValidation, LabelAlign } from '../../pro/es/form/enum';
import { ColumnAlign, TableQueryBarType, TableColumnResizeTriggerType } from '../../pro/es/table/enum';
import { ButtonColor, FuncType } from '../../pro/es/button/enum';
import { HighlightRenderer } from '../../pro/es/field/FormField';
import { ButtonProps } from '../../pro/es/button/Button';
import { ColumnProps } from '../../pro/es/table/Column';
import Field from '../../pro/es/data-set/Field';
import Record from '../../pro/es/data-set/Record';
import { ShowHelp } from '../../pro/es/field/enum';
import { FieldFocusMode } from '../../pro/es/core/enum';
import { Size } from '../_util/enum';
import { CustomizedLoad, CustomizedSave, renderEmptyHandler, TooltipThemeHook, LovShowSelectedInViewHook } from './index';
import { Action } from '../trigger/enum';
declare const defaults: {
    prefixCls: string;
    proPrefixCls: string;
    iconfontPrefix: string;
    ripple: boolean;
    collapseExpandIconPosition: string;
    collapseTrigger: string;
    lovTableProps: {};
    lovModalProps: {};
    lovAutoSelectSingle: boolean;
    lovShowSelectedInView: LovShowSelectedInViewHook;
    labelLayout: LabelLayout;
    labelAlign: LabelAlign;
    queryBar: TableQueryBarType;
    tableBorder: boolean;
    tableHighLightRow: boolean;
    tableSelectedHighLightRow: boolean;
    tableRowHeight: number;
    tableDefaultRenderer: string;
    tableColumnResizable: boolean;
    tableColumnHideable: boolean;
    performanceTableColumnHideable: boolean;
    tableRowDraggable: boolean;
    tableColumnDraggable: boolean;
    tableHeightChangeable: boolean;
    performanceTableColumnDraggable: boolean;
    tableColumnAlign: (_column: ColumnProps, field?: Field | undefined, record?: Record | undefined) => ColumnAlign | undefined;
    tableSpinProps: {
        size: Size;
        wrapperClassName: string;
    };
    tableButtonProps: ButtonProps;
    tableCommandProps: ButtonProps;
    tableAlwaysShowRowBox: boolean;
    tableUseMouseBatchChoose: boolean;
    tableEditorNextKeyEnterDown: boolean;
    tableAutoFocus: boolean;
    tableKeyboard: boolean;
    tableFilterSearchText: string;
    tableAutoHeightDiff: number;
    performanceTableAutoHeight: boolean;
    tableColumnDefaultWidth: number;
    tableColumnDefaultMinWidth: number;
    tableColumnResizeTrigger: TableColumnResizeTriggerType;
    tableAggregationColumnDefaultWidth: number;
    tableAggregationColumnDefaultMinWidth: number;
    customizedSave: CustomizedSave;
    customizedLoad: CustomizedLoad;
    tableShowRemovedRow: boolean;
    modalSectionBorder: boolean;
    drawerHeaderFooterCombined: boolean;
    drawerSectionBorder: boolean;
    drawerTransitionName: string;
    modalOkFirst: boolean;
    modalAutoCenter: boolean;
    modalKeyboard: boolean;
    modalMaskClosable: boolean;
    modalMovable: boolean;
    modalClosable: boolean;
    buttonColor: ButtonColor;
    buttonFuncType: FuncType;
    autoInsertSpaceInButton: boolean;
    renderEmpty: renderEmptyHandler;
    icons: {
        whatsNew: string[];
        direction: string[];
        suggestion: string[];
        edit: string[];
        data: string[];
        other: string[];
        series: string[];
    };
    dropdownMatchSelectWidth: boolean;
    defaultActiveFirstOption: boolean;
    selectReverse: boolean;
    selectPagingOptionContent: string;
    selectSearchable: boolean;
    selectBoxSearchable: boolean;
    selectReserveParam: boolean;
    selectTrigger: Action[];
    useColon: boolean;
    excludeUseColonTagList: string[];
    numberFieldNonStrictStep: boolean;
    showInvalidDate: boolean;
    highlightRenderer: HighlightRenderer;
    onPerformance: typeof noop;
    performanceEnabled: {
        Table: boolean;
    };
    tooltipTheme: TooltipThemeHook;
    showValidation: ShowValidation;
    showHelp: ShowHelp;
    numberFieldKeyboard: boolean;
    colorPreset: boolean;
    feedback: {
        loadSuccess(_result: any): void;
        loadFailed(error: any): void;
        submitSuccess(_result: any): void;
        submitFailed(error: any): void;
    };
    confirm: (message: any) => Promise<boolean>;
    validationMessageReportFormatter: (message: any) => Promise<string>;
    validationMessageFormatter: (message: any, injectOptions: any) => any;
    modalResizable: boolean;
    tableColumnResizeTransition: boolean;
    fieldFocusMode: FieldFocusMode;
    formAutoFocus: boolean;
};
export default defaults;
