import { HTMLAttributes, PureComponent } from 'react';
import { BreakpointMap } from '../responsive/Responsive';
import ConfigContext, { ConfigContextValue } from '../config-provider/ConfigContext';
export interface RowProps extends HTMLAttributes<HTMLDivElement> {
    gutter?: number | BreakpointMap;
    type?: 'flex';
    align?: 'top' | 'middle' | 'bottom';
    justify?: 'start' | 'end' | 'center' | 'space-around' | 'space-between';
    prefixCls?: string;
}
export default class Row extends PureComponent<RowProps> {
    static displayName: string;
    static get contextType(): typeof ConfigContext;
    static defaultProps: {
        gutter: number;
    };
    context: ConfigContextValue;
    renderRow: ([gutter]: [(number | undefined)?]) => JSX.Element;
    render(): JSX.Element;
}
