import React, { ForwardRefExoticComponent, PropsWithoutRef, RefAttributes } from 'react';
export interface IconBaseProps extends React.HTMLProps<HTMLSpanElement> {
    spin?: boolean;
    rotate?: number;
}
export interface CustomIconComponentProps {
    width: string | number;
    height: string | number;
    fill: string;
    viewBox?: string | undefined;
    className?: string;
    style?: React.CSSProperties | undefined;
}
export interface IconComponentProps extends IconBaseProps {
    viewBox?: string | undefined;
    component?: React.ComponentType<CustomIconComponentProps | React.SVGProps<SVGSVGElement>>;
    ariaLabel?: React.AriaAttributes['aria-label'];
}
export interface IIcon extends ForwardRefExoticComponent<PropsWithoutRef<IconComponentProps> & RefAttributes<HTMLSpanElement>> {
    __C7N_ICON?: boolean;
}
declare const Icon: IIcon;
export default Icon;
