import React, { CSSProperties, FunctionComponent, ReactNode } from 'react';
import { ListGridType } from './index';
export interface ListItemProps {
    className?: string;
    children?: ReactNode;
    prefixCls?: string;
    style?: CSSProperties;
    extra?: ReactNode;
    actions?: Array<ReactNode>;
    grid?: ListGridType;
    renderCheckBox?: {
        element: () => HTMLElement;
        isChecked: boolean;
    };
}
export interface ListItemMetaProps {
    avatar?: ReactNode;
    className?: string;
    children?: ReactNode;
    description?: ReactNode;
    prefixCls?: string;
    style?: CSSProperties;
    title?: ReactNode;
}
export declare const Meta: React.NamedExoticComponent<ListItemMetaProps>;
declare const ListItem: FunctionComponent<ListItemProps>;
export declare type ListItemComponent = typeof ListItem & {
    Meta: typeof Meta;
};
declare const _default: ListItemComponent;
export default _default;
