import React, { memo, useMemo } from 'react';
import { getContext, Symbols } from 'choerodon-ui/shared';
var MenuContext = getContext(Symbols.MenuContext, {});

var BaseMenuContextProvider = function MenuContextProvider(props) {
  var children = props.children,
      inlineCollapsed = props.inlineCollapsed,
      menuTheme = props.menuTheme;
  var value = useMemo(function () {
    return {
      inlineCollapsed: inlineCollapsed,
      menuTheme: menuTheme
    };
  }, [inlineCollapsed, menuTheme]);
  return /*#__PURE__*/React.createElement(MenuContext.Provider, {
    value: value
  }, children);
};

BaseMenuContextProvider.displayName = 'MenuContextProvider';
export var MenuContextProvider = /*#__PURE__*/memo(BaseMenuContextProvider);
export default MenuContext;
//# sourceMappingURL=MenuContext.js.map
