import _extends from "@babel/runtime/helpers/extends";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _inherits from "@babel/runtime/helpers/inherits";
import _createSuper from "@babel/runtime/helpers/createSuper";
import React, { PureComponent } from 'react';
import Tooltip from '../tooltip';
import { Item } from '../rc-components/menu';
import MenuContext from './MenuContext';

var MenuItem = /*#__PURE__*/function (_PureComponent) {
  _inherits(MenuItem, _PureComponent);

  var _super = _createSuper(MenuItem);

  function MenuItem() {
    var _this;

    _classCallCheck(this, MenuItem);

    _this = _super.apply(this, arguments);

    _this.onKeyDown = function (e) {
      _this.menuItem.onKeyDown(e);
    };

    _this.saveMenuItem = function (menuItem) {
      _this.menuItem = menuItem;
    };

    return _this;
  }

  _createClass(MenuItem, [{
    key: "render",
    value: function render() {
      var inlineCollapsed = this.context.inlineCollapsed;
      var props = this.props;
      var item = /*#__PURE__*/React.createElement(Item, _extends({}, props, {
        ref: this.saveMenuItem
      }));

      if (inlineCollapsed && props.level === 1) {
        return /*#__PURE__*/React.createElement(Tooltip, {
          prefixCls: props.tooltipPrefixCls,
          title: props.children,
          placement: "right",
          overlayClassName: "".concat(props.rootPrefixCls, "-inline-collapsed-tooltip")
        }, item);
      }

      return item;
    }
  }], [{
    key: "contextType",
    get: function get() {
      return MenuContext;
    }
  }]);

  return MenuItem;
}(PureComponent);

MenuItem.isMenuItem = 1;
export default MenuItem;
//# sourceMappingURL=MenuItem.js.map
