import { Component, ReactNode } from 'react';
import { ButtonType, ButtonProps } from '../button/Button';
export interface CommonButtonProps {
    type?: ButtonType;
    actionFn?: (...args: any[]) => any | PromiseLike<any>;
    closeModal: Function;
    text?: ReactNode;
    buttonProps?: ButtonProps;
}
export interface ActionButtonProps {
    okProps: CommonButtonProps;
    cancelProps?: CommonButtonProps;
    autoFocus?: boolean;
}
export interface ActionButtonState {
    loading: boolean;
}
export default class ActionButton extends Component<ActionButtonProps, ActionButtonState> {
    timeoutId: number;
    constructor(props: ActionButtonProps);
    componentDidMount(): void;
    componentWillUnmount(): void;
    onClick: (props: CommonButtonProps) => void;
    render(): JSX.Element;
}
