import { Component } from 'react';
import { ModalFuncProps } from './Modal';
import ConfigContext, { ConfigContextValue } from '../config-provider/ConfigContext';
export interface SidebarState {
    open: boolean;
}
export interface SidebarProps extends ModalFuncProps {
    close?: (...args: any[]) => void;
    alwaysCanCancel?: boolean;
}
export default class Sidebar extends Component<SidebarProps, {}> {
    static displayName: string;
    static get contextType(): typeof ConfigContext;
    static defaultProps: {
        width: string;
        transitionName: string;
        maskTransitionName: string;
        confirmLoading: boolean;
        alwaysCanCancel: boolean;
        visible: boolean;
        okType: string;
        funcType: string;
    };
    context: ConfigContextValue;
    state: SidebarState;
    constructor(props: any, context: ConfigContextValue);
    handleCancel: (e: any) => void;
    handleOk: (e: any) => void;
    renderFooter: () => JSX.Element;
    handleStatus: () => void;
    getPrefixCls(): string;
    render(): JSX.Element;
}
