import { Component, ReactNode } from 'react';
import { AbstractTooltipProps, RenderFunction } from '../tooltip';
import ConfigContext, { ConfigContextValue } from '../config-provider/ConfigContext';
export interface PopoverProps extends AbstractTooltipProps {
    title?: ReactNode;
    content?: ReactNode | RenderFunction;
}
export default class Popover extends Component<PopoverProps, {}> {
    static displayName: string;
    static get contextType(): typeof ConfigContext;
    static defaultProps: {
        placement: string;
        transitionName: string;
        trigger: string;
        mouseEnterDelay: number;
        mouseLeaveDelay: number;
        overlayStyle: {};
    };
    context: ConfigContextValue;
    private tooltip;
    getPopupDomNode(): any;
    getOverlay: () => JSX.Element;
    saveTooltip: (node: any) => void;
    getPrefixCls(): string;
    render(): JSX.Element;
}
