import React, { memo, useMemo } from 'react';
import { getContext, Symbols } from 'choerodon-ui/shared';
import { getPrefixCls } from '../configure/utils';
var RadioContext = getContext(Symbols.RadioContext, {
  getPrefixCls: getPrefixCls
});

var BaseRadioContextProvider = function RadioContextProvider(props) {
  var children = props.children,
      radioGroup = props.radioGroup,
      getGlobalPrefixCls = props.getPrefixCls;
  var value = useMemo(function () {
    return {
      radioGroup: radioGroup,
      getPrefixCls: getGlobalPrefixCls
    };
  }, [getGlobalPrefixCls, radioGroup]);
  return /*#__PURE__*/React.createElement(RadioContext.Provider, {
    value: value
  }, children);
};

BaseRadioContextProvider.displayName = 'RadioContextProvider';
export var RadioContextProvider = /*#__PURE__*/memo(BaseRadioContextProvider);
export default RadioContext;
//# sourceMappingURL=RadioContext.js.map
