import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["prefixCls", "disabled", "onTouchStart", "onTouchEnd", "onMouseDown", "onMouseUp", "onMouseLeave"];
import React from 'react';
import Touchable from 'rmc-feedback';

var InputHandler = function InputHandler(props) {
  var prefixCls = props.prefixCls,
      disabled = props.disabled,
      onTouchStart = props.onTouchStart,
      onTouchEnd = props.onTouchEnd,
      onMouseDown = props.onMouseDown,
      onMouseUp = props.onMouseUp,
      onMouseLeave = props.onMouseLeave,
      otherProps = _objectWithoutProperties(props, _excluded);

  return /*#__PURE__*/React.createElement(Touchable, {
    disabled: disabled,
    onTouchStart: onTouchStart,
    onTouchEnd: onTouchEnd,
    onMouseDown: onMouseDown,
    onMouseUp: onMouseUp,
    onMouseLeave: onMouseLeave,
    activeClassName: "".concat(prefixCls, "-handler-active")
  }, /*#__PURE__*/React.createElement("span", otherProps));
};

InputHandler.displayName = 'RcInputHandler';
export default InputHandler;
//# sourceMappingURL=InputHandler.js.map
