import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _typeof from "@babel/runtime/helpers/typeof";
import React, { isValidElement, createRef, useEffect, useRef } from 'react';
import measureTextWidth from '../../../../pro/es/_util/measureTextWidth';
import classNames from 'classnames';

var Marks = function Marks(_ref) {
  var className = _ref.className,
      vertical = _ref.vertical,
      marks = _ref.marks,
      included = _ref.included,
      upperBound = _ref.upperBound,
      lowerBound = _ref.lowerBound,
      max = _ref.max,
      min = _ref.min,
      onClickLabel = _ref.onClickLabel;
  var marksKeys = Object.keys(marks);
  var range = max - min;
  var listRef = useRef([]);
  useEffect(function () {
    // 解决相邻 mark 重叠问题。
    var markCurrents = listRef.current;

    for (var i = 0; i < markCurrents.length; i++) {
      var currentParent = markCurrents[i].current;
      var currentParentChild = currentParent.firstChild;

      if (i > 0) {
        // 从第二个 mark 开始判断
        var prevParent = markCurrents[i - 1].current;
        var prevChild = prevParent.firstChild;

        if (!vertical) {
          var pevlength = prevParent.offsetLeft + prevChild.offsetLeft + prevChild.offsetWidth;

          if (currentParent.offsetLeft + currentParentChild.offsetLeft < pevlength && !prevParent.style.top) {
            currentParent.style.top = '-40px';
          }
        } else {
          var pevHeight = prevParent.offsetTop;

          if (currentParent.offsetTop + currentParent.offsetHeight > pevHeight && !prevParent.style.left) {
            currentParent.style.left = "".concat(-(currentParent.offsetWidth + 15), "px");
          }
        }
      }
    }
  }, []);
  var elements = marksKeys.map(parseFloat).sort(function (a, b) {
    return a - b;
  }).map(function (point, index) {
    var _classNames;

    var markPoint = marks[point];
    var markPointIsObject = _typeof(markPoint) === 'object' && ! /*#__PURE__*/isValidElement(markPoint);
    var markLabel = markPointIsObject ? markPoint.label : markPoint;

    if (!markLabel && markLabel !== 0) {
      return null;
    }

    var isActive = !included && point === upperBound || included && point <= upperBound && point >= lowerBound;
    var markClassName = classNames((_classNames = {}, _defineProperty(_classNames, "".concat(className, "-text"), true), _defineProperty(_classNames, "".concat(className, "-text-active"), isActive), _classNames));
    var bottomStyle = {
      marginBottom: '-50%',
      bottom: "".concat((point - min) / range * 100, "%")
    };
    var markWidth = typeof markLabel === 'string' ? measureTextWidth(markLabel) : 0;
    var leftStyle = {
      marginLeft: "".concat(-markWidth / 2, "px"),
      left: "".concat((point - min) / range * 100, "%")
    };
    var style = vertical ? bottomStyle : leftStyle;
    var markStyle = markPointIsObject ? _objectSpread(_objectSpread({}, style), markPoint.style) : style;
    var ref = /*#__PURE__*/createRef();
    listRef.current.push(ref);
    return /*#__PURE__*/React.createElement("span", {
      ref: ref,
      className: markClassName,
      style: markStyle,
      key: point,
      onMouseDown: function onMouseDown(e) {
        return onClickLabel(e, point);
      },
      onTouchStart: function onTouchStart(e) {
        return onClickLabel(e, point);
      }
    }, /*#__PURE__*/React.createElement("span", null, markLabel));
  });
  return /*#__PURE__*/React.createElement("div", {
    className: className
  }, elements);
};

export default Marks;
//# sourceMappingURL=Marks.js.map
