import React from 'react';
export default function DropIndicator(_ref) {
  var prefixCls = _ref.prefixCls,
      dropPosition = _ref.dropPosition,
      dropLevelOffset = _ref.dropLevelOffset,
      indent = _ref.indent;
  var style = {
    pointerEvents: 'none',
    position: 'absolute',
    right: 0,
    height: 2
  };

  switch (dropPosition) {
    case -1:
      style.top = 0;
      style.left = -dropLevelOffset * indent;
      break;

    case 1:
      style.bottom = 0;
      style.left = -dropLevelOffset * indent;
      break;

    case 0:
      style.bottom = 0;
      style.left = indent;
      break;

    default:
  }

  return /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-drop-indicator"),
    style: style
  });
}
//# sourceMappingURL=DropIndicator.js.map
