import React from 'react';
import { TreeNodeProps } from './TreeNode';
import { FlattenNode } from './interface';
import { TreeNodeRequiredProps } from './utils/treeUtil';
export interface MotionTreeNodeProps extends Omit<TreeNodeProps, 'domRef'> {
    active: boolean;
    motion?: any;
    motionNodes?: FlattenNode[] | null;
    onMotionStart: () => void;
    onMotionEnd: () => void;
    motionType?: 'show' | 'hide' | null;
    treeNodeRequiredProps: TreeNodeRequiredProps;
}
declare const RefMotionTreeNode: React.ForwardRefExoticComponent<Pick<MotionTreeNodeProps, string | number> & React.RefAttributes<HTMLDivElement>>;
export default RefMotionTreeNode;
