import * as React from 'react';
import { SkeletonTitleProps } from './Title';
import { SkeletonGridProps } from './Grid';
import { SkeletonParagraphProps } from './Paragraph';
import SkeletonButton from './Button';
import SkeletonAvatar, { AvatarProps } from './Avatar';
import SkeletonInput from './Input';
import ConfigContext, { ConfigContextValue } from '../config-provider/ConfigContext';
declare type SkeletonAvatarProps = Omit<AvatarProps, 'active'>;
export interface SkeletonProps {
    active?: boolean;
    loading?: boolean;
    prefixCls?: string;
    className?: string;
    children?: React.ReactNode;
    avatar?: SkeletonAvatarProps | boolean;
    title?: SkeletonTitleProps | boolean;
    paragraph?: SkeletonParagraphProps | boolean;
    grid?: SkeletonGridProps;
}
declare class Skeleton extends React.Component<SkeletonProps, any> {
    static get contextType(): typeof ConfigContext;
    static Button: typeof SkeletonButton;
    static Avatar: typeof SkeletonAvatar;
    static Input: typeof SkeletonInput;
    static defaultProps: Partial<SkeletonProps>;
    context: ConfigContextValue;
    renderSkeleton: () => {} | null | undefined;
    render(): JSX.Element;
}
export default Skeleton;
