import _extends from "@babel/runtime/helpers/extends";
import React, { useContext } from 'react';
import RcSteps, { Step, StepGroup } from '../rc-components/steps';
import ConfigContext from '../config-provider/ConfigContext';

var Steps = function Steps(props) {
  var customizePrefixCls = props.prefixCls;

  var _useContext = useContext(ConfigContext),
      getPrefixCls = _useContext.getPrefixCls;

  var prefixCls = getPrefixCls('steps', customizePrefixCls);
  return /*#__PURE__*/React.createElement(RcSteps, _extends({}, props, {
    prefixCls: prefixCls
  }));
};

Steps.displayName = 'Steps';
Steps.Step = Step;
Steps.StepGroup = StepGroup;
Steps.defaultProps = {
  iconPrefix: 'icon',
  current: 0
};
export default Steps;
//# sourceMappingURL=index.js.map
