import React from 'react';
import FilterSelect from './FilterSelect';
import ColumnFilter from './ColumnFilter';
export default function FilterBar(props) {
  var prefixCls = props.prefixCls,
      columns = props.columns,
      onColumnFilterChange = props.onColumnFilterChange,
      onFilterSelectChange = props.onFilterSelectChange,
      onFilterSelectClear = props.onFilterSelectClear,
      onFilter = props.onFilter,
      dataSource = props.dataSource,
      filters = props.filters,
      columnFilters = props.columnFilters,
      placeholder = props.placeholder,
      multiple = props.multiple,
      getPopupContainer = props.getPopupContainer;
  return /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-filter-bar")
  }, /*#__PURE__*/React.createElement(FilterSelect, {
    prefixCls: prefixCls,
    placeholder: placeholder,
    columns: columns,
    dataSource: dataSource,
    onChange: onFilterSelectChange,
    onClear: onFilterSelectClear,
    onFilter: onFilter,
    filters: filters,
    columnFilters: columnFilters,
    getPopupContainer: getPopupContainer,
    multiple: multiple
  }), /*#__PURE__*/React.createElement(ColumnFilter, {
    prefixCls: prefixCls,
    columns: columns,
    onColumnFilterChange: onColumnFilterChange,
    getPopupContainer: getPopupContainer
  }));
}
//# sourceMappingURL=FilterBar.js.map
