import _defineProperty from "@babel/runtime/helpers/defineProperty";
import React from 'react';
import noop from 'lodash/noop';
import classNames from 'classnames';
import Button from '../button';
import { Size } from '../_util/enum';

var SortButton = function SortButton(props) {
  var _props$moveToUp = props.moveToUp,
      moveToUp = _props$moveToUp === void 0 ? noop : _props$moveToUp,
      _props$moveToDown = props.moveToDown,
      moveToDown = _props$moveToDown === void 0 ? noop : _props$moveToDown,
      _props$upArrowText = props.upArrowText,
      upArrowText = _props$upArrowText === void 0 ? '' : _props$upArrowText,
      _props$downArrowText = props.downArrowText,
      downArrowText = _props$downArrowText === void 0 ? '' : _props$downArrowText,
      upActive = props.upActive,
      downActive = props.downActive,
      className = props.className;
  var customUpClass = classNames("".concat(className, "-custom-up-active"), _defineProperty({}, "".concat(className, "-custom-up-disable"), !upActive));
  var customDownClass = classNames("".concat(className, "-custom-down-active"), _defineProperty({}, "".concat(className, "-custom-down-disable"), !downActive));
  return /*#__PURE__*/React.createElement("div", {
    className: className
  }, typeof upArrowText === 'string' ? /*#__PURE__*/React.createElement(Button, {
    type: "primary",
    size: Size.small,
    disabled: !upActive,
    onClick: moveToUp,
    icon: "keyboard_arrow_up"
  }, upArrowText) : /*#__PURE__*/React.createElement("div", {
    className: customUpClass,
    onClick: upActive ? moveToUp : undefined
  }, upArrowText), typeof downArrowText === 'string' ? /*#__PURE__*/React.createElement(Button, {
    type: "primary",
    size: Size.small,
    disabled: !downActive,
    onClick: moveToDown,
    icon: "keyboard_arrow_down"
  }, downArrowText) : /*#__PURE__*/React.createElement("div", {
    className: customDownClass,
    onClick: downActive ? moveToDown : undefined
  }, downArrowText));
};

export default SortButton;
//# sourceMappingURL=SortButton.js.map
