import _extends from "@babel/runtime/helpers/extends";
import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _inherits from "@babel/runtime/helpers/inherits";
import _createSuper from "@babel/runtime/helpers/createSuper";
import React, { Component } from 'react';
import classNames from 'classnames';
import Lazyload from 'react-lazy-load';
import Checkbox from '../checkbox';
import PureRenderMixin from '../rc-components/util/PureRenderMixin';

var Item = /*#__PURE__*/function (_Component) {
  _inherits(Item, _Component);

  var _super = _createSuper(Item);

  function Item() {
    _classCallCheck(this, Item);

    return _super.apply(this, arguments);
  }

  _createClass(Item, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate() {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return PureRenderMixin.shouldComponentUpdate.apply(this, args);
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames;

      var _this$props = this.props,
          renderedText = _this$props.renderedText,
          renderedEl = _this$props.renderedEl,
          item = _this$props.item,
          lazy = _this$props.lazy,
          checked = _this$props.checked,
          isHighlight = _this$props.isHighlight,
          prefixCls = _this$props.prefixCls,
          onClick = _this$props.onClick,
          checkboxPrefixCls = _this$props.checkboxPrefixCls;
      var className = classNames((_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-content-item"), true), _defineProperty(_classNames, "".concat(prefixCls, "-content-item-disabled"), item.disabled), _defineProperty(_classNames, "".concat(prefixCls, "-content-item-highlight"), isHighlight), _classNames));
      var listItem = /*#__PURE__*/React.createElement("li", {
        className: className,
        title: renderedText,
        onClick: item.disabled ? undefined : function () {
          return onClick(item);
        }
      }, /*#__PURE__*/React.createElement(Checkbox, {
        prefixCls: checkboxPrefixCls,
        checked: checked,
        disabled: item.disabled
      }), /*#__PURE__*/React.createElement("span", null, renderedEl));
      var children = null;

      if (lazy) {
        var lazyProps = _objectSpread({
          height: 32,
          offset: 500,
          throttle: 0,
          debounce: false
        }, lazy);

        children = /*#__PURE__*/React.createElement(Lazyload, _extends({}, lazyProps), listItem);
      } else {
        children = listItem;
      }

      return children;
    }
  }]);

  return Item;
}(Component);

export { Item as default };
//# sourceMappingURL=item.js.map
