import React, { Component } from 'react';
import { UploadFile, UploadListProps } from './interface';
import { previewImage } from './utils';
import ConfigContext, { ConfigContextValue } from '../config-provider/ConfigContext';
export default class UploadList extends Component<UploadListProps, any> {
    static displayName: string;
    static get contextType(): typeof ConfigContext;
    static defaultProps: {
        listType: string;
        progressAttr: {
            strokeWidth: number;
            showInfo: boolean;
        };
        previewFile: typeof previewImage;
        showRemoveIcon: boolean;
        showPreviewIcon: boolean;
        dragUploadList: boolean;
        showFileSize: boolean;
        showDownloadIcon: boolean;
        showReUploadIcon: boolean;
        downloadPropsIntercept: (o: any) => any;
    };
    context: ConfigContextValue;
    handleClose: (file: UploadFile) => void;
    handlePreview: (file: UploadFile, e: React.SyntheticEvent<HTMLElement, Event>) => void;
    /**
     * @param {UploadFile} file
     * @param {React.SyntheticEvent<HTMLElement>} e
     */
    handleReUpload: (file: UploadFile, e: React.SyntheticEvent<HTMLElement, Event>) => void;
    handleReUploadConfirm: (fileTarget: UploadFile, e: React.SyntheticEvent<HTMLElement, Event>) => void;
    componentDidUpdate(): void;
    /**
     * 拖拽事件
     * @param result
     */
    onDragEnd: (result: any) => void;
    render(): JSX.Element;
}
