"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _shared = require("choerodon-ui/shared");

function isCssAnimationSupported() {
  var CSS_ANIMATION_SUPPORT = _shared.global.CSS_ANIMATION_SUPPORT;

  if (CSS_ANIMATION_SUPPORT !== undefined) {
    return CSS_ANIMATION_SUPPORT;
  }

  if (typeof window !== 'undefined') {
    var domPrefixes = ['webkit', 'moz', 'O', 'ms', 'khtml'];
    var elmStyle = document.createElement('div').style;
    var support = elmStyle.animationName !== undefined || domPrefixes.some(function (prefix) {
      return elmStyle["".concat(prefix, "AnimationName")] !== undefined;
    });
    _shared.global.CSS_ANIMATION_SUPPORT = support;
    return support;
  }

  return false;
}

var _default = isCssAnimationSupported;
exports["default"] = _default;
//# sourceMappingURL=isCssAnimationSupported.js.map
