"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = isFlexSupported;

var _shared = require("choerodon-ui/shared");

function isFlexSupported() {
  var FLEX_SUPPORT = _shared.global.FLEX_SUPPORT;

  if (FLEX_SUPPORT !== undefined) {
    return FLEX_SUPPORT;
  }

  if (typeof window !== 'undefined' && window.document && window.document.documentElement) {
    var documentElement = window.document.documentElement;
    var support = 'flex' in documentElement.style || 'webkitFlex' in documentElement.style || 'Flex' in documentElement.style || 'msFlex' in documentElement.style;
    _shared.global.FLEX_SUPPORT = support;
    return support;
  }

  return false;
}
//# sourceMappingURL=isFlexSupported.js.map
