"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard")["default"];

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var _react = _interopRequireWildcard(require("react"));

var _reactDom = require("react-dom");

var _classnames = _interopRequireDefault(require("classnames"));

var _icon = _interopRequireDefault(require("../icon"));

var _animate = _interopRequireDefault(require("../animate"));

var _getDataOrAriaProps = _interopRequireDefault(require("../_util/getDataOrAriaProps"));

var _ConfigContext = _interopRequireDefault(require("../config-provider/ConfigContext"));

var Alert = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2["default"])(Alert, _PureComponent);

  var _super = (0, _createSuper2["default"])(Alert);

  function Alert() {
    var _this;

    (0, _classCallCheck2["default"])(this, Alert);
    _this = _super.apply(this, arguments);
    _this.state = {
      closing: true,
      closed: false
    };

    _this.handleClose = function (e) {
      e.preventDefault();
      var dom = (0, _reactDom.findDOMNode)((0, _assertThisInitialized2["default"])(_this));
      dom.style.height = "".concat(dom.offsetHeight, "px"); // Magic code
      // 重复一次后才能正确设置 height

      dom.style.height = "".concat(dom.offsetHeight, "px");

      _this.setState({
        closing: false
      });

      var onClose = _this.props.onClose;

      if (onClose) {
        onClose(e);
      }
    };

    _this.animationEnd = function () {
      _this.setState({
        closed: true,
        closing: true
      });

      var afterClose = _this.props.afterClose;

      if (afterClose) {
        afterClose();
      }
    };

    return _this;
  }

  (0, _createClass2["default"])(Alert, [{
    key: "render",
    value: function render() {
      var _classNames;

      var props = this.props;
      var iconOutline = props.iconOutline,
          description = props.description,
          customizePrefixCls = props.prefixCls,
          message = props.message,
          closeText = props.closeText,
          banner = props.banner,
          _props$className = props.className,
          className = _props$className === void 0 ? '' : _props$className,
          style = props.style;
      var closable = props.closable,
          showIcon = props.showIcon,
          type = props.type,
          iconType = props.iconType;
      var _this$state = this.state,
          closing = _this$state.closing,
          closed = _this$state.closed;
      var getPrefixCls = this.context.getPrefixCls;
      var prefixCls = getPrefixCls('alert', customizePrefixCls); // banner模式默认有 Icon

      showIcon = banner && showIcon === undefined ? true : showIcon; // banner模式默认为警告

      type = banner && type === undefined ? 'warning' : type || 'info';

      if (!iconType) {
        // use outline icon in alert with description
        if (iconOutline) {
          switch (type) {
            case 'success':
              iconType = 'check_circle_outline-o';
              break;

            case 'info':
              iconType = 'info-o';
              break;

            case 'error':
              iconType = 'error_outline';
              break;

            case 'warning':
              iconType = 'warning_amber-o-2';
              break;

            default:
              iconType = 'default';
          }
        } else {
          switch (type) {
            case 'success':
              iconType = 'check_circle';
              break;

            case 'info':
              iconType = 'info';
              break;

            case 'error':
              iconType = 'error';
              break;

            case 'warning':
              iconType = 'warning';
              break;

            default:
              iconType = 'default';
          }
        }
      }

      var alertCls = (0, _classnames["default"])(prefixCls, (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-").concat(type), true), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-close"), !closing), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-with-description"), !!description), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-no-icon"), !showIcon), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-banner"), !!banner), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-closable"), closable || closeText), _classNames), className); // closeable when closeText is assigned

      if (closeText) {
        closable = true;
      }

      var closeIcon = closable ? /*#__PURE__*/_react["default"].createElement("button", {
        type: "button",
        className: "".concat(prefixCls, "-close-wrapper")
      }, /*#__PURE__*/_react["default"].createElement("a", {
        onClick: this.handleClose,
        className: "".concat(prefixCls, "-close-icon")
      }, closeText || /*#__PURE__*/_react["default"].createElement(_icon["default"], {
        type: "close"
      }))) : null;
      var dataOrAriaProps = (0, _getDataOrAriaProps["default"])(this.props);
      return closed ? null : /*#__PURE__*/_react["default"].createElement(_animate["default"], {
        component: "",
        hiddenProp: "hidden",
        transitionName: "".concat(prefixCls, "-slide-up"),
        onEnd: this.animationEnd
      }, /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
        hidden: !closing,
        className: alertCls,
        style: style
      }, dataOrAriaProps), showIcon ? /*#__PURE__*/_react["default"].createElement(_icon["default"], {
        className: "".concat(prefixCls, "-icon"),
        type: iconType
      }) : null, /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-content")
      }, /*#__PURE__*/_react["default"].createElement("span", {
        className: "".concat(prefixCls, "-message")
      }, message), /*#__PURE__*/_react["default"].createElement("span", {
        className: "".concat(prefixCls, "-description")
      }, description)), closeIcon));
    }
  }], [{
    key: "contextType",
    get: function get() {
      return _ConfigContext["default"];
    }
  }]);
  return Alert;
}(_react.PureComponent);

exports["default"] = Alert;
Alert.displayName = 'Alert';
//# sourceMappingURL=index.js.map
