"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.AnchorContextProvider = void 0;

var _react = _interopRequireWildcard(require("react"));

var _shared = require("choerodon-ui/shared");

var _utils = require("../configure/utils");

var AnchorContext = (0, _shared.getContext)(_shared.Symbols.AnchorContext, {
  getPrefixCls: _utils.getPrefixCls
});

var BaseAnchorContextProvider = function AnchorContextProvider(props) {
  var children = props.children,
      c7nAnchor = props.c7nAnchor,
      getGlobalPrefixCls = props.getPrefixCls;
  var value = (0, _react.useMemo)(function () {
    return {
      c7nAnchor: c7nAnchor,
      getPrefixCls: getGlobalPrefixCls
    };
  }, [getGlobalPrefixCls, c7nAnchor]);
  return /*#__PURE__*/_react["default"].createElement(AnchorContext.Provider, {
    value: value
  }, children);
};

BaseAnchorContextProvider.displayName = 'AnchorContextProvider';
var AnchorContextProvider = /*#__PURE__*/(0, _react.memo)(BaseAnchorContextProvider);
exports.AnchorContextProvider = AnchorContextProvider;
var _default = AnchorContext;
exports["default"] = _default;
//# sourceMappingURL=AnchorContext.js.map
