import * as React from 'react';
import ConfigContext, { ConfigContextValue } from '../config-provider/ConfigContext';
import { Size } from '../_util/enum';
export interface GroupProps {
    className?: string;
    children?: React.ReactNode;
    style?: React.CSSProperties;
    prefixCls?: string;
    maxCount?: number;
    maxStyle?: React.CSSProperties;
    maxPopoverPlacement?: 'top' | 'bottom';
    maxPopoverTrigger?: 'hover' | 'focus' | 'click';
    size?: Size | number;
}
export default class Group extends React.Component<GroupProps> {
    static displayName: string;
    static get contextType(): typeof ConfigContext;
    static defaultProps: {
        size: Size;
        maxPopoverPlacement: string;
        maxPopoverTrigger: string;
        className: string;
    };
    context: ConfigContextValue;
    render(): JSX.Element;
}
