"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.CheckboxContextProvider = void 0;

var _react = _interopRequireWildcard(require("react"));

var _shared = require("choerodon-ui/shared");

var _utils = require("../configure/utils");

var CheckboxContext = (0, _shared.getContext)(_shared.Symbols.CheckboxContext, {
  getPrefixCls: _utils.getPrefixCls
});

var BaseCheckboxContextProvider = function CheckboxContextProvider(props) {
  var children = props.children,
      checkboxGroup = props.checkboxGroup,
      getGlobalPrefixCls = props.getPrefixCls;
  var value = (0, _react.useMemo)(function () {
    return {
      checkboxGroup: checkboxGroup,
      getPrefixCls: getGlobalPrefixCls
    };
  }, [getGlobalPrefixCls, checkboxGroup]);
  return /*#__PURE__*/_react["default"].createElement(CheckboxContext.Provider, {
    value: value
  }, children);
};

BaseCheckboxContextProvider.displayName = 'CheckboxContextProvider';
var CheckboxContextProvider = /*#__PURE__*/(0, _react.memo)(BaseCheckboxContextProvider);
exports.CheckboxContextProvider = CheckboxContextProvider;
var _default = CheckboxContext;
exports["default"] = _default;
//# sourceMappingURL=CheckboxContext.js.map
