"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _IconFont = _interopRequireDefault(require("./IconFont"));

var _ConfigContext = _interopRequireDefault(require("../config-provider/ConfigContext"));

var _excluded = ["type", "customFontName", "height", "width", "className", "scriptUrl"];

var Icon = function Icon(props) {
  var _useContext = (0, _react.useContext)(_ConfigContext["default"]),
      getConfig = _useContext.getConfig;

  var iconfontPrefix = getConfig('iconfontPrefix');
  var type = props.type,
      customFontName = props.customFontName,
      height = props.height,
      width = props.width,
      _props$className = props.className,
      className = _props$className === void 0 ? '' : _props$className,
      scriptUrl = props.scriptUrl,
      otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var classString = (0, _classnames["default"])(iconfontPrefix, customFontName, "".concat(iconfontPrefix, "-").concat(type), className);

  if (scriptUrl && typeof document !== 'undefined' && typeof window !== 'undefined' && typeof document.createElement === 'function') {
    var SvgIcon = (0, _IconFont["default"])({
      scriptUrl: scriptUrl
    });

    if (SvgIcon) {
      return /*#__PURE__*/_react["default"].createElement(SvgIcon, {
        type: type,
        width: width,
        height: height
      });
    }
  }

  return /*#__PURE__*/_react["default"].createElement("i", (0, _extends2["default"])({}, otherProps, {
    className: classString
  }));
};

Icon.displayName = 'Icon';
Icon.createFromIconfontCN = _IconFont["default"];
Icon.__C7N_ICON = true;
var _default = Icon;
exports["default"] = _default;
//# sourceMappingURL=index.js.map
