"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.MenuContextProvider = void 0;

var _react = _interopRequireWildcard(require("react"));

var _shared = require("choerodon-ui/shared");

var MenuContext = (0, _shared.getContext)(_shared.Symbols.MenuContext, {});

var BaseMenuContextProvider = function MenuContextProvider(props) {
  var children = props.children,
      inlineCollapsed = props.inlineCollapsed,
      menuTheme = props.menuTheme;
  var value = (0, _react.useMemo)(function () {
    return {
      inlineCollapsed: inlineCollapsed,
      menuTheme: menuTheme
    };
  }, [inlineCollapsed, menuTheme]);
  return /*#__PURE__*/_react["default"].createElement(MenuContext.Provider, {
    value: value
  }, children);
};

BaseMenuContextProvider.displayName = 'MenuContextProvider';
var MenuContextProvider = /*#__PURE__*/(0, _react.memo)(BaseMenuContextProvider);
exports.MenuContextProvider = MenuContextProvider;
var _default = MenuContext;
exports["default"] = _default;
//# sourceMappingURL=MenuContext.js.map
