import React from 'react';
import { MessagePlacement, ConfigProps } from 'choerodon-ui/shared/message-manager';
export declare type ConfigOnClose = (() => void) | MessagePlacement;
export interface ThenableArgument {
    (_: any): any;
}
export interface MessageType {
    (): void;
    then: (fill: ThenableArgument, reject: ThenableArgument) => Promise<any>;
    promise: Promise<any>;
}
export declare type ConfigOptions = Partial<ConfigProps> & {
    icons?: Partial<ConfigProps['icons']>;
};
declare const _default: {
    info(content: React.ReactNode, duration?: number | "left" | "right" | "top" | "bottom" | "topLeft" | "topRight" | "bottomLeft" | "bottomRight" | "rightTop" | "leftTop" | "rightBottom" | "leftBottom" | (() => void) | undefined, onClose?: "left" | "right" | "top" | "bottom" | "topLeft" | "topRight" | "bottomLeft" | "bottomRight" | "rightTop" | "leftTop" | "rightBottom" | "leftBottom" | (() => void) | undefined, placement?: "left" | "right" | "top" | "bottom" | "topLeft" | "topRight" | "bottomLeft" | "bottomRight" | "rightTop" | "leftTop" | "rightBottom" | "leftBottom" | undefined): MessageType;
    success(content: React.ReactNode, duration?: number | "left" | "right" | "top" | "bottom" | "topLeft" | "topRight" | "bottomLeft" | "bottomRight" | "rightTop" | "leftTop" | "rightBottom" | "leftBottom" | (() => void) | undefined, onClose?: "left" | "right" | "top" | "bottom" | "topLeft" | "topRight" | "bottomLeft" | "bottomRight" | "rightTop" | "leftTop" | "rightBottom" | "leftBottom" | (() => void) | undefined, placement?: "left" | "right" | "top" | "bottom" | "topLeft" | "topRight" | "bottomLeft" | "bottomRight" | "rightTop" | "leftTop" | "rightBottom" | "leftBottom" | undefined): MessageType;
    error(content: React.ReactNode, duration?: number | "left" | "right" | "top" | "bottom" | "topLeft" | "topRight" | "bottomLeft" | "bottomRight" | "rightTop" | "leftTop" | "rightBottom" | "leftBottom" | (() => void) | undefined, onClose?: "left" | "right" | "top" | "bottom" | "topLeft" | "topRight" | "bottomLeft" | "bottomRight" | "rightTop" | "leftTop" | "rightBottom" | "leftBottom" | (() => void) | undefined, placement?: "left" | "right" | "top" | "bottom" | "topLeft" | "topRight" | "bottomLeft" | "bottomRight" | "rightTop" | "leftTop" | "rightBottom" | "leftBottom" | undefined): MessageType;
    warn(content: React.ReactNode, duration?: number | "left" | "right" | "top" | "bottom" | "topLeft" | "topRight" | "bottomLeft" | "bottomRight" | "rightTop" | "leftTop" | "rightBottom" | "leftBottom" | (() => void) | undefined, onClose?: "left" | "right" | "top" | "bottom" | "topLeft" | "topRight" | "bottomLeft" | "bottomRight" | "rightTop" | "leftTop" | "rightBottom" | "leftBottom" | (() => void) | undefined, placement?: "left" | "right" | "top" | "bottom" | "topLeft" | "topRight" | "bottomLeft" | "bottomRight" | "rightTop" | "leftTop" | "rightBottom" | "leftBottom" | undefined): MessageType;
    warning(content: React.ReactNode, duration?: number | "left" | "right" | "top" | "bottom" | "topLeft" | "topRight" | "bottomLeft" | "bottomRight" | "rightTop" | "leftTop" | "rightBottom" | "leftBottom" | (() => void) | undefined, onClose?: "left" | "right" | "top" | "bottom" | "topLeft" | "topRight" | "bottomLeft" | "bottomRight" | "rightTop" | "leftTop" | "rightBottom" | "leftBottom" | (() => void) | undefined, placement?: "left" | "right" | "top" | "bottom" | "topLeft" | "topRight" | "bottomLeft" | "bottomRight" | "rightTop" | "leftTop" | "rightBottom" | "leftBottom" | undefined): MessageType;
    loading(content: React.ReactNode, duration?: number | "left" | "right" | "top" | "bottom" | "topLeft" | "topRight" | "bottomLeft" | "bottomRight" | "rightTop" | "leftTop" | "rightBottom" | "leftBottom" | (() => void) | undefined, onClose?: "left" | "right" | "top" | "bottom" | "topLeft" | "topRight" | "bottomLeft" | "bottomRight" | "rightTop" | "leftTop" | "rightBottom" | "leftBottom" | (() => void) | undefined, placement?: "left" | "right" | "top" | "bottom" | "topLeft" | "topRight" | "bottomLeft" | "bottomRight" | "rightTop" | "leftTop" | "rightBottom" | "leftBottom" | undefined): MessageType;
    config(options: ConfigOptions): void;
    destroy(): void;
};
export default _default;
