import { CSSProperties, MouseEventHandler, ReactElement, ReactNode } from 'react';
import { Step, StepGroup } from '../rc-components/steps';
import { Size } from '../_util/enum';
export interface StepsProps {
    prefixCls?: string;
    iconPrefix?: string;
    current?: number;
    status?: 'wait' | 'process' | 'finish' | 'error';
    size?: Size;
    direction?: 'horizontal' | 'vertical';
    progressDot?: boolean | Function;
    style?: CSSProperties;
    headerRender?: () => ReactElement<any>;
    headerIcon?: string;
    headerText?: string;
    type?: string;
    onChange?: Function;
}
export interface StepProps {
    className?: string;
    description?: ReactNode;
    icon?: ReactNode;
    onClick?: MouseEventHandler<HTMLElement>;
    status?: 'wait' | 'process' | 'finish' | 'error';
    disabled?: boolean;
    title?: ReactNode;
    subTitle?: ReactNode;
    style?: CSSProperties;
}
export declare type StepsComponent = typeof Steps & {
    Step: typeof Step;
    StepGroup: typeof StepGroup;
};
declare const Steps: {
    (props: any): JSX.Element;
    displayName: string;
    defaultProps: {
        iconPrefix: string;
        current: number;
    };
};
declare const _default: StepsComponent;
export default _default;
