import { CSSProperties, FunctionComponent, ReactNode } from 'react';
import DataSet from 'choerodon-ui/dataset';
import { CountRendererProps } from './Count';
export interface TabPaneProps {
    /** 选项卡头显示文字 */
    tab?: ReactNode | ((title?: string) => ReactNode);
    title?: string;
    style?: CSSProperties;
    active?: boolean;
    closable?: boolean;
    className?: string;
    eventKey?: string;
    rootPrefixCls?: string;
    disabled?: boolean;
    forceRender?: boolean;
    destroyInactiveTabPane?: boolean;
    count?: number | (() => number | undefined);
    countRenderer?: (props: CountRendererProps) => ReactNode;
    overflowCount?: number;
    showCount?: boolean;
    placeholder?: ReactNode;
    sort?: number;
    dataSet?: DataSet | DataSet[];
    children?: ReactNode;
    hidden?: boolean;
}
declare const TabPane: FunctionComponent<TabPaneProps>;
declare const MemoTabPane: typeof TabPane;
export default MemoTabPane;
