"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _noop = _interopRequireDefault(require("lodash/noop"));

var _classnames = _interopRequireDefault(require("classnames"));

var _button = _interopRequireDefault(require("../button"));

var _enum = require("../_util/enum");

var Operation = function Operation(props) {
  var _props$moveToLeft = props.moveToLeft,
      moveToLeft = _props$moveToLeft === void 0 ? _noop["default"] : _props$moveToLeft,
      _props$moveToRight = props.moveToRight,
      moveToRight = _props$moveToRight === void 0 ? _noop["default"] : _props$moveToRight,
      _props$leftArrowText = props.leftArrowText,
      leftArrowText = _props$leftArrowText === void 0 ? '' : _props$leftArrowText,
      _props$rightArrowText = props.rightArrowText,
      rightArrowText = _props$rightArrowText === void 0 ? '' : _props$rightArrowText,
      leftActive = props.leftActive,
      rightActive = props.rightActive,
      className = props.className,
      style = props.style,
      buttonProps = props.buttonProps;
  var customLeftClass = (0, _classnames["default"])("".concat(className, "-custom-left-active"), (0, _defineProperty2["default"])({}, "".concat(className, "-custom-left-disable"), !leftActive));
  var customRightClass = (0, _classnames["default"])("".concat(className, "-custom-left-active"), (0, _defineProperty2["default"])({}, "".concat(className, "-custom-left-disable"), !rightActive));
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: className,
    style: style
  }, typeof leftArrowText === 'string' ? /*#__PURE__*/_react["default"].createElement(_button["default"], (0, _extends2["default"])({}, buttonProps, {
    type: "primary",
    size: _enum.Size.small,
    disabled: !leftActive,
    onClick: moveToLeft,
    icon: "keyboard_arrow_left"
  }), leftArrowText) : /*#__PURE__*/_react["default"].createElement("div", {
    className: customLeftClass,
    onClick: leftActive ? moveToLeft : undefined
  }, leftArrowText), typeof rightArrowText === 'string' ? /*#__PURE__*/_react["default"].createElement(_button["default"], (0, _extends2["default"])({}, buttonProps, {
    type: "primary",
    size: _enum.Size.small,
    disabled: !rightActive,
    onClick: moveToRight,
    icon: "keyboard_arrow_right"
  }), rightArrowText) : /*#__PURE__*/_react["default"].createElement("div", {
    className: customRightClass,
    onClick: rightActive ? moveToRight : undefined
  }, rightArrowText));
};

Operation.displayName = 'TransferOperation';
var _default = Operation;
exports["default"] = _default;
//# sourceMappingURL=operation.js.map
