import React, { CSSProperties } from 'react';
export interface WaterMarkProps {
    /** 类名 */
    className?: string;
    /** 是否启用 */
    enable?: boolean;
    /** 水印类名 */
    markClassName?: string;
    /** 水印之间的水平间距 */
    gapX?: number;
    /** 水印之间的垂直间距 */
    gapY?: number;
    /** 追加的水印元素的z-index */
    zIndex?: number;
    /** 水印的宽度 */
    width?: number;
    /** 水印的高度 */
    height?: number;
    /** 水印在canvas 画布上绘制的垂直偏移量，正常情况下，水印绘制在中间位置, 即 offsetTop = gapY / 2 */
    offsetTop?: number;
    /** 水印在canvas 画布上绘制的水平偏移量, 正常情况下，水印绘制在中间位置, 即 offsetTop = gapX / 2 */
    offsetLeft?: number;
    /** 水印绘制时，旋转的角度，单位 ° */
    rotate?: number;
    /** ClassName 前缀 */
    prefixCls?: string;
    /** 高清印图片源, 为了高清屏幕显示，建议使用 2倍或3倍图，优先使用图片渲染水印。 */
    image?: string;
    /** 水印文字内容 */
    content?: string;
    /** 水印文字样式 */
    markStyle?: CSSProperties;
    children?: React.ReactNode;
    /** 是否可移除，默认为 false 不可移除，如果修改 Dom 节点强制移除则重新生成 */
    removeable?: boolean;
    /** 指定挂载的节点 */
    getContainer?: () => HTMLElement;
}
declare const WaterMark: React.FC<WaterMarkProps>;
export default WaterMark;
