import isEmpty from './isEmpty';
export function toTransformValue(value) {
  return Object.keys(value).reduce(function (values, key) {
    var v = value[key];

    if (!isEmpty(v)) {
      values.push("".concat(key, "(").concat(v, ")"));
    }

    return values;
  }, []).join(' ');
}
export default function transform(value, style) {
  if (style) {
    style.transform = value;
    style.webkitTransform = value;
    return;
  }

  return ['-webkit-', '-ms-', ''].map(function (prefix) {
    return "".concat(prefix, "transform:").concat(value);
  }).join(';');
}
//# sourceMappingURL=transform.js.map
