import _extends from "@babel/runtime/helpers/extends";
import React, { useContext } from 'react';
import { observer } from 'mobx-react-lite';
import { Droppable } from 'react-beautiful-dnd';
import BoardContext from '../../BoardContext';

var Tree = function Tree(props) {
  var children = props.children;

  var _useContext = useContext(BoardContext),
      prefixCls = _useContext.prefixCls; // const { droppableProps, renderClone } = columnsDragRender;


  return true ? /*#__PURE__*/React.createElement(Droppable, {
    droppableId: "tree__--__fields",
    key: "tree"
  }, function (droppableProvided) {
    return /*#__PURE__*/React.createElement("div", _extends({
      ref: droppableProvided.innerRef,
      className: "".concat(prefixCls, "-customization-tree")
    }, droppableProvided && droppableProvided.droppableProps), children, droppableProvided && droppableProvided.placeholder);
  }) : /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-customization-tree")
  }, children);
};

Tree.displayName = 'Tree';
export default observer(Tree);
//# sourceMappingURL=Tree.js.map
