import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _inherits from "@babel/runtime/helpers/inherits";
import _createSuper from "@babel/runtime/helpers/createSuper";
import { __decorate } from "tslib";
import { observer } from 'mobx-react';
import { NumberField } from '../number-field/NumberField';
import { FieldType } from '../data-set/enum';
import formatCurrency from '../formatter/formatCurrency';
import { getCurrencyFormatOptions, getCurrencyFormatter } from '../field/utils';

var Currency = /*#__PURE__*/function (_NumberField) {
  _inherits(Currency, _NumberField);

  var _super = _createSuper(Currency);

  function Currency() {
    _classCallCheck(this, Currency);

    return _super.apply(this, arguments);
  }

  _createClass(Currency, [{
    key: "getFieldType",
    value: function getFieldType() {
      return FieldType.currency;
    }
  }, {
    key: "getFormatter",
    value: function getFormatter() {
      return this.getProp('formatter') || getCurrencyFormatter(this.getContextConfig);
    }
  }, {
    key: "getFormatOptions",
    value: function getFormatOptions() {
      var _this = this;

      return getCurrencyFormatOptions(function (name) {
        return _this.getProp(name);
      }, function (name) {
        return _this.getDisplayProp(name);
      }, this.lang, this.getContextConfig);
    }
  }]);

  return Currency;
}(NumberField);

Currency.displayName = 'Currency';
Currency.format = formatCurrency;
/**
 * @deprecated
 */

Currency.bigNumberFormat = formatCurrency;
Currency = __decorate([observer], Currency);
export default Currency;
//# sourceMappingURL=Currency.js.map
