import { ConfigContextValue } from '../../../es/config-provider/ConfigContext';
import DataSet from './DataSet';
import ViewComponent, { ViewComponentProps } from '../core/ViewComponent';
import { Lang } from '../locale-context/enum';
/**
 * 可绑定数据源的组件.
 */
export interface DataSetComponentProps extends ViewComponentProps {
    /** 数据源 */
    dataSet?: DataSet;
}
export default class DataSetComponent<T extends DataSetComponentProps, C extends ConfigContextValue = ConfigContextValue> extends ViewComponent<T, C> {
    get dataSet(): DataSet | undefined;
    get lang(): Lang;
    getObservableProps(props: any, context: any): any;
    getOmitPropsKeys(): string[];
}
