import { FunctionComponent, ReactNode } from 'react';
import { RenderFunction } from '../../../es/trigger/Trigger';
import { Action } from '../../../es/trigger/enum';
import DropdownButton from './DropdownButton';
import { Placements } from './enum';
export interface DropDownProps {
    trigger?: Action[];
    overlay: ReactNode | RenderFunction;
    onHiddenChange?: (hidden?: boolean) => void;
    onHiddenBeforeChange?: (hidden: boolean) => boolean;
    onVisibleChange?: (visible?: boolean) => void;
    onOverlayClick?: (e: any) => void;
    hidden?: boolean;
    visible?: boolean;
    defaultHidden?: boolean;
    defaultVisible?: boolean;
    disabled?: boolean;
    align?: Record<string, any>;
    getPopupContainer?: (triggerNode: Element) => HTMLElement;
    suffixCls?: string;
    prefixCls?: string;
    className?: string;
    transitionName?: string;
    placement?: Placements;
    forceRender?: boolean;
    popupClassName?: string;
    children?: ReactNode;
}
interface DropdownInterface extends FunctionComponent<DropDownProps> {
    Button: typeof DropdownButton;
}
declare const Dropdown: DropdownInterface;
export default Dropdown;
