import { CSSProperties } from 'react';
import DataSet from '../data-set/DataSet';
import Record from '../data-set/Record';
import { LabelLayout, SpacingType } from './enum';
import { LabelWidth, SeparateSpacing, SpacingTypeMap } from './Form';
export declare const defaultLabelWidth = 100;
export declare const defaultLabelLayout: LabelLayout;
export declare const defaultColumns = 1;
export declare const FIELD_SUFFIX = "field";
export declare function normalizeLabelWidth(labelWidth: LabelWidth, columns: number): (number | 'auto')[];
export declare function getProperty(props: any, key: string, dataSet?: DataSet, record?: Record): any;
/**
 * 有ds时，仅以ds field属性为准；无ds则以组件属性为准
 * @param props
 * @param key
 * @param dataSet
 * @param record
 * @returns
 */
export declare function getPropertyDSFirst(props: any, key: string, dataSet?: DataSet, record?: Record): any;
export declare const defaultExcludeUseColonTag: string[];
export declare function hasParentElement(parentElement: HTMLElement | null, tagName: string): boolean;
export declare function normalizeSeparateSpacing(separateSpacing: number | [number, number] | SeparateSpacing): SeparateSpacing;
export declare function normalizeSpacingType(spacingType: SpacingType | [SpacingType, SpacingType] | SpacingTypeMap | undefined): SpacingTypeMap;
export declare type SpacingProperties = {
    paddingHorizontal: number;
    paddingVertical: number;
    marginHorizontal: number;
    marginVertical: number;
    style: CSSProperties;
};
export declare function getSpacingProperties(separateSpacing: SeparateSpacing, spacingType: SpacingTypeMap, isHorizontal: boolean): SpacingProperties;
export declare function getSpacingLabelStyle(properties: SpacingProperties | undefined, isHorizontal: boolean, rowIndex: number): CSSProperties | undefined;
export declare function getSpacingFieldStyle(properties: SpacingProperties | undefined, isHorizontal: boolean, rowIndex: number): CSSProperties | undefined;
