import _extends from "@babel/runtime/helpers/extends";
import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["header", "className", "children", "classPrefix", "headerHeight", "verticalAlign", "width", "left"];
import React from 'react';
import classNames from 'classnames';
import { defaultClassPrefix, prefix } from './utils';
var ColumnGroup = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var header = props.header,
      className = props.className,
      children = props.children,
      classPrefix = props.classPrefix,
      _props$headerHeight = props.headerHeight,
      headerHeight = _props$headerHeight === void 0 ? 80 : _props$headerHeight,
      verticalAlign = props.verticalAlign,
      width = props.width,
      left = props.left,
      rest = _objectWithoutProperties(props, _excluded);

  var height = headerHeight / 2;
  var styles = {
    height: height,
    width: width,
    left: left
  };

  var contentStyles = _objectSpread(_objectSpread({}, styles), {}, {
    verticalAlign: verticalAlign
  });

  var addPrefix = function addPrefix(name) {
    return prefix(classPrefix)(name);
  };

  return /*#__PURE__*/React.createElement("div", _extends({
    ref: ref,
    className: classNames(classPrefix, className)
  }, rest), /*#__PURE__*/React.createElement("div", {
    className: addPrefix('header'),
    style: styles
  }, /*#__PURE__*/React.createElement("div", {
    className: addPrefix('header-content'),
    style: contentStyles
  }, header)), React.Children.map(children, function (node) {
    var nodeStyles = _objectSpread(_objectSpread({}, node.props.style), {}, {
      top: styles.height,
      left: styles.left
    });

    return /*#__PURE__*/React.cloneElement(node, {
      className: addPrefix('cell'),
      style: nodeStyles,
      children: /*#__PURE__*/React.createElement("span", {
        className: addPrefix('cell-content')
      }, node.props.children)
    });
  }));
});
ColumnGroup.displayName = 'ColumnGroup';
ColumnGroup.__PRO_TABLE_COLUMN_GROUP = true;
ColumnGroup.defaultProps = {
  headerHeight: 80,
  classPrefix: defaultClassPrefix('performance-table-column-group')
};
export default ColumnGroup;
//# sourceMappingURL=ColumnGroup.js.map
