import React, { memo, useCallback } from 'react';
import { FuncType } from '../../button/enum';
import { Size } from '../../core/enum';
import Button from '../../button/Button';
import useModal from '../../use-modal';

var CustomizationColumnHeader = function CustomizationColumnHeader(props) {
  var onHeaderClick = props.onHeaderClick;
  var modal = useModal();
  var openCustomizationModal = useCallback(function () {
    return onHeaderClick(modal);
  }, [modal, onHeaderClick]);
  return /*#__PURE__*/React.createElement(Button, {
    funcType: FuncType.flat,
    size: Size.small,
    icon: "predefine",
    onClick: openCustomizationModal
  });
};

CustomizationColumnHeader.displayName = 'CustomizationColumnHeader';
export default /*#__PURE__*/memo(CustomizationColumnHeader);
//# sourceMappingURL=CustomizationColumnHeader.js.map
