/**
 * Returns an object consisting of props beyond the scope of the Component.
 * Useful for getting and spreading unknown props from the user.
 * @param {object} propTypes
 * @param {object} props A ReactElement props object
 * @returns {{}} A shallow copy of the prop object
 */
declare const getUnhandledProps: (propTypeKeys: string[], props: Record<string, any>) => any;
export default getUnhandledProps;
