import curry from 'lodash/curry';
import classNames from 'classnames';
export var globalKey = 'c7n-';
export var getClassNamePrefix = function getClassNamePrefix() {
  return globalKey;
};
export var defaultClassPrefix = function defaultClassPrefix(name) {
  return "".concat(getClassNamePrefix()).concat(name);
};
export var prefix = curry(function (pre, className) {
  if (!pre || !className) {
    return '';
  }

  if (Array.isArray(className)) {
    return classNames(className.filter(function (name) {
      return !!name;
    }).map(function (name) {
      return "".concat(pre, "-").concat(name);
    }));
  }

  return "".concat(pre, "-").concat(className);
});
//# sourceMappingURL=prefix.js.map
