import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";

/**
 * 根据条件，选择性调用 a 与 b 其中一个方法。
 * @param a
 * @param b
 */
function toggle(a, b) {
  return function (target, value) {
    var options = [target].concat(_toConsumableArray(value));
    return function (condition) {
      if (condition) {
        a.apply(void 0, _toConsumableArray(options));
      } else {
        b.apply(void 0, _toConsumableArray(options));
      }
    };
  };
}

export default toggle;
//# sourceMappingURL=toggle.js.map
