import _extends from "@babel/runtime/helpers/extends";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _inherits from "@babel/runtime/helpers/inherits";
import _createSuper from "@babel/runtime/helpers/createSuper";
import { __decorate } from "tslib";
import React, { Component } from 'react';
import { observer } from 'mobx-react';
import { RichTextToolbarType } from '../enum';

var Toolbar = function Toolbar(props) {
  var id = props.id,
      prefixCls = props.prefixCls;
  return /*#__PURE__*/React.createElement("div", {
    id: id || 'toolbar',
    className: "".concat(prefixCls, "-toolbar")
  }, /*#__PURE__*/React.createElement("button", {
    type: "button",
    className: "ql-bold"
  }), /*#__PURE__*/React.createElement("button", {
    type: "button",
    className: "ql-italic"
  }), /*#__PURE__*/React.createElement("button", {
    type: "button",
    className: "ql-underline"
  }), /*#__PURE__*/React.createElement("button", {
    type: "button",
    className: "ql-strike"
  }), /*#__PURE__*/React.createElement("button", {
    type: "button",
    className: "ql-blockquote"
  }), /*#__PURE__*/React.createElement("button", {
    type: "button",
    className: "ql-list",
    value: "ordered"
  }), /*#__PURE__*/React.createElement("button", {
    type: "button",
    className: "ql-list",
    value: "bullet"
  }), /*#__PURE__*/React.createElement("button", {
    type: "button",
    className: "ql-image"
  }), /*#__PURE__*/React.createElement("button", {
    type: "button",
    className: "ql-link"
  }), /*#__PURE__*/React.createElement("select", {
    className: "ql-color"
  }));
};

var RichTextToolbar = /*#__PURE__*/function (_Component) {
  _inherits(RichTextToolbar, _Component);

  var _super = _createSuper(RichTextToolbar);

  function RichTextToolbar() {
    _classCallCheck(this, RichTextToolbar);

    return _super.apply(this, arguments);
  }

  _createClass(RichTextToolbar, [{
    key: "renderToolBar",
    value: function renderToolBar(props) {
      var prefixCls = this.props.prefixCls;
      return /*#__PURE__*/React.createElement(Toolbar, _extends({
        key: "toolbar",
        prefixCls: prefixCls
      }, props));
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          id = _this$props.id,
          toolbar = _this$props.toolbar,
          dataSet = _this$props.dataSet;
      var props = {
        id: id,
        dataSet: dataSet
      };

      if (typeof toolbar === 'function') {
        return toolbar(props);
      }

      switch (toolbar) {
        case RichTextToolbarType.normal:
          return this.renderToolBar(props);

        default:
          return null;
      }
    }
  }]);

  return RichTextToolbar;
}(Component);

RichTextToolbar.displayName = 'RichTextToolbar';
RichTextToolbar = __decorate([observer], RichTextToolbar);
export default RichTextToolbar;
//# sourceMappingURL=index.js.map
