import React, { memo, useCallback } from 'react';
import ReactResizeObserver from '../../../es/_util/resizeObserver';

var ResizeObservedRow = function ResizeObservedRow(props) {
  var children = props.children,
      onResize = props.onResize,
      rowIndex = props.rowIndex;
  var handleResize = useCallback(function (_width, height, target) {
    onResize(rowIndex, height, target);
  }, [onResize, rowIndex]);
  return /*#__PURE__*/React.createElement(ReactResizeObserver, {
    resizeProp: "height",
    onResize: handleResize,
    immediately: true
  }, children);
};

ResizeObservedRow.displayName = 'ResizeObservedRow';
export default /*#__PURE__*/memo(ResizeObservedRow);
//# sourceMappingURL=ResizeObservedRow.js.map
