import _extends from "@babel/runtime/helpers/extends";
import React, { useContext, useEffect } from 'react';
import { useInView } from 'react-intersection-observer';
import { observer } from 'mobx-react-lite';
import TableContext from './TableContext';
import TableHeaderCell from './TableHeaderCell';

var TableVirtualHeaderCell = function TableVirtualHeaderCell(props) {
  var columnGroup = props.columnGroup;

  var _useContext = useContext(TableContext),
      tableStore = _useContext.tableStore;

  var _useInView = useInView({
    root: tableStore.node.wrapper,
    rootMargin: '100px',
    initialInView: true
  }),
      ref = _useInView.ref,
      inView = _useInView.inView;

  useEffect(function () {
    columnGroup.setInView(inView);
    return function () {
      if (columnGroup.inView !== undefined) {
        columnGroup.setInView(undefined);
      }
    };
  }, [columnGroup, inView]);
  return /*#__PURE__*/React.createElement(TableHeaderCell, _extends({}, props, {
    intersectionRef: ref
  }));
};

TableVirtualHeaderCell.displayName = 'TableVirtualHeaderCell';
export default observer(TableVirtualHeaderCell);
//# sourceMappingURL=TableVirtualHeaderCell.js.map
