import React, { ReactNode } from 'react';
import { DraggableProvided, DraggableStateSnapshot } from 'react-beautiful-dnd';
import Record from '../data-set/Record';
import { ElementProps } from '../core/ViewComponent';
import { ColumnLock } from './enum';
import ColumnGroups from './ColumnGroups';
import { Group } from '../data-set/DataSet';
import VirtualRowMetaData from './VirtualRowMetaData';
export interface TableVirtualRowProps extends ElementProps {
    lock?: ColumnLock | boolean | undefined;
    isExpanded?: boolean | undefined;
    columnGroups: ColumnGroups;
    record: Record;
    index: number;
    isFixedRowHeight?: boolean | undefined;
    virtualCell?: boolean | undefined;
    virtualIndex?: number | undefined;
    headerGroupIndex?: number | undefined;
    expandIconColumnIndex?: number | undefined;
    snapshot?: DraggableStateSnapshot | undefined;
    provided?: DraggableProvided | undefined;
    isDragDisabled?: boolean | ((record?: Record) => boolean);
    groupPath?: [Group, boolean][] | undefined;
    metaData?: VirtualRowMetaData;
    children?: ReactNode;
}
declare const _default: React.FunctionComponent<TableVirtualRowProps>;
export default _default;
