import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import React, { memo, useContext, useState } from 'react';
import Popover from '../../../../es/popover';
import { FuncType } from '../../button/enum';
import { Size } from '../../core/enum';
import Button from '../../button/Button';
import Tooltip from '../../tooltip';
import TableContext from '../TableContext';
import { $l } from '../../locale-context';
import CustomizationSettings from './CustomizationSettings';

var ComboCustomizationColumnHeader = function ComboCustomizationColumnHeader() {
  var _useContext = useContext(TableContext),
      prefixCls = _useContext.prefixCls;

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      visible = _useState2[0],
      setVisible = _useState2[1];

  var handleVisibleChange = function handleVisibleChange() {
    setVisible(!visible);
  };

  return /*#__PURE__*/React.createElement(Tooltip, {
    title: $l('Table', 'field_settings')
  }, /*#__PURE__*/React.createElement(Popover, {
    trigger: "click",
    placement: "bottomRight",
    overlayClassName: "".concat(prefixCls, "-combo-customization"),
    title: $l('Table', 'field_settings'),
    content: /*#__PURE__*/React.createElement(CustomizationSettings, {
      visible: visible,
      setVisible: setVisible
    }),
    onVisibleChange: handleVisibleChange,
    visible: visible,
    arrowPointAtCenter: true
  }, /*#__PURE__*/React.createElement(Button, {
    funcType: FuncType.flat,
    size: Size.small,
    icon: "predefine"
  })));
};

ComboCustomizationColumnHeader.displayName = 'ComboCustomizationColumnHeader';
export default /*#__PURE__*/memo(ComboCustomizationColumnHeader);
//# sourceMappingURL=index.js.map
