import React, { useContext } from 'react';
import { observer } from 'mobx-react-lite';
import Tree from '../tree/Tree';
import SubGroups from './SubGroups';
import TableContext from '../../TableContext';

var Group = function Group(props) {
  var header = props.header,
      records = props.records,
      value = props.value,
      onDragEnd = props.onDragEnd,
      treeNodeRenderer = props.treeNodeRenderer,
      treeNodeSuffix = props.treeNodeSuffix;

  var _useContext = useContext(TableContext),
      prefixCls = _useContext.prefixCls;

  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-customization-tree-group-header")
  }, header), /*#__PURE__*/React.createElement(Tree, {
    value: value
  }, /*#__PURE__*/React.createElement(SubGroups, {
    records: records,
    onDragEnd: onDragEnd,
    treeNodeRenderer: treeNodeRenderer,
    treeNodeSuffix: treeNodeSuffix
  })));
};

Group.displayName = 'Group';
export default observer(Group);
//# sourceMappingURL=Group.js.map
