import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["treeNodeRenderer", "treeNodeSuffix", "childrenRecords", "onDragEnd"];
import React, { useContext } from 'react';
import { observer } from 'mobx-react-lite';
import { DragDropContext } from 'react-beautiful-dnd';
import SubGroups from './SubGroups';
import TreeNode from '../tree/TreeNode';
import TableContext from '../../TableContext';

var SubGroup = function SubGroup(props) {
  var treeNodeRenderer = props.treeNodeRenderer,
      treeNodeSuffix = props.treeNodeSuffix,
      childrenRecords = props.childrenRecords,
      onDragEnd = props.onDragEnd,
      rest = _objectWithoutProperties(props, _excluded);

  var _useContext = useContext(TableContext),
      tableStore = _useContext.tableStore;

  var treeNode = /*#__PURE__*/React.createElement(TreeNode, _extends({}, rest, {
    isLeaf: false,
    renderer: treeNodeRenderer,
    suffix: treeNodeSuffix
  }), /*#__PURE__*/React.createElement(SubGroups, {
    records: childrenRecords,
    onDragEnd: onDragEnd,
    treeNodeRenderer: treeNodeRenderer,
    treeNodeSuffix: treeNodeSuffix
  }));
  return tableStore.columnDraggable ? /*#__PURE__*/React.createElement(DragDropContext, {
    onDragEnd: onDragEnd
  }, treeNode) : treeNode;
};

SubGroup.displayName = 'SubGroup';
export default observer(SubGroup);
//# sourceMappingURL=SubGroup.js.map
