import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _extends from "@babel/runtime/helpers/extends";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _inherits from "@babel/runtime/helpers/inherits";
import _createSuper from "@babel/runtime/helpers/createSuper";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import { __decorate } from "tslib";
import React, { cloneElement, Component } from 'react';
import { observer } from 'mobx-react';
import { action, observable, runInAction } from 'mobx';
import isFunction from 'lodash/isFunction';
import noop from 'lodash/noop';
import classNames from 'classnames';
import Icon from '../../../../es/icon';
import { getProPrefixCls as getProPrefixClsDefault, getConfig } from '../../../../es/configure/utils';
import TableButtons from './TableButtons';
import Button from '../../button';
import TableContext from '../TableContext';
import { ButtonColor, FuncType } from '../../button/enum';
import Form from '../../form';
import { LabelLayout } from '../../form/enum';
import { $l } from '../../locale-context';
import autobind from '../../_util/autobind';
import { Tooltip as LabelTooltip } from '../../core/enum';

var TableProfessionalBar = /*#__PURE__*/function (_Component) {
  _inherits(TableProfessionalBar, _Component);

  var _super = _createSuper(TableProfessionalBar);

  function TableProfessionalBar() {
    var _this;

    _classCallCheck(this, TableProfessionalBar);

    _this = _super.apply(this, arguments);

    _this.openMore = function (fields) {
      var tableStore = _this.context.tableStore;

      if (_this.moreFields && _this.moreFields.length) {
        _this.moreFields = [];
      } else {
        _this.moreFields = fields;
      }

      if (tableStore.node) {
        tableStore.node.handleHeightTypeChange();
      }

      return _this.moreFields;
    };

    return _this;
  }

  _createClass(TableProfessionalBar, [{
    key: "queryFields",
    get: function get() {
      var queryFields = this.props.queryFields;
      return queryFields.filter(function (component) {
        return !component.props.hidden;
      });
    }
  }, {
    key: "prefixCls",
    get: function get() {
      var prefixCls = this.props.prefixCls;
      var _this$context$tableSt = this.context.tableStore.getProPrefixCls,
          getProPrefixCls = _this$context$tableSt === void 0 ? getProPrefixClsDefault : _this$context$tableSt;
      return getProPrefixCls('table', prefixCls);
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      var _this$props = this.props,
          queryFieldsLimit = _this$props.queryFieldsLimit,
          queryFields = _this$props.queryFields,
          queryDataSet = _this$props.queryDataSet,
          defaultExpanded = _this$props.defaultExpanded;

      if (queryDataSet && queryFields.length && defaultExpanded) {
        runInAction(function () {
          _this2.moreFields = _this2.createFields(queryFields.filter(function (f) {
            return !f.props.hidden;
          }).slice(queryFieldsLimit));
        });
      }

      this.processDataSetListener(true);
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps, _) {
      var _this3 = this;

      var queryFieldsLimit = nextProps.queryFieldsLimit,
          queryFields = nextProps.queryFields,
          queryDataSet = nextProps.queryDataSet,
          defaultExpanded = nextProps.defaultExpanded;

      if (queryDataSet && queryFields.length && (defaultExpanded || this.moreFields && this.moreFields.length)) {
        runInAction(function () {
          _this3.moreFields = _this3.createFields(queryFields.filter(function (f) {
            return !f.props.hidden;
          }).slice(queryFieldsLimit));
        });
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.processDataSetListener(false);
    }
  }, {
    key: "processDataSetListener",
    value: function processDataSetListener(flag) {
      var queryDataSet = this.props.queryDataSet;

      if (queryDataSet) {
        var handler = flag ? queryDataSet.addEventListener : queryDataSet.removeEventListener;
        handler.call(queryDataSet, 'validate', this.handleDataSetValidate);
      }
    }
    /**
     * queryDataSet 查询前校验事件 触发展开动态字段
     * @param dataSet 查询DS
     * @param result
     */

  }, {
    key: "handleDataSetValidate",
    value: function () {
      var _handleDataSetValidate = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(_ref) {
        var _this4 = this;

        var result, queryFieldsLimit, moreFields;
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                result = _ref.result;
                queryFieldsLimit = this.props.queryFieldsLimit;
                moreFields = this.createFields(this.queryFields.slice(queryFieldsLimit));
                _context.next = 5;
                return result;

              case 5:
                if (_context.sent) {
                  _context.next = 7;
                  break;
                }

                runInAction(function () {
                  _this4.moreFields = moreFields;
                });

              case 7:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function handleDataSetValidate(_x) {
        return _handleDataSetValidate.apply(this, arguments);
      }

      return handleDataSetValidate;
    }()
  }, {
    key: "handleFieldEnter",
    value: function handleFieldEnter() {
      this.handleQuery();
    }
  }, {
    key: "handleQuery",
    value: function () {
      var _handleQuery = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(collapse) {
        var _this$props2, dataSet, queryDataSet, _this$props2$onQuery, onQuery;

        return _regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _this$props2 = this.props, dataSet = _this$props2.dataSet, queryDataSet = _this$props2.queryDataSet, _this$props2$onQuery = _this$props2.onQuery, onQuery = _this$props2$onQuery === void 0 ? noop : _this$props2$onQuery;
                _context2.t0 = queryDataSet;

                if (!_context2.t0) {
                  _context2.next = 6;
                  break;
                }

                _context2.next = 5;
                return queryDataSet.validate();

              case 5:
                _context2.t0 = _context2.sent;

              case 6:
                if (!_context2.t0) {
                  _context2.next = 12;
                  break;
                }

                _context2.next = 9;
                return dataSet.query();

              case 9:
                if (collapse) {
                  _context2.next = 12;
                  break;
                }

                _context2.next = 12;
                return onQuery();

              case 12:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function handleQuery(_x2) {
        return _handleQuery.apply(this, arguments);
      }

      return handleQuery;
    }()
  }, {
    key: "getResetButton",
    value: function getResetButton() {
      var prefixCls = this.prefixCls;
      return /*#__PURE__*/React.createElement(Button, {
        key: 'lov_reset_btn',
        className: "".concat(prefixCls, "-professional-reset-btn"),
        funcType: FuncType.raised,
        onClick: this.handleQueryReset
      }, $l('Table', 'reset_button'));
    }
  }, {
    key: "getMoreFieldsButton",
    value: function getMoreFieldsButton(fields) {
      var _this5 = this;

      var prefixCls = this.prefixCls;

      if (fields.length) {
        return /*#__PURE__*/React.createElement(Button, {
          className: "".concat(prefixCls, "-professional-query-more"),
          funcType: FuncType.raised,
          onClick: function onClick() {
            return _this5.openMore(fields);
          }
        }, $l('Table', 'more'), this.moreFields && this.moreFields.length ? /*#__PURE__*/React.createElement(Icon, {
          type: 'expand_less'
        }) : /*#__PURE__*/React.createElement(Icon, {
          type: 'expand_more'
        }));
      }
    }
    /**
     * 注入 onEnterDown 事件
     * @param elements
     */

  }, {
    key: "createFields",
    value: function createFields(elements) {
      var _this6 = this;

      return elements.map(function (element) {
        var onEnterDown = element.props.onEnterDown;

        if (onEnterDown && isFunction(onEnterDown)) {
          return element;
        }

        var props = {
          onEnterDown: _this6.handleFieldEnter
        };
        return /*#__PURE__*/cloneElement(element, props);
      });
    }
  }, {
    key: "getQueryBar",
    value: function getQueryBar() {
      var _this7 = this;

      var _this$props3 = this.props,
          queryFieldsLimit = _this$props3.queryFieldsLimit,
          queryFields = _this$props3.queryFields,
          queryDataSet = _this$props3.queryDataSet,
          formProps = _this$props3.formProps;
      var prefixCls = this.prefixCls;

      if (queryDataSet && queryFields.length) {
        var currentFields = /*#__PURE__*/React.createElement(Form, _extends({
          dataSet: queryDataSet,
          columns: queryFieldsLimit,
          labelTooltip: LabelTooltip.overflow,
          labelWidth: 80
        }, formProps), this.createFields(this.queryFields.slice(0, queryFieldsLimit)), this.moreFields);
        var moreFields = this.createFields(this.queryFields.slice(queryFieldsLimit));
        var moreFieldsButton = this.getMoreFieldsButton(moreFields);
        var noVerticalFlag = false;
        var labelLayout = formProps && formProps.labelLayout || getConfig('labelLayout');

        if (labelLayout !== LabelLayout.vertical) {
          noVerticalFlag = true;
        }

        return /*#__PURE__*/React.createElement("div", {
          key: "query_bar",
          className: "".concat(prefixCls, "-professional-query-bar")
        }, currentFields, /*#__PURE__*/React.createElement("span", {
          className: classNames("".concat(prefixCls, "-professional-query-bar-button"), _defineProperty({}, "".concat(prefixCls, "-professional-query-bar-button-vertical"), !noVerticalFlag))
        }, moreFieldsButton, this.getResetButton(), /*#__PURE__*/React.createElement(Button, {
          color: ButtonColor.primary,
          wait: 500,
          onClick: function onClick() {
            return _this7.handleQuery();
          }
        }, $l('Table', 'query_button'))));
      }
    }
  }, {
    key: "handleQueryReset",
    value: function handleQueryReset() {
      var _this$props4 = this.props,
          queryDataSet = _this$props4.queryDataSet,
          autoQueryAfterReset = _this$props4.autoQueryAfterReset,
          _this$props4$onReset = _this$props4.onReset,
          onReset = _this$props4$onReset === void 0 ? noop : _this$props4$onReset;

      if (queryDataSet) {
        var current = queryDataSet.current;

        if (current) {
          current.reset();
          onReset();

          if (autoQueryAfterReset) {
            this.handleQuery(true);
          }
        }
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props5 = this.props,
          buttons = _this$props5.buttons,
          summaryBar = _this$props5.summaryBar;
      var prefixCls = this.prefixCls;
      var queryBar = this.getQueryBar();
      var tableButtons = buttons.length ? /*#__PURE__*/React.createElement("div", {
        key: "professional_toolbar",
        className: "".concat(prefixCls, "-professional-toolbar")
      }, /*#__PURE__*/React.createElement(TableButtons, {
        key: "table_buttons",
        prefixCls: prefixCls,
        buttons: buttons
      }, summaryBar)) : /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-toolbar"),
        key: "professional_toolbar"
      }, summaryBar);
      return [queryBar, tableButtons];
    }
  }], [{
    key: "contextType",
    get: function get() {
      return TableContext;
    }
  }]);

  return TableProfessionalBar;
}(Component);

TableProfessionalBar.defaultProps = {
  queryFieldsLimit: 3,
  autoQueryAfterReset: true
};

__decorate([observable], TableProfessionalBar.prototype, "moreFields", void 0);

__decorate([autobind], TableProfessionalBar.prototype, "handleDataSetValidate", null);

__decorate([autobind], TableProfessionalBar.prototype, "handleFieldEnter", null);

__decorate([autobind], TableProfessionalBar.prototype, "handleQuery", null);

__decorate([action], TableProfessionalBar.prototype, "openMore", void 0);

__decorate([autobind], TableProfessionalBar.prototype, "handleQueryReset", null);

TableProfessionalBar = __decorate([observer], TableProfessionalBar);
export default TableProfessionalBar;
//# sourceMappingURL=TableProfessionalBar.js.map
