import _defineProperty from "@babel/runtime/helpers/defineProperty";
import React from 'react';
import noop from 'lodash/noop';
import classNames from 'classnames';
import Button from '../button';
import { ButtonColor } from '../button/enum';
export default function TransferSort(props) {
  var _props$moveToUp = props.moveToUp,
      moveToUp = _props$moveToUp === void 0 ? noop : _props$moveToUp,
      _props$moveToDown = props.moveToDown,
      moveToDown = _props$moveToDown === void 0 ? noop : _props$moveToDown,
      _props$upArrowText = props.upArrowText,
      upArrowText = _props$upArrowText === void 0 ? '' : _props$upArrowText,
      _props$downArrowText = props.downArrowText,
      downArrowText = _props$downArrowText === void 0 ? '' : _props$downArrowText,
      upActive = props.upActive,
      downActive = props.downActive,
      className = props.className,
      multiple = props.multiple;

  if (multiple) {
    var customUpClass = classNames("".concat(className, "-custom-up-active"), _defineProperty({}, "".concat(className, "-custom-up-disable"), !upActive));
    var customDownClass = classNames("".concat(className, "-custom-down-active"), _defineProperty({}, "".concat(className, "-custom-down-disable"), !downActive));
    return /*#__PURE__*/React.createElement("div", {
      className: className
    }, typeof upArrowText === 'string' ? /*#__PURE__*/React.createElement(Button, {
      color: upActive ? ButtonColor.primary : ButtonColor["default"],
      disabled: !upActive,
      onClick: moveToUp,
      icon: 'expand_less'
    }, upArrowText) : /*#__PURE__*/React.createElement("div", {
      className: customUpClass,
      onClick: upActive ? moveToUp : undefined
    }, upArrowText), typeof downArrowText === 'string' ? /*#__PURE__*/React.createElement(Button, {
      color: downActive ? ButtonColor.primary : ButtonColor["default"],
      disabled: !downActive,
      onClick: moveToDown,
      icon: 'expand_more'
    }, downArrowText) : /*#__PURE__*/React.createElement("div", {
      className: customDownClass,
      onClick: downActive ? moveToDown : undefined
    }, downArrowText));
  }

  return null;
}
//# sourceMappingURL=TransferSort.js.map
