import * as React from 'react';
import { BlockProps, EllipsisConfig } from './interface';
import { FormField, FormFieldProps } from '../field/FormField';
export interface TextProps extends BlockProps, FormFieldProps<any> {
    ellipsis?: boolean | Omit<EllipsisConfig, 'expandable' | 'rows' | 'onExpand'>;
    onClick?: (e?: React.MouseEvent<HTMLDivElement>) => void;
}
export default class Text extends FormField<TextProps> {
    static displayName: string;
    static __PRO_TEXT: boolean;
    static defaultProps: {
        suffixCls: string;
        readOnly: boolean;
        disabled: boolean;
        noValidate: boolean;
        trim: import("../data-set/enum").FieldTrim;
    };
    get mergedEllipsis(): boolean | EllipsisConfig | undefined;
    renderWrapper(): React.ReactNode;
}
