import { ReactNode } from 'react';
import Record from '../data-set/Record';
import TextArea, { TextAreaProps } from '../text-area/TextArea';
import { ResizeType, AutoSizeType } from '../text-area/enum';
import { IntlType } from './enum';
import { ModalProps } from '../modal/Modal';
export interface IntlFieldProps extends TextAreaProps {
    modalProps?: ModalProps;
    maxLengths?: object;
    type?: IntlType;
    displayOutput?: boolean;
}
export default class IntlField extends TextArea<IntlFieldProps> {
    static displayName: string;
    static defaultProps: {
        rows: number;
        resize: ResizeType;
        type: IntlType;
        suffixCls: string;
        autoSize: boolean;
        clearButton: boolean;
        multiple: boolean;
        border: boolean;
        valueChangeAction: import("../text-field/enum").ValueChangeAction;
        waitType: import("../core/enum").WaitType;
        readOnly: boolean;
        disabled: boolean;
        noValidate: boolean;
        trim: import("../data-set/enum").FieldTrim;
    };
    modal: any;
    locales?: object;
    loading?: boolean;
    constructor(props: any, context: any);
    get range(): boolean;
    get readOnly(): boolean;
    get resize(): ResizeType | undefined;
    get autoSize(): boolean | AutoSizeType | undefined;
    get border(): boolean | undefined;
    getEditorTextInfo(rangeTarget?: 0 | 1): {
        text: string;
        width: number;
        placeholder?: string;
    };
    getPlaceholders(): string[];
    isEditable(): boolean;
    openModal: () => Promise<void>;
    setLoading(loading: any): void;
    handleIntlListClose: () => Promise<void>;
    handleIntlListOk(): Promise<boolean | undefined>;
    handleIntlListCancel(): Promise<void>;
    handleKeyDown(e: any): void;
    handleBlur(e: any): void;
    storeLocales(record: Record, name: string): void;
    getOmitPropsKeys(): string[];
    getOtherProps(): any;
    getWrapperClassNames(...args: any[]): string;
    getSuffix(): ReactNode;
    handleEnterDown(e: any): void;
    componentWillReceiveProps(nextProps: any, nextContext: any): void;
    componentWillUnmount(): void;
    renderWrapper(): ReactNode;
    showTooltip(e: any): boolean;
    renderOutput(): ReactNode;
}
