import { Component } from 'react';
import { Config, ConfigKeys, DefaultConfig } from '../../../lib/configure';
import { ResizeType } from '../text-area/enum';
import { IntlType } from './enum';
import Record from '../data-set/Record';
import { Lang } from '../locale-context/enum';
export interface IntlListProps {
    record?: Record;
    name?: string;
    lang: Lang;
    maxLengths?: object;
    disabled?: boolean;
    readOnly?: boolean;
    type?: IntlType;
    rows?: number;
    cols?: number;
    resize?: ResizeType;
    getConfig<T extends ConfigKeys>(key: T): T extends keyof DefaultConfig ? DefaultConfig[T] : Config[T];
}
export default class IntlList extends Component<IntlListProps> {
    renderOptions(): JSX.Element[];
    render(): JSX.Element;
}
