"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = confirm;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _react = _interopRequireDefault(require("react"));

var _noop = _interopRequireDefault(require("lodash/noop"));

var _modalManager = _interopRequireDefault(require("../modal-manager"));

var _Modal = _interopRequireDefault(require("./Modal"));

var _ModalContainer = require("../modal-container/ModalContainer");

var _icon = _interopRequireDefault(require("../icon"));

var _utils = require("./utils");

var _excluded = ["children", "type", "onOk", "onCancel", "onClose", "iconType", "border", "okCancel", "title"];

function confirm(_x) {
  return _confirm.apply(this, arguments);
}

function _confirm() {
  _confirm = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(props) {
    var container, _normalizeProps, children, _normalizeProps$type, type, _normalizeProps$onOk, _onOk, _normalizeProps$onCan, _onCancel, _normalizeProps$onClo, _onClose, iconType, _normalizeProps$borde, border, _normalizeProps$okCan, okCancel, title, otherProps, prefixCls, titleNode, contentNode, iconNode;

    return _regenerator["default"].wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return (0, _ModalContainer.getContainer)();

          case 2:
            container = _context4.sent;
            _normalizeProps = (0, _utils.normalizeProps)(props), children = _normalizeProps.children, _normalizeProps$type = _normalizeProps.type, type = _normalizeProps$type === void 0 ? 'confirm' : _normalizeProps$type, _normalizeProps$onOk = _normalizeProps.onOk, _onOk = _normalizeProps$onOk === void 0 ? _noop["default"] : _normalizeProps$onOk, _normalizeProps$onCan = _normalizeProps.onCancel, _onCancel = _normalizeProps$onCan === void 0 ? _noop["default"] : _normalizeProps$onCan, _normalizeProps$onClo = _normalizeProps.onClose, _onClose = _normalizeProps$onClo === void 0 ? _noop["default"] : _normalizeProps$onClo, iconType = _normalizeProps.iconType, _normalizeProps$borde = _normalizeProps.border, border = _normalizeProps$borde === void 0 ? false : _normalizeProps$borde, _normalizeProps$okCan = _normalizeProps.okCancel, okCancel = _normalizeProps$okCan === void 0 ? true : _normalizeProps$okCan, title = _normalizeProps.title, otherProps = (0, _objectWithoutProperties2["default"])(_normalizeProps, _excluded);
            prefixCls = container.context.getProPrefixCls('confirm');
            titleNode = title && /*#__PURE__*/_react["default"].createElement("div", {
              className: "".concat(prefixCls, "-title")
            }, title);
            contentNode = children && /*#__PURE__*/_react["default"].createElement("div", {
              className: "".concat(prefixCls, "-content")
            }, children);
            iconNode = iconType && /*#__PURE__*/_react["default"].createElement("td", {
              className: "".concat(prefixCls, "-icon ").concat(prefixCls, "-").concat(type)
            }, /*#__PURE__*/_react["default"].createElement(_icon["default"], {
              type: iconType
            }));
            return _context4.abrupt("return", new Promise(function (resolve) {
              _Modal["default"].open((0, _objectSpread2["default"])((0, _objectSpread2["default"])({
                key: _modalManager["default"].getKey(),
                className: "".concat(prefixCls, "-wrapper"),
                border: border,
                destroyOnClose: true,
                okCancel: okCancel,
                closable: false,
                movable: false,
                style: {
                  width: '4.16rem'
                },
                children: /*#__PURE__*/_react["default"].createElement("table", {
                  className: prefixCls
                }, /*#__PURE__*/_react["default"].createElement("tbody", null, /*#__PURE__*/_react["default"].createElement("tr", null, iconNode, /*#__PURE__*/_react["default"].createElement("td", null, titleNode, contentNode)))),
                onOk: function () {
                  var _onOk2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
                    var result;
                    return _regenerator["default"].wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            _context.next = 2;
                            return _onOk();

                          case 2:
                            result = _context.sent;

                            if (result !== false) {
                              resolve('ok');
                            }

                            return _context.abrupt("return", result);

                          case 5:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee);
                  }));

                  function onOk() {
                    return _onOk2.apply(this, arguments);
                  }

                  return onOk;
                }(),
                onCancel: function () {
                  var _onCancel2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
                    var result;
                    return _regenerator["default"].wrap(function _callee2$(_context2) {
                      while (1) {
                        switch (_context2.prev = _context2.next) {
                          case 0:
                            _context2.next = 2;
                            return _onCancel();

                          case 2:
                            result = _context2.sent;

                            if (result !== false) {
                              resolve('cancel');
                            }

                            return _context2.abrupt("return", result);

                          case 5:
                          case "end":
                            return _context2.stop();
                        }
                      }
                    }, _callee2);
                  }));

                  function onCancel() {
                    return _onCancel2.apply(this, arguments);
                  }

                  return onCancel;
                }(),
                onClose: function () {
                  var _onClose2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
                    var result;
                    return _regenerator["default"].wrap(function _callee3$(_context3) {
                      while (1) {
                        switch (_context3.prev = _context3.next) {
                          case 0:
                            _context3.next = 2;
                            return _onClose();

                          case 2:
                            result = _context3.sent;

                            if (result !== false) {
                              resolve('cancel');
                            }

                            return _context3.abrupt("return", result);

                          case 5:
                          case "end":
                            return _context3.stop();
                        }
                      }
                    }, _callee3);
                  }));

                  function onClose() {
                    return _onClose2.apply(this, arguments);
                  }

                  return onClose;
                }()
              }, otherProps), {}, {
                resizable: false
              }));
            }));

          case 9:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _confirm.apply(this, arguments);
}
//# sourceMappingURL=confirm.js.map
