import { ReactNode } from 'react';
import { TextField, TextFieldProps } from '../text-field/TextField';
export interface PasswordProps extends TextFieldProps {
    /**
     * 是否可揭示
     * @default true
     */
    reveal?: boolean;
}
export default class Password extends TextField<PasswordProps> {
    static displayName: string;
    static defaultProps: {
        suffixCls: string;
        reveal: boolean;
        clearButton: boolean;
        multiple: boolean;
        border: boolean;
        valueChangeAction: import("../text-field/enum").ValueChangeAction;
        waitType: import("../core/enum").WaitType;
        readOnly: boolean;
        disabled: boolean;
        noValidate: boolean;
        trim: import("../data-set/enum").FieldTrim;
    };
    type: string;
    revealIconFocus: boolean;
    reveal?: boolean;
    get multiple(): boolean;
    get range(): boolean;
    getOmitPropsKeys(): string[];
    getOtherPrevNode(): ReactNode;
    getInnerSpanButton(): ReactNode;
    select(): void;
    handleFocus(e: any): void;
    handleToggleReveal(e: any): void;
    doReveal(target: any): void;
    resetReveal(target: any): void;
}
