"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _utils = require("./utils");

var _TableContext = _interopRequireDefault(require("./TableContext"));

var _excluded = ["className", "width", "height", "top", "style", "isHeaderRow", "headerHeight", "rowRef", "classPrefix", "children", "rowDraggable", "provided", "snapshot"];
var propTypeKeys = ['width', 'height', 'headerHeight', 'top', 'isHeaderRow', 'rowDraggable', 'rowRef', 'className', 'classPrefix', 'style', 'provided', 'snapshot'];

var Row = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2["default"])(Row, _React$PureComponent);

  var _super = (0, _createSuper2["default"])(Row);

  function Row() {
    (0, _classCallCheck2["default"])(this, Row);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(Row, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          width = _this$props.width,
          height = _this$props.height,
          top = _this$props.top,
          style = _this$props.style,
          isHeaderRow = _this$props.isHeaderRow,
          headerHeight = _this$props.headerHeight,
          rowRef = _this$props.rowRef,
          classPrefix = _this$props.classPrefix,
          children = _this$props.children,
          rowDraggable = _this$props.rowDraggable,
          provided = _this$props.provided,
          snapshot = _this$props.snapshot,
          rest = (0, _objectWithoutProperties2["default"])(_this$props, _excluded);
      var addPrefix = (0, _utils.prefix)(classPrefix);
      var classes = (0, _classnames["default"])(classPrefix, className, (0, _defineProperty2["default"])({}, addPrefix('header'), isHeaderRow));
      var styles = (0, _objectSpread2["default"])({
        minWidth: width,
        height: isHeaderRow ? headerHeight : height
      }, style);
      var unhandledProps = (0, _utils.getUnhandledProps)(propTypeKeys, rest);
      return /*#__PURE__*/React.createElement(_TableContext["default"].Consumer, null, function (_ref) {
        var translateDOMPositionXY = _ref.translateDOMPositionXY;

        if (translateDOMPositionXY) {
          translateDOMPositionXY(styles, 0, top);
        }

        var providedProps = {};
        var transform = styles.transform;

        if (rowDraggable && provided) {
          var regex = new RegExp('translate\\((.*?)px, (.*?)px\\)');
          var regex3d = new RegExp('translate3d\\((.*?)px,(.*?)px,(.*?)\\)'); // the transform property of parent style gotten through reference and passed in as a prop

          var parentValues = regex3d.exec(styles.transform || '');
          var childValues = regex.exec(provided.draggableProps.style.transform || ''); // if both the parent (the nested list) and the child (item beeing dragged) has transform values, recalculate the child items transform to account for position fixed not working

          if (childValues != null && parentValues != null) {
            var x = parseFloat(childValues[1], 10);
            var y = parseFloat(childValues[2], 10);
            var p_x = parseFloat(parentValues[1], 10);
            var p_y = parseFloat(parentValues[2], 10);
            var p_z = parseFloat(parentValues[3], 10);
            transform = "translate3d(".concat(x + p_x, "px, ").concat(y + p_y, "px, ").concat(p_z, "px)");
          }

          (0, _extends2["default"])(providedProps, provided.draggableProps, provided.dragHandleProps);
          styles = (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, styles), {}, {
            top: 'auto !important',
            left: 'auto !important',
            cursor: 'move',
            transform: transform
          });
        }

        return /*#__PURE__*/React.createElement("div", (0, _extends2["default"])({}, providedProps, {
          role: "row"
        }, unhandledProps, {
          ref: rowRef,
          className: classes,
          style: styles
        }), children);
      });
    }
  }]);
  return Row;
}(React.PureComponent);

Row.defaultProps = {
  classPrefix: (0, _utils.defaultClassPrefix)('performance-table-row'),
  height: 46,
  headerHeight: 40
};
var _default = Row;
exports["default"] = _default;
//# sourceMappingURL=Row.js.map
