"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard")["default"];

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var _tslib = require("tslib");

var _react = _interopRequireWildcard(require("react"));

var _mobxReact = require("mobx-react");

var _isObject = _interopRequireDefault(require("lodash/isObject"));

var _Table = require("../Table");

var _TableContext = _interopRequireDefault(require("../TableContext"));

var _autobind = _interopRequireDefault(require("../../_util/autobind"));

var _utils = require("../../table/utils");

var _TableProfessionalBar = _interopRequireDefault(require("./TableProfessionalBar"));

var _TableDynamicFilterBar = _interopRequireDefault(require("./TableDynamicFilterBar"));

var PerformanceTableQueryBar = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(PerformanceTableQueryBar, _Component);

  var _super = (0, _createSuper2["default"])(PerformanceTableQueryBar);

  function PerformanceTableQueryBar() {
    (0, _classCallCheck2["default"])(this, PerformanceTableQueryBar);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(PerformanceTableQueryBar, [{
    key: "handleQueryReset",
    value: function handleQueryReset() {
      var queryDataSet = this.context.tableStore.dataSet.queryDataSet;

      if (queryDataSet) {
        var current = queryDataSet.current;

        if (current) {
          current.reset();
        }

        this.handleQuery();
      }
    }
  }, {
    key: "handleQuery",
    value: function () {
      var _handleQuery = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
        var _this$context, tableStore, _this$context$tableSt, dataSet, queryDataSet;

        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _this$context = this.context, tableStore = _this$context.tableStore, _this$context$tableSt = _this$context.tableStore, dataSet = _this$context$tableSt.dataSet, queryDataSet = _this$context$tableSt.dataSet.queryDataSet;

                if (!(tableStore.queryBar === _Table.TableQueryBarType.filterBar)) {
                  _context.next = 19;
                  break;
                }

                _context.next = 4;
                return dataSet.modifiedCheck(undefined, dataSet, 'query');

              case 4:
                _context.t2 = _context.sent;

                if (!_context.t2) {
                  _context.next = 7;
                  break;
                }

                _context.t2 = queryDataSet;

              case 7:
                _context.t1 = _context.t2;

                if (!_context.t1) {
                  _context.next = 10;
                  break;
                }

                _context.t1 = queryDataSet.current;

              case 10:
                _context.t0 = _context.t1;

                if (!_context.t0) {
                  _context.next = 15;
                  break;
                }

                _context.next = 14;
                return queryDataSet.current.validate();

              case 14:
                _context.t0 = _context.sent;

              case 15:
                if (!_context.t0) {
                  _context.next = 17;
                  break;
                }

                return _context.abrupt("return", dataSet.query());

              case 17:
                _context.next = 20;
                break;

              case 19:
                return _context.abrupt("return", dataSet.query());

              case 20:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function handleQuery() {
        return _handleQuery.apply(this, arguments);
      }

      return handleQuery;
    }()
  }, {
    key: "getQueryFields",
    value: function getQueryFields() {
      var _this$context$tableSt2 = this.context.tableStore,
          dataSet = _this$context$tableSt2.dataSet,
          _this$context$tableSt3 = _this$context$tableSt2.queryBar,
          _this$context$tableSt4 = _this$context$tableSt3.queryFields,
          queryFields = _this$context$tableSt4 === void 0 ? {} : _this$context$tableSt4,
          type = _this$context$tableSt3.type;
      var queryDataSet = dataSet.queryDataSet;
      var result = [];

      if (queryDataSet) {
        var fields = queryDataSet.fields,
            current = queryDataSet.current,
            _queryDataSet$props$f = queryDataSet.props.fields,
            propFields = _queryDataSet$props$f === void 0 ? [] : _queryDataSet$props$f;
        var cloneFields = fields.toJS();

        var processField = function processField(field, name) {
          if (!field.get('bind', current) && !name.includes('__tls')) {
            var element = queryFields[name];
            var filterBarProps = {};

            if (type === _Table.TableQueryBarType.filterBar) {
              var placeholder = /*#__PURE__*/(0, _react.isValidElement)(element) && element.props.placeholder ? element.props.placeholder : (0, _utils.getPlaceholderByField)(field, current);
              filterBarProps = {
                placeholder: placeholder,
                border: false,
                clearButton: true
              };
            }

            var props = (0, _objectSpread2["default"])({
              key: name,
              name: name,
              dataSet: queryDataSet,
              isFlat: type === _Table.TableQueryBarType.filterBar
            }, filterBarProps);
            result.push( /*#__PURE__*/(0, _react.isValidElement)(element) ? /*#__PURE__*/(0, _react.cloneElement)(element, props) : /*#__PURE__*/(0, _react.cloneElement)((0, _utils.getEditorByField)(field, current, type !== _Table.TableQueryBarType.professionalBar, type === _Table.TableQueryBarType.filterBar), (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, props), (0, _isObject["default"])(element) ? element : {})));
          }
        };

        propFields.forEach(function (_ref) {
          var name = _ref.name;

          if (name) {
            var field = cloneFields.get(name);

            if (field) {
              cloneFields["delete"](name);
              processField(field, name);
            }
          }
        });
        cloneFields.forEach(function (field, name) {
          processField(field, name);
        });
      }

      return result;
    }
  }, {
    key: "renderProfessionalBar",
    value: function renderProfessionalBar(props) {
      var prefixCls = this.context.tableStore.prefixCls;
      return /*#__PURE__*/_react["default"].createElement(_TableProfessionalBar["default"], (0, _extends2["default"])({
        key: "toolbar",
        prefixCls: prefixCls
      }, props));
    }
  }, {
    key: "renderDynamicFilterBar",
    value: function renderDynamicFilterBar(props) {
      var prefixCls = this.context.tableStore.prefixCls; // @ts-ignore

      return /*#__PURE__*/_react["default"].createElement(_TableDynamicFilterBar["default"], (0, _extends2["default"])({
        key: "toolbar",
        prefixCls: prefixCls
      }, props));
    }
  }, {
    key: "render",
    value: function render() {
      var _this$context$tableSt5 = this.context.tableStore,
          queryBar = _this$context$tableSt5.queryBar,
          dataSet = _this$context$tableSt5.dataSet;

      if (dataSet) {
        var queryFields = this.getQueryFields();
        var queryDataSet = dataSet.queryDataSet;
        var props = (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, queryBar), {}, {
          queryFields: queryFields,
          queryDataSet: queryDataSet
        });

        if (typeof queryBar.renderer === 'function') {
          return queryBar.renderer(props);
        }

        switch (queryBar.type) {
          case _Table.TableQueryBarType.professionalBar:
            return this.renderProfessionalBar(props);

          case _Table.TableQueryBarType.filterBar:
            return this.renderDynamicFilterBar(props);

          default:
        }
      }

      return null;
    }
  }], [{
    key: "contextType",
    get: function get() {
      return _TableContext["default"];
    }
  }]);
  return PerformanceTableQueryBar;
}(_react.Component);

PerformanceTableQueryBar.displayName = 'PerformanceTableQueryBar';
PerformanceTableQueryBar.defaultProps = {
  queryFieldsLimit: 3
};
(0, _tslib.__decorate)([_autobind["default"]], PerformanceTableQueryBar.prototype, "handleQueryReset", null);
(0, _tslib.__decorate)([_autobind["default"]], PerformanceTableQueryBar.prototype, "handleQuery", null);
PerformanceTableQueryBar = (0, _tslib.__decorate)([_mobxReact.observer], PerformanceTableQueryBar);
var _default = PerformanceTableQueryBar;
exports["default"] = _default;
//# sourceMappingURL=index.js.map
