import { ReactNode } from 'react';
import { SliderProps } from '../../../lib/slider';
import { NumberField } from '../number-field/NumberField';
export interface RangeProps extends SliderProps {
    /**
     *  是否垂直方向
     */
    vertical?: boolean;
    min?: number;
    max?: number;
    dots?: boolean;
    included?: boolean;
    range?: boolean;
    step?: number;
    defaultValue?: number | [number, number];
}
export default class Range extends NumberField<RangeProps> {
    static displayName: string;
    static defaultProps: {
        suffixCls: string;
        min: number;
        step: number;
        max: number;
        vertical: boolean;
        dots: boolean;
        marks: {};
        included: boolean;
        range: boolean;
        tipFormatter: null;
        longPressPlus: boolean;
        clearButton: boolean;
        multiple: boolean;
        border: boolean;
        valueChangeAction: import("../text-field/enum").ValueChangeAction;
        waitType: import("../core/enum").WaitType;
        readOnly: boolean;
        disabled: boolean;
        noValidate: boolean;
        trim: import("../data-set/enum").FieldTrim;
    };
    renderWrapper(): ReactNode;
    renderTrack(): JSX.Element;
}
