import React, { Component, Key } from 'react';
import { ColProps } from '../../../lib/col';
import noop from 'lodash/noop';
import { ElementProps } from '../core/ViewComponent';
import Record from '../data-set/Record';
export interface Info {
    key: string | number | undefined;
    value: any | Record;
}
export interface ColSize {
    span?: number;
    order?: number;
    offset?: number;
    push?: number;
    pull?: number;
}
export declare type ScreeningOptionProps = Omit<ElementProps, "lang" | "spellCheck"> & ColProps & {
    optionkey?: Key;
    selectedKeys?: Array<string | number | undefined>;
    onSelect?: (info: Info) => void;
    onClick?: (info: Info) => void;
    onDeselect?: (info: Info) => void;
    onMouseEnter?: (info: Info) => void;
    onMouseLeave?: (info: Info) => void;
    onMouseDown?: (info: Info) => void;
    disabled?: boolean;
    children?: React.ReactElement<any> | string;
    active?: boolean;
    multiple?: boolean;
    isSelected?: boolean;
    value?: any | Record;
    optionRender: React.ReactElement<any> | string;
};
export default class ScreeningOption extends Component<ScreeningOptionProps> {
    static displayName: 'ScreeningOption';
    static defaultProps: {
        onSelect: typeof noop;
        onMouseEnter: typeof noop;
        onMouseLeave: typeof noop;
        onMouseDown: typeof noop;
        isSelected: boolean;
    };
    onMouseLeave: () => void;
    onMouseEnter: () => void;
    onClick: () => void;
    render(): JSX.Element;
}
