"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard")["default"];

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

var _mobxReactLite = require("mobx-react-lite");

var _reactIntersectionObserver = require("react-intersection-observer");

var _UnitConvertor = require("../../../lib/_util/UnitConvertor");

var _TableContext = _interopRequireDefault(require("./TableContext"));

var _TableStore = require("./TableStore");

var _TableCell = _interopRequireDefault(require("./TableCell"));

var TableVirtualCell = function TableVirtualCell(props) {
  var _useContext = (0, _react.useContext)(_TableContext["default"]),
      node = _useContext.tableStore.node;

  var _useInView = (0, _reactIntersectionObserver.useInView)({
    root: node.tableBodyWrap || node.element,
    rootMargin: "".concat(_TableStore.VIRTUAL_ROOT_MARGIN, "px"),
    initialInView: true
  }),
      intersectionRef = _useInView.ref,
      inView = _useInView.inView,
      entry = _useInView.entry;

  var height = !inView && entry && entry.target.offsetParent ? (0, _UnitConvertor.pxToRem)(entry.boundingClientRect.height || entry.target.offsetHeight, true) : undefined;
  return /*#__PURE__*/_react["default"].createElement(_TableCell["default"], (0, _extends2["default"])({}, props, {
    intersectionRef: intersectionRef,
    inView: inView,
    virtualHeight: height
  }));
};

TableVirtualCell.displayName = 'TableVirtualCell';

var _default = (0, _mobxReactLite.observer)(TableVirtualCell);

exports["default"] = _default;
//# sourceMappingURL=TableVirtualCell.js.map
