"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _tslib = require("tslib");

var _mobx = require("mobx");

var _TableRowGroup = require("./TableRowGroup");

var VirtualRowMetaData = /*#__PURE__*/function () {
  function VirtualRowMetaData(store, type, prev, record) {
    var _this = this;

    (0, _classCallCheck2["default"])(this, VirtualRowMetaData);
    this.store = store;
    this.type = type;
    this.prev = prev;

    if (record !== undefined) {
      (0, _mobx.runInAction)(function () {
        _this.record = record;
      });
    }
  }

  (0, _createClass2["default"])(VirtualRowMetaData, [{
    key: "height",
    get: function get() {
      if (this.type === 'group') {
        return _TableRowGroup.ROW_GROUP_HEIGHT;
      }

      var actualHeight = this.actualHeight;

      if (actualHeight === undefined) {
        return this.store.virtualRowHeight;
      }

      return actualHeight;
    }
  }, {
    key: "offset",
    get: function get() {
      var prev = this.prev;

      if (prev) {
        return prev.offset + prev.height;
      }

      return 0;
    }
  }, {
    key: "setHeight",
    value: function setHeight(height) {
      this.actualHeight = height;
      this.aggregation = this.store.aggregation;
    }
  }]);
  return VirtualRowMetaData;
}();

exports["default"] = VirtualRowMetaData;
(0, _tslib.__decorate)([_mobx.observable], VirtualRowMetaData.prototype, "actualHeight", void 0);
(0, _tslib.__decorate)([_mobx.observable], VirtualRowMetaData.prototype, "record", void 0);
(0, _tslib.__decorate)([_mobx.computed], VirtualRowMetaData.prototype, "offset", null);
(0, _tslib.__decorate)([_mobx.action], VirtualRowMetaData.prototype, "setHeight", null);
//# sourceMappingURL=VirtualRowMetaData.js.map
