"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _mobxReactLite = require("mobx-react-lite");

var _Tree = _interopRequireDefault(require("../tree/Tree"));

var _SubGroups = _interopRequireDefault(require("./SubGroups"));

var _TableContext = _interopRequireDefault(require("../../TableContext"));

var Group = function Group(props) {
  var header = props.header,
      records = props.records,
      value = props.value,
      onDragEnd = props.onDragEnd,
      treeNodeRenderer = props.treeNodeRenderer,
      treeNodeSuffix = props.treeNodeSuffix;

  var _useContext = (0, _react.useContext)(_TableContext["default"]),
      prefixCls = _useContext.prefixCls;

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(prefixCls, "-customization-tree-group-header")
  }, header), /*#__PURE__*/_react["default"].createElement(_Tree["default"], {
    value: value
  }, /*#__PURE__*/_react["default"].createElement(_SubGroups["default"], {
    records: records,
    onDragEnd: onDragEnd,
    treeNodeRenderer: treeNodeRenderer,
    treeNodeSuffix: treeNodeSuffix
  })));
};

Group.displayName = 'Group';

var _default = (0, _mobxReactLite.observer)(Group);

exports["default"] = _default;
//# sourceMappingURL=Group.js.map
