"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TableColumnResizeTriggerType = exports.TableButtonType = exports.TableBoxSizing = exports.TableAutoHeightType = exports.SelectionMode = exports.ScrollPosition = exports.RowBoxPlacement = exports.HighLightRowType = exports.GroupType = exports.DragColumnAlign = exports.ColumnLock = exports.ColumnAlign = void 0;
Object.defineProperty(exports, "TableColumnTooltip", {
  enumerable: true,
  get: function get() {
    return _enum.Tooltip;
  }
});
exports.TableQueryBarType = exports.TablePaginationPosition = exports.TableMode = exports.TableHeightType = exports.TableEditMode = exports.TableCommandType = void 0;

var _enum = require("../core/enum");

var ColumnLock;
exports.ColumnLock = ColumnLock;

(function (ColumnLock) {
  ColumnLock["left"] = "left";
  ColumnLock["right"] = "right";
})(ColumnLock || (exports.ColumnLock = ColumnLock = {}));

var RowBoxPlacement;
exports.RowBoxPlacement = RowBoxPlacement;

(function (RowBoxPlacement) {
  RowBoxPlacement["start"] = "start";
  RowBoxPlacement["end"] = "end";
})(RowBoxPlacement || (exports.RowBoxPlacement = RowBoxPlacement = {}));

var ColumnAlign;
exports.ColumnAlign = ColumnAlign;

(function (ColumnAlign) {
  ColumnAlign["left"] = "left";
  ColumnAlign["center"] = "center";
  ColumnAlign["right"] = "right";
})(ColumnAlign || (exports.ColumnAlign = ColumnAlign = {}));

var DragColumnAlign;
exports.DragColumnAlign = DragColumnAlign;

(function (DragColumnAlign) {
  DragColumnAlign["left"] = "left";
  DragColumnAlign["right"] = "right";
})(DragColumnAlign || (exports.DragColumnAlign = DragColumnAlign = {}));

var ScrollPosition;
exports.ScrollPosition = ScrollPosition;

(function (ScrollPosition) {
  ScrollPosition["left"] = "left";
  ScrollPosition["right"] = "right";
  ScrollPosition["both"] = "both";
  ScrollPosition["middle"] = "middle";
})(ScrollPosition || (exports.ScrollPosition = ScrollPosition = {}));

var SelectionMode;
exports.SelectionMode = SelectionMode;

(function (SelectionMode) {
  SelectionMode["rowbox"] = "rowbox";
  SelectionMode["treebox"] = "treebox";
  SelectionMode["click"] = "click";
  SelectionMode["none"] = "none";
  SelectionMode["dblclick"] = "dblclick";
  SelectionMode["mousedown"] = "mousedown";
})(SelectionMode || (exports.SelectionMode = SelectionMode = {}));

var TableButtonType;
exports.TableButtonType = TableButtonType;

(function (TableButtonType) {
  TableButtonType["add"] = "add";
  TableButtonType["delete"] = "delete";
  TableButtonType["remove"] = "remove";
  TableButtonType["save"] = "save";
  TableButtonType["query"] = "query";
  TableButtonType["reset"] = "reset";
  TableButtonType["expandAll"] = "expandAll";
  TableButtonType["collapseAll"] = "collapseAll";
  TableButtonType["export"] = "export";
})(TableButtonType || (exports.TableButtonType = TableButtonType = {}));

var TableCommandType;
exports.TableCommandType = TableCommandType;

(function (TableCommandType) {
  TableCommandType["edit"] = "edit";
  TableCommandType["delete"] = "delete";
})(TableCommandType || (exports.TableCommandType = TableCommandType = {}));

var TableMode;
exports.TableMode = TableMode;

(function (TableMode) {
  TableMode["list"] = "list";
  TableMode["tree"] = "tree";
})(TableMode || (exports.TableMode = TableMode = {}));

var TableEditMode;
exports.TableEditMode = TableEditMode;

(function (TableEditMode) {
  TableEditMode["cell"] = "cell";
  TableEditMode["inline"] = "inline";
})(TableEditMode || (exports.TableEditMode = TableEditMode = {}));

var TableQueryBarType;
exports.TableQueryBarType = TableQueryBarType;

(function (TableQueryBarType) {
  TableQueryBarType["normal"] = "normal";
  TableQueryBarType["bar"] = "bar";
  TableQueryBarType["none"] = "none";
  TableQueryBarType["advancedBar"] = "advancedBar";
  TableQueryBarType["professionalBar"] = "professionalBar";
  TableQueryBarType["filterBar"] = "filterBar";
  TableQueryBarType["comboBar"] = "comboBar";
})(TableQueryBarType || (exports.TableQueryBarType = TableQueryBarType = {}));

var TablePaginationPosition;
exports.TablePaginationPosition = TablePaginationPosition;

(function (TablePaginationPosition) {
  TablePaginationPosition["top"] = "top";
  TablePaginationPosition["bottom"] = "bottom";
  TablePaginationPosition["both"] = "both";
})(TablePaginationPosition || (exports.TablePaginationPosition = TablePaginationPosition = {}));

var TableHeightType;
exports.TableHeightType = TableHeightType;

(function (TableHeightType) {
  TableHeightType["auto"] = "auto";
  TableHeightType["fixed"] = "fixed";
  TableHeightType["flex"] = "flex";
})(TableHeightType || (exports.TableHeightType = TableHeightType = {}));

var TableAutoHeightType;
exports.TableAutoHeightType = TableAutoHeightType;

(function (TableAutoHeightType) {
  TableAutoHeightType["maxHeight"] = "maxHeight";
  TableAutoHeightType["minHeight"] = "minHeight";
})(TableAutoHeightType || (exports.TableAutoHeightType = TableAutoHeightType = {}));

var HighLightRowType;
exports.HighLightRowType = HighLightRowType;

(function (HighLightRowType) {
  HighLightRowType["click"] = "click";
  HighLightRowType["focus"] = "focus";
})(HighLightRowType || (exports.HighLightRowType = HighLightRowType = {}));

var GroupType;
exports.GroupType = GroupType;

(function (GroupType) {
  GroupType["header"] = "header";
  GroupType["column"] = "column";
  GroupType["row"] = "row";
  GroupType["none"] = "none";
})(GroupType || (exports.GroupType = GroupType = {}));

var TableColumnResizeTriggerType;
exports.TableColumnResizeTriggerType = TableColumnResizeTriggerType;

(function (TableColumnResizeTriggerType) {
  TableColumnResizeTriggerType["hover"] = "hover";
  TableColumnResizeTriggerType["mouseDown"] = "mouseDown";
})(TableColumnResizeTriggerType || (exports.TableColumnResizeTriggerType = TableColumnResizeTriggerType = {}));

var TableBoxSizing;
exports.TableBoxSizing = TableBoxSizing;

(function (TableBoxSizing) {
  TableBoxSizing["content"] = "content";
  TableBoxSizing["wrapper"] = "wrapper";
})(TableBoxSizing || (exports.TableBoxSizing = TableBoxSizing = {}));
//# sourceMappingURL=enum.js.map
