"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.SELECTFIELDS = exports.SELECTCHANGE = exports.SEARCHTEXT = exports.SEARCHEXP = exports.ORIGINALVALUEOBJ = exports.OPTIONDATASET = exports.NEWFILTERDATASET = exports.MENURESULT = exports.MENUDATASET = exports.FILTERMENUDATASET = exports.EXPTYPE = exports.CONDITIONSTATUS = exports.CONDITIONDATASET = void 0;
exports.isEqualDynamicProps = isEqualDynamicProps;
exports.isSelect = isSelect;
exports.omitData = omitData;
exports.parseValue = parseValue;
exports.processFilterParam = processFilterParam;
exports.stringifyValue = stringifyValue;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _createForOfIteratorHelper2 = _interopRequireDefault(require("@babel/runtime/helpers/createForOfIteratorHelper"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectSpread3 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _tslib = require("tslib");

var _react = _interopRequireWildcard(require("react"));

var _mobxReact = require("mobx-react");

var _mobx = require("mobx");

var _uniq = _interopRequireDefault(require("lodash/uniq"));

var _pull = _interopRequireDefault(require("lodash/pull"));

var _noop = _interopRequireDefault(require("lodash/noop"));

var _map = _interopRequireDefault(require("lodash/map"));

var _isObject = _interopRequireDefault(require("lodash/isObject"));

var _isEmpty2 = _interopRequireDefault(require("lodash/isEmpty"));

var _isNumber = _interopRequireDefault(require("lodash/isNumber"));

var _isFunction = _interopRequireDefault(require("lodash/isFunction"));

var _isEqual = _interopRequireDefault(require("lodash/isEqual"));

var _isArray = _interopRequireDefault(require("lodash/isArray"));

var _isString = _interopRequireDefault(require("lodash/isString"));

var _omit = _interopRequireDefault(require("lodash/omit"));

var _defer = _interopRequireDefault(require("lodash/defer"));

var _difference = _interopRequireDefault(require("lodash/difference"));

var _isUndefined = _interopRequireDefault(require("lodash/isUndefined"));

var _isNil = _interopRequireDefault(require("lodash/isNil"));

var _classnames = _interopRequireDefault(require("classnames"));

var _ConfigContext = _interopRequireDefault(require("../../../../lib/config-provider/ConfigContext"));

var _utils = require("../../../../lib/configure/utils");

var _UnitConvertor = require("../../../../lib/_util/UnitConvertor");

var _icon = _interopRequireDefault(require("../../../../lib/icon"));

var _enum = require("../../../../lib/trigger/enum");

var _popover = _interopRequireDefault(require("../../../../lib/popover"));

var _tag = _interopRequireDefault(require("../../../../lib/tag"));

var _DataSet = _interopRequireDefault(require("../../data-set/DataSet"));

var _enum2 = require("../../data-set/enum");

var _button = _interopRequireDefault(require("../../button"));

var _dropdown = _interopRequireDefault(require("../../dropdown"));

var _textField = _interopRequireDefault(require("../../text-field"));

var _enum3 = require("../../text-field/enum");

var _tooltip = _interopRequireDefault(require("../../tooltip"));

var _enum4 = require("../../core/enum");

var _localeContext = require("../../locale-context");

var _autobind = _interopRequireDefault(require("../../_util/autobind"));

var _isEmpty3 = _interopRequireDefault(require("../../_util/isEmpty"));

var _FieldList = _interopRequireDefault(require("./FieldList"));

var _TableButtons = _interopRequireDefault(require("./TableButtons"));

var _ColumnFilter = _interopRequireDefault(require("./ColumnFilter"));

var _QuickFilterMenu = _interopRequireDefault(require("./quick-filter/QuickFilterMenu"));

var _QuickFilterMenuContext = _interopRequireDefault(require("./quick-filter/QuickFilterMenuContext"));

var _QuickFilterDataSet = require("./quick-filter/QuickFilterDataSet");

var _singleton = require("../../tooltip/singleton");

var _enum5 = require("../../field/enum");

var _utils2 = require("../../field/utils");

var _select = _interopRequireDefault(require("../../select"));

var _tree = _interopRequireDefault(require("../../tree"));

var _enum6 = require("../../button/enum");

var _Operator = require("./quick-filter/Operator");

var _utils3 = require("../utils");

var _enum7 = require("../../form/enum");

var _enum8 = require("../../trigger-field/enum");

var _excluded = ["fieldName", "value", "conditionType", "comparator"];

/**
 * 当前数据是否有值并需要选中
 * @param data
 */
function isSelect(data) {
  if ((0, _isObject["default"])(data[1])) {
    return !(0, _isEmpty2["default"])(data[1]);
  }

  return data[0] !== '__dirty' && !(0, _isEmpty3["default"])(data[1]);
}

function isEqualDynamicProps(originalValue, newValue, dataSet, record, name) {
  if ((0, _isEqual["default"])(newValue, originalValue)) {
    return true;
  }

  if ((0, _isObject["default"])(newValue) && (0, _isObject["default"])(originalValue) && Object.keys(newValue).length) {
    var combineKeys = (0, _uniq["default"])(Object.keys(newValue).concat(Object.keys(originalValue)));
    return combineKeys.every(function (key) {
      var value = (0, _mobx.toJS)(newValue[key]);
      var oldValue = (0, _mobx.toJS)(originalValue[key]);

      if (oldValue === value) {
        return true;
      }

      if ((0, _isEmpty3["default"])(oldValue) && (0, _isEmpty3["default"])(value)) {
        return true;
      }

      if (name && name.includes('.')) {
        return (0, _isEmpty3["default"])(oldValue) && (0, _isEmpty3["default"])(record.get(name));
      }

      if ((0, _isNumber["default"])(oldValue) || (0, _isNumber["default"])(value)) {
        var oEp = (0, _isNumber["default"])(oldValue) ? (0, _isEmpty3["default"])(oldValue) : (0, _isEmpty2["default"])(oldValue);
        var nEp = (0, _isNumber["default"])(value) ? (0, _isEmpty3["default"])(value) : (0, _isEmpty2["default"])(value);

        if (oEp && nEp) {
          return true;
        }

        return String(oldValue) === String(value);
      }

      var field = dataSet.getField(key);

      if (field && field.get('range', record)) {
        var rangeValue = value ? (0, _isArray["default"])(value) ? value.join('') : Object.values(value).join('') : '';
        var rangeOldValue = oldValue ? (0, _isArray["default"])(oldValue) ? oldValue.join('') : Object.values(oldValue).join('') : '';
        return rangeValue === rangeOldValue;
      }

      if (field && field.get('lovCode') && oldValue && value) {
        var valueField = dataSet.getField(key).get('valueField', record);
        var textField = dataSet.getField(key).get('textField', record);
        return value[valueField] === oldValue[valueField] && value[textField] === oldValue[textField];
      }

      return (0, _isEqual["default"])(oldValue, value);
    });
  }

  return (0, _isEqual["default"])(newValue, originalValue);
}
/**
 * 提交副本数据
 * @param data
 */


function omitData(data) {
  return (0, _omit["default"])(data, 'creationDate', 'createdBy', 'lastUpdateDate', 'lastUpdatedBy', 'objectVersionNumber', '_token', 'searchId', 'searchConditionId', 'searchQueryId', 'searchOrderId');
}
/**
 * obj 值使用 JSON 保存、获取赋值转化
 * @param value
 */


function parseValue(value) {
  try {
    var res = JSON.parse(value);

    if ((0, _typeof2["default"])(res) === 'object') {
      return res;
    }

    return value;
  } catch (e) {
    return value;
  }
}

function stringifyValue(value) {
  if ((0, _typeof2["default"])(value) === 'object') {
    return JSON.stringify(value);
  }

  return value;
}
/**
 * 处理查询过滤条件
 * @params
 */


function processFilterParam(dataSet) {
  var newFilterDataSet = dataSet.getState(NEWFILTERDATASET); // 处理公式参数

  var searchExp = '';
  var expType = dataSet.getState(EXPTYPE);

  if (expType !== 'customize') {
    var joinStr = expType === 'all' || expType === undefined ? 'AND' : 'OR';

    for (var i = 1; i <= newFilterDataSet.length; i++) {
      if (i === newFilterDataSet.length) {
        searchExp += i;
      } else {
        searchExp += i + joinStr;
      }
    }
  } else {
    searchExp = dataSet.getState(SEARCHEXP).toLocaleUpperCase().replace(/\s+/g, '');
  }

  dataSet.setQueryParameter('search.exp', searchExp); // 处理字段参数

  var searchFld = [];
  newFilterDataSet.map(function (record, index) {
    var dataObj = record.toData();
    var name = dataObj[_QuickFilterDataSet.AdvancedFieldSet.fieldName];
    var comparator = dataObj[_QuickFilterDataSet.AdvancedFieldSet.comparator];
    var tableName = newFilterDataSet.getField(name).get('help', record);
    var value = '';

    if ((0, _isObject["default"])(dataObj[name])) {
      if (!(0, _isArray["default"])(dataObj[name])) {
        value = dataObj[name][name];
      } else {
        value = dataObj[name].map(function (arr) {
          return (0, _isObject["default"])(arr) ? arr[name] : arr;
        });
      }
    } else {
      value = dataObj[name];
    }

    var paramFieldName = tableName ? "".concat(tableName, ".").concat(name) : name;
    var searchValue = [];

    if ([_Operator.OPERATOR.IS_NULL.value, _Operator.OPERATOR.IS_NOT_NULL.value].includes(comparator) || value) {
      var enCodeValue = (0, _isNumber["default"])(value) ? value : value ? encodeURIComponent(value) : value;
      searchValue = [index + 1, paramFieldName, dataObj[_QuickFilterDataSet.AdvancedFieldSet.comparator], enCodeValue].filter(Boolean);
    }

    if (searchValue && searchValue.length) {
      searchFld.push(searchValue.join('@'));
    }

    return null;
  });
  var searchFilParam = searchFld.join(',');
  dataSet.setQueryParameter('search.fld', searchFilParam);
}

var CONDITIONSTATUS = '__CONDITIONSTATUS__';
exports.CONDITIONSTATUS = CONDITIONSTATUS;
var SELECTFIELDS = '__SELECTFIELDS__';
exports.SELECTFIELDS = SELECTFIELDS;
var MENUDATASET = '__MENUDATASET__';
exports.MENUDATASET = MENUDATASET;
var CONDITIONDATASET = '__CONDITIONDATASET__';
exports.CONDITIONDATASET = CONDITIONDATASET;
var OPTIONDATASET = '__OPTIONDATASET__';
exports.OPTIONDATASET = OPTIONDATASET;
var FILTERMENUDATASET = '__FILTERMENUDATASET__';
exports.FILTERMENUDATASET = FILTERMENUDATASET;
var MENURESULT = '__MENURESULT__';
exports.MENURESULT = MENURESULT;
var SEARCHTEXT = '__SEARCHTEXT__';
exports.SEARCHTEXT = SEARCHTEXT;
var SELECTCHANGE = '__SELECTCHANGE__';
exports.SELECTCHANGE = SELECTCHANGE;
var EXPTYPE = '__EXPTYPE__';
exports.EXPTYPE = EXPTYPE;
var SEARCHEXP = '__SEARCHEXP__';
exports.SEARCHEXP = SEARCHEXP;
var NEWFILTERDATASET = '__NEWFILTERDATASET__';
exports.NEWFILTERDATASET = NEWFILTERDATASET;
var ORIGINALVALUEOBJ = '__ORIGINALVALUEOBJ__';
exports.ORIGINALVALUEOBJ = ORIGINALVALUEOBJ;

var TableDynamicFilterBar = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(TableDynamicFilterBar, _Component);

  var _super = (0, _createSuper2["default"])(TableDynamicFilterBar);

  function TableDynamicFilterBar(props, context) {
    var _this;

    (0, _classCallCheck2["default"])(this, TableDynamicFilterBar);
    _this = _super.call(this, props, context);
    _this.refAdvancedFilterContainer = null;
    _this.refDropdown = null;
    _this.refSingleWrapper = null;
    _this.refEditors = new Map();
    _this.refFilterItems = new Map();
    _this.refCustomizeExpTypeEditor = null;
    _this.originalConditionFields = [];

    _this.handleMouseDownOut = function (e) {
      if (_this.refDropdown && !_this.refDropdown.contains(e.target)) {
        _this.fieldSelectHidden = true;
      }
    };

    _this.setOriginalConditionFields = function (code) {
      var _this$props = _this.props,
          queryDataSet = _this$props.queryDataSet,
          dataSet = _this$props.dataSet;

      if (!code) {
        if (queryDataSet) {
          _this.initConditionFields({
            dataSet: queryDataSet,
            record: queryDataSet.get(0)
          });
        }
      } else {
        _this.originalConditionFields = Array.isArray(code) ? code : [code];
      }

      dataSet.setState(SELECTFIELDS, (0, _toConsumableArray2["default"])(_this.originalConditionFields));
    };
    /**
     * 勾选
     * @param code
     * @param record
     */


    _this.handleSelect = function (code, record) {
      var dataSet = _this.props.dataSet;
      var codes = Array.isArray(code) ? code : [code];
      var selectFields = dataSet.getState(SELECTFIELDS) || [];
      dataSet.setState(SELECTFIELDS, (0, _uniq["default"])([].concat((0, _toConsumableArray2["default"])(selectFields), (0, _toConsumableArray2["default"])(codes))));
      var shouldUpdate = dataSet.getState(SELECTFIELDS).length !== _this.originalConditionFields.length || !!(0, _difference["default"])((0, _mobx.toJS)(dataSet.getState(SELECTFIELDS)), (0, _mobx.toJS)(_this.originalConditionFields)).length;
      var isDirty = record ? record.dirty : false;

      _this.setConditionStatus(shouldUpdate || isDirty ? _enum2.RecordStatus.update : _enum2.RecordStatus.sync);

      dataSet.setState(SELECTCHANGE, shouldUpdate);
    };
    /**
     * 取消勾选
     * @param code
     */


    _this.handleUnSelect = function (code) {
      var _this$props2 = _this.props,
          queryDataSet = _this$props2.queryDataSet,
          dataSet = _this$props2.dataSet;
      var codes = Array.isArray(code) ? code : [code];
      var isDirty = false;

      if (queryDataSet) {
        var current = queryDataSet.current;

        if (current) {
          codes.forEach(function (name) {
            return current.set(name, undefined);
          });
          isDirty = current.dirty;
        }
      }

      var selectFields = dataSet.getState(SELECTFIELDS) || [];
      dataSet.setState(SELECTFIELDS, _pull["default"].apply(void 0, [(0, _toConsumableArray2["default"])(selectFields)].concat((0, _toConsumableArray2["default"])(codes))));
      var shouldUpdate = dataSet.getState(SELECTFIELDS).length !== _this.originalConditionFields.length || !!(0, _difference["default"])((0, _mobx.toJS)(dataSet.getState(SELECTFIELDS)), (0, _mobx.toJS)(_this.originalConditionFields)).length;

      _this.setConditionStatus(shouldUpdate || isDirty ? _enum2.RecordStatus.update : _enum2.RecordStatus.sync);

      dataSet.setState(SELECTCHANGE, shouldUpdate);
    };

    (0, _mobx.runInAction)(function () {
      _this.fieldSelectHidden = true;
      _this.expand = true;
    });
    return _this;
  }

  (0, _createClass2["default"])(TableDynamicFilterBar, [{
    key: "prefixCls",
    get: function get() {
      var prefixCls = this.props.prefixCls;
      var _this$context$getProP = this.context.getProPrefixCls,
          getProPrefixCls = _this$context$getProP === void 0 ? _utils.getProPrefixCls : _this$context$getProP;
      return getProPrefixCls('table', prefixCls);
    }
  }, {
    key: "queryFields",
    get: function get() {
      var _this$props3 = this.props,
          queryFields = _this$props3.queryFields,
          queryDataSet = _this$props3.queryDataSet,
          dataSet = _this$props3.dataSet;
      var menuDataSet = dataSet.getState(MENUDATASET);
      var isTenant = menuDataSet && menuDataSet.current && menuDataSet.current.get('isTenant');
      return queryFields.filter(function (component) {
        if (component.props.hidden) {
          return !component.props.hidden;
        }

        if (isTenant && queryDataSet && queryDataSet.getField(component.props.name)) {
          return queryDataSet.getField(component.props.name).get('fieldVisible') !== 0;
        }

        return !component.props.hidden;
      });
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      var _this$props4 = this.props,
          fuzzyQueryOnly = _this$props4.fuzzyQueryOnly,
          queryDataSet = _this$props4.queryDataSet,
          dataSet = _this$props4.dataSet;

      if (!fuzzyQueryOnly) {
        this.processDataSetListener(true);
        document.addEventListener('mousedown', this.handleMouseDownOut);

        if (this.isSingleLineOpt() && this.refSingleWrapper) {
          var _this$refSingleWrappe = this.refSingleWrapper.getBoundingClientRect(),
              height = _this$refSingleWrappe.height;

          var _this$refSingleWrappe2 = this.refSingleWrapper.children[0].children[0].getBoundingClientRect(),
              childHeight = _this$refSingleWrappe2.height;

          (0, _mobx.runInAction)(function () {
            _this2.showExpandIcon = height > childHeight + 18;
          });
        }

        var autoQuery = dataSet.props.autoQuery;

        if (!autoQuery || autoQuery && dataSet.status === _enum2.DataSetStatus.ready) {
          this.handleDataSetQuery({
            dataSet: dataSet
          });
        }
      }

      var shouldInit = dataSet.getState(ORIGINALVALUEOBJ) ? dataSet.getState(ORIGINALVALUEOBJ).query === undefined : true;

      if (shouldInit && queryDataSet && queryDataSet.current) {
        this.initConditionFields({
          dataSet: queryDataSet,
          record: queryDataSet.current
        });
      }

      if (queryDataSet && queryDataSet.current && !this.tableFilterAdapter) {
        dataSet.setState(CONDITIONSTATUS, queryDataSet.current.dirty ? _enum2.RecordStatus.update : _enum2.RecordStatus.sync);
      }

      this.setFilterVisiable();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var fuzzyQueryOnly = this.props.fuzzyQueryOnly;

      if (!fuzzyQueryOnly) {
        document.removeEventListener('mousedown', this.handleMouseDownOut);
        this.processDataSetListener(false);
      }

      if (this.isTooltipShown) {
        (0, _singleton.hide)();
        delete this.isTooltipShown;
      }
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var _this3 = this;

      var dataSet = nextProps.dataSet,
          fuzzyQueryOnly = nextProps.fuzzyQueryOnly,
          queryDataSet = nextProps.queryDataSet; // eslint-disable-next-line react/destructuring-assignment

      if (dataSet !== this.props.dataSet || fuzzyQueryOnly !== this.props.fuzzyQueryOnly) {
        (0, _mobx.runInAction)(function () {
          _this3.fieldSelectHidden = true;
          _this3.expand = true;
        });

        if (!fuzzyQueryOnly) {
          // 移除原有实例监听
          this.processDataSetListener(false);
          this.processDataSetListener(true, nextProps);

          if (this.isSingleLineOpt() && this.refSingleWrapper) {
            var _this$refSingleWrappe3 = this.refSingleWrapper.getBoundingClientRect(),
                height = _this$refSingleWrappe3.height;

            var _this$refSingleWrappe4 = this.refSingleWrapper.children[0].children[0].getBoundingClientRect(),
                childHeight = _this$refSingleWrappe4.height;

            (0, _mobx.runInAction)(function () {
              _this3.showExpandIcon = height > childHeight + 18;
            });
          }
        }

        var shouldInit = dataSet.getState(ORIGINALVALUEOBJ) ? dataSet.getState(ORIGINALVALUEOBJ).query === undefined : true;

        if (shouldInit && queryDataSet && queryDataSet.current) {
          this.initConditionFields({
            dataSet: queryDataSet,
            record: queryDataSet.current
          });
        }

        if (queryDataSet && queryDataSet.current && !this.tableFilterAdapter) {
          dataSet.setState(CONDITIONSTATUS, queryDataSet.current.dirty ? _enum2.RecordStatus.update : _enum2.RecordStatus.sync);
        }
      }
    }
  }, {
    key: "processDataSetListener",
    value: function processDataSetListener(flag, nextProps) {
      var _ref = nextProps || this.props,
          queryDataSet = _ref.queryDataSet,
          dataSet = _ref.dataSet;

      if (queryDataSet) {
        var handler = flag ? queryDataSet.addEventListener : queryDataSet.removeEventListener;
        var dsHandler = flag ? dataSet.addEventListener : dataSet.removeEventListener;
        handler.call(queryDataSet, _enum2.DataSetEvents.validate, this.handleDataSetValidate);
        handler.call(queryDataSet, _enum2.DataSetEvents.update, this.handleDataSetUpdate);
        handler.call(queryDataSet, _enum2.DataSetEvents.create, this.handleDataSetCreate);
        handler.call(queryDataSet, _enum2.DataSetEvents.reset, this.handleDataSetReset);
        handler.call(queryDataSet, _enum2.DataSetEvents.load, this.handleDataSetLoad);
        dsHandler.call(dataSet, _enum2.DataSetEvents.query, this.handleDataSetQuery);
      }
    }
  }, {
    key: "handleDataSetQuery",
    value: function () {
      var _handleDataSetQuery = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(_ref2) {
        var dataSet, res, defaultMenus, _ref3, conditionList, initQueryData, queryDataSet;

        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                dataSet = _ref2.dataSet;

                if (!(!dataSet.getState(MENURESULT) && this.tableFilterAdapter)) {
                  _context.next = 16;
                  break;
                }

                _context.next = 4;
                return this.initMenuDataSet();

              case 4:
                res = dataSet.getState(MENURESULT);

                if (!(res && res.length && res.filter(function (menu) {
                  return menu.defaultFlag;
                }).length)) {
                  _context.next = 16;
                  break;
                }

                defaultMenus = res.filter(function (menu) {
                  return menu.defaultFlag;
                });
                _ref3 = defaultMenus.length > 1 ? defaultMenus.find(function (menu) {
                  return menu.isTenant !== 1;
                }) : defaultMenus[0], conditionList = _ref3.conditionList;
                initQueryData = {};

                if (!(conditionList && conditionList.length)) {
                  _context.next = 16;
                  break;
                }

                (0, _map["default"])(conditionList, function (condition) {
                  if (condition.comparator === 'EQUAL') {
                    var fieldName = condition.fieldName,
                        value = condition.value;
                    initQueryData[fieldName] = parseValue(value);
                  }
                });
                queryDataSet = this.props.queryDataSet;

                if (!(queryDataSet && queryDataSet.current && dataSet.props.autoQuery)) {
                  _context.next = 16;
                  break;
                }

                if (!Object.keys(initQueryData).length) {
                  _context.next = 16;
                  break;
                }

                dataSet.query();
                return _context.abrupt("return", false);

              case 16:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function handleDataSetQuery(_x) {
        return _handleDataSetQuery.apply(this, arguments);
      }

      return handleDataSetQuery;
    }()
    /**
     * queryDataSet 查询前校验事件 触发展开动态字段
     * @param dataSet 查询DS
     * @param result
     */

  }, {
    key: "handleDataSetValidate",
    value: function () {
      var _handleDataSetValidate = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(_ref4) {
        var _this4 = this;

        var dataSet, result, refSingleWrapper;
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                dataSet = _ref4.dataSet, result = _ref4.result;
                _context2.next = 3;
                return result;

              case 3:
                if (_context2.sent) {
                  _context2.next = 7;
                  break;
                }

                (0, _mobx.runInAction)(function () {
                  var current = dataSet.current;
                  dataSet.fields.forEach(function (field, key) {
                    if (!field.isValid(current)) {
                      _this4.handleSelect(key);
                    }
                  });
                  _this4.expand = true;
                });
                refSingleWrapper = this.refSingleWrapper;

                if (refSingleWrapper) {
                  refSingleWrapper.style.height = '';
                  refSingleWrapper.style.overflow = '';
                }

              case 7:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function handleDataSetValidate(_x2) {
        return _handleDataSetValidate.apply(this, arguments);
      }

      return handleDataSetValidate;
    }()
  }, {
    key: "setConditionStatus",
    value: function setConditionStatus(value, orglValue) {
      var dataSet = this.props.dataSet;
      dataSet.setState(CONDITIONSTATUS, value);

      if (value === _enum2.RecordStatus.sync && orglValue) {
        var oriObj = dataSet.getState(ORIGINALVALUEOBJ);
        dataSet.setState(ORIGINALVALUEOBJ, (0, _objectSpread3["default"])((0, _objectSpread3["default"])({}, oriObj), {}, {
          query: orglValue
        }));
      }
    }
    /**
     * 筛选条件更新 触发表格查询
     */

  }, {
    key: "handleDataSetUpdate",
    value: function () {
      var _handleDataSetUpdate = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(_ref5) {
        var record, name, oldValue, value, _this$props5, dataSet, queryDataSet, _this$props5$onQuery, onQuery, autoQuery, field, shouldQuery, rangeKeys, _record$set, _record$set2, rangeValue, rangeOldValue, status, hasFocus, i, queryField, editor;

        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                record = _ref5.record, name = _ref5.name, oldValue = _ref5.oldValue, value = _ref5.value;
                _this$props5 = this.props, dataSet = _this$props5.dataSet, queryDataSet = _this$props5.queryDataSet, _this$props5$onQuery = _this$props5.onQuery, onQuery = _this$props5$onQuery === void 0 ? _noop["default"] : _this$props5$onQuery, autoQuery = _this$props5.autoQuery;
                field = queryDataSet && queryDataSet.getField(name);
                shouldQuery = true;

                if (field && field.get('range', record)) {
                  // 处理 range 失焦对象 undefined，bind 字段无处理的情况
                  if (value) {
                    rangeKeys = Object.keys(value);

                    if (rangeKeys.length) {
                      if (value[rangeKeys[0]] === undefined && value[rangeKeys[1]] === undefined) {
                        record.set(name, null);
                      } else if (value[rangeKeys[1]] === undefined) {
                        record.set(name, (_record$set = {}, (0, _defineProperty2["default"])(_record$set, rangeKeys[0], value[rangeKeys[0]]), (0, _defineProperty2["default"])(_record$set, rangeKeys[1], null), _record$set));
                      } else if (value[rangeKeys[0]] === undefined) {
                        record.set(name, (_record$set2 = {}, (0, _defineProperty2["default"])(_record$set2, rangeKeys[0], null), (0, _defineProperty2["default"])(_record$set2, rangeKeys[1], value[rangeKeys[1]]), _record$set2));
                      }
                    }
                  }

                  rangeValue = value ? (0, _isArray["default"])(value) ? value.join('') : Object.values(value).join('') : '';
                  rangeOldValue = oldValue ? (0, _isArray["default"])(oldValue) ? oldValue.join('') : Object.values(oldValue).join('') : '';
                  shouldQuery = rangeValue !== rangeOldValue;
                }

                status = _enum2.RecordStatus.update;

                if (record) {
                  this.handleSelect(name, record);
                  status = isEqualDynamicProps(dataSet.getState(ORIGINALVALUEOBJ).query, (0, _omit["default"])(record.toData(), ['__dirty']), queryDataSet, record, name) ? _enum2.RecordStatus.sync : _enum2.RecordStatus.update;
                }

                this.setConditionStatus(status);

                if (!(autoQuery && shouldQuery)) {
                  _context3.next = 27;
                  break;
                }

                _context3.next = 11;
                return dataSet.modifiedCheck(undefined, dataSet, 'query');

              case 11:
                if (!_context3.sent) {
                  _context3.next = 26;
                  break;
                }

                _context3.t0 = queryDataSet && queryDataSet.current;

                if (!_context3.t0) {
                  _context3.next = 17;
                  break;
                }

                _context3.next = 16;
                return queryDataSet.current.validate();

              case 16:
                _context3.t0 = _context3.sent;

              case 17:
                if (!_context3.t0) {
                  _context3.next = 22;
                  break;
                }

                dataSet.query();
                onQuery();
                _context3.next = 24;
                break;

              case 22:
                hasFocus = false;

                for (i = 0; i < this.queryFields.length; i++) {
                  queryField = this.queryFields[i];
                  editor = this.refEditors.get(String(queryField.key));

                  if (editor && !editor.valid && !hasFocus && field && !field.get('multiple', record)) {
                    editor.focus();
                    hasFocus = true;
                  }
                }

              case 24:
                _context3.next = 27;
                break;

              case 26:
                record.init(name, oldValue);

              case 27:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function handleDataSetUpdate(_x3) {
        return _handleDataSetUpdate.apply(this, arguments);
      }

      return handleDataSetUpdate;
    }()
    /**
     * queryDS 新建，初始勾选值
     */

  }, {
    key: "handleDataSetCreate",
    value: function handleDataSetCreate() {
      var queryDataSet = this.props.queryDataSet;

      if (queryDataSet) {
        this.initConditionFields({
          dataSet: queryDataSet,
          record: queryDataSet.current
        });
      }
    }
    /**
     * queryDS reset，初始记录
     */

  }, {
    key: "handleDataSetReset",
    value: function handleDataSetReset() {
      var queryDataSet = this.props.queryDataSet;

      if (queryDataSet && !this.tableFilterAdapter) {
        queryDataSet.create();
      }
    }
    /**
     * queryDS load，兼容项目loadData([])的处理，初始化记录
     */

  }, {
    key: "handleDataSetLoad",
    value: function handleDataSetLoad(_ref6) {
      var dataSet = _ref6.dataSet;

      if (!this.tableFilterAdapter && !dataSet.length) {
        dataSet.create();
      }
    }
    /**
     * 初始化勾选值、条件字段
     * @param props
     */

  }, {
    key: "initConditionFields",
    value: function initConditionFields(props) {
      var _this5 = this;

      var dataSet = props.dataSet,
          record = props.record;
      var tableDS = this.props.dataSet;
      var originalValue = (0, _omit["default"])(record.toData(), ['__dirty']);
      var conditionData = Object.entries(originalValue);
      var newObj = tableDS.getState(ORIGINALVALUEOBJ) || {};
      tableDS.setState(ORIGINALVALUEOBJ, (0, _objectSpread3["default"])((0, _objectSpread3["default"])({}, newObj), {}, {
        query: originalValue
      }));
      this.originalConditionFields = [];
      var fields = dataSet.fields;
      (0, _map["default"])(conditionData, function (data) {
        var name = data[0];

        if (!fields.has(data[0]) && (0, _isObject["default"])(data[1]) && !(0, _isEmpty2["default"])(data[1]) && !(0, _isArray["default"])(data[1])) {
          name = "".concat(data[0], ".").concat(Object.keys(data[1])[0]);
        }

        if (isSelect(data) && !(dataSet.getState(SELECTFIELDS) || []).includes(name)) {
          var field = dataSet.getField(name);

          if (!field || !field.get('bind', record) || field.get('usedFlag')) {
            _this5.originalConditionFields.push(name);

            _this5.handleSelect(name, record);
          }
        }
      });
    }
    /**
     * 高级搜索字段集
     */

  }, {
    key: "advancedSearchFieldProps",
    get: function get() {
      var _this$props6 = this.props,
          queryDataSet = _this$props6.queryDataSet,
          dataSet = _this$props6.dataSet,
          advancedSearchFields = _this$props6.advancedSearchFields;

      if (advancedSearchFields && advancedSearchFields.length) {
        var omitPropsArr = ['dynamicProps', 'computedProps', 'order', 'pattern', 'maxLength', 'minLength', 'max', 'min', 'validator', 'required', 'readOnly', 'disabled', 'defaultValue', 'cascadeMap', 'ignore'];
        return advancedSearchFields.map(function (field) {
          var name = field.name,
              source = field.source,
              alias = field.alias,
              tableName = field.tableName,
              _field$fieldProps = field.fieldProps,
              fieldProps = _field$fieldProps === void 0 ? {} : _field$fieldProps;
          var fieldName = alias || name;

          var dynamicRequired = function dynamicRequired(_ref7) {
            var record = _ref7.record;
            var isNullOperater = [_Operator.OPERATOR.IS_NULL.value, _Operator.OPERATOR.IS_NOT_NULL.value].includes(record.get(_QuickFilterDataSet.AdvancedFieldSet.comparator));

            if (fieldName === record.get(_QuickFilterDataSet.AdvancedFieldSet.fieldName) && !isNullOperater) {
              return true;
            }

            return false;
          };

          var required = fieldProps.required,
              computedProps = fieldProps.computedProps;
          if (required) delete fieldProps.required;
          if (computedProps && 'required' in computedProps) delete computedProps.required;

          if (fieldProps.dynamicProps) {
            fieldProps.dynamicProps.required = dynamicRequired;
          } else {
            fieldProps.dynamicProps = {
              required: dynamicRequired
            };
          }

          if (source === 'fields' && dataSet.props.fields) {
            var dsFiedlsProps = dataSet.props.fields.find(function (f) {
              return f.name === name;
            });
            return (0, _objectSpread3["default"])((0, _objectSpread3["default"])((0, _objectSpread3["default"])({}, (0, _omit["default"])(dsFiedlsProps, omitPropsArr)), fieldProps), {}, {
              help: tableName,
              name: fieldName
            });
          }

          if (source === 'queryFields' && queryDataSet && queryDataSet.props.fields) {
            var _dsFiedlsProps = queryDataSet.props.fields.find(function (f) {
              return f.name === name;
            });

            return (0, _objectSpread3["default"])((0, _objectSpread3["default"])((0, _objectSpread3["default"])({}, (0, _omit["default"])(_dsFiedlsProps, omitPropsArr)), fieldProps), {}, {
              help: tableName,
              name: fieldName
            });
          }

          return (0, _objectSpread3["default"])((0, _objectSpread3["default"])({}, fieldProps), {}, {
            // multiple: fieldProps && fieldProps.multiple ? '|' : false,
            help: tableName,
            name: fieldName
          });
        });
      }

      return [];
    }
    /**
    * 加载动态筛选条相关初始数据 & 存储初始值
    *  1.筛选条
    *  2.高级搜索
    *  3.模糊搜索
    * @param param
    */

  }, {
    key: "loadConditionData",
    value: function loadConditionData(_ref8) {
      var conditionDataSet = _ref8.conditionDataSet,
          newFilterDataSet = _ref8.newFilterDataSet,
          menuRecord = _ref8.menuRecord,
          dataSet = _ref8.dataSet,
          searchText = _ref8.searchText;
      var comparatorData = [];
      var regularData = [];
      var newObj = dataSet.getState(ORIGINALVALUEOBJ) || {};
      var searchTextValue = null;
      menuRecord.get('conditionList').forEach(function (condition) {
        if (condition.conditionType !== 'comparator') {
          regularData.push(condition);
        } else {
          var _objectSpread2;

          var fieldName = condition.fieldName,
              value = condition.value,
              conditionType = condition.conditionType,
              comparator = condition.comparator,
              rest = (0, _objectWithoutProperties2["default"])(condition, _excluded);
          comparatorData.push((0, _objectSpread3["default"])((_objectSpread2 = {}, (0, _defineProperty2["default"])(_objectSpread2, _QuickFilterDataSet.AdvancedFieldSet.fieldName, fieldName), (0, _defineProperty2["default"])(_objectSpread2, fieldName, value), (0, _defineProperty2["default"])(_objectSpread2, _QuickFilterDataSet.AdvancedFieldSet.conditionType, conditionType), (0, _defineProperty2["default"])(_objectSpread2, _QuickFilterDataSet.AdvancedFieldSet.comparator, comparator), _objectSpread2), rest));
        }
      }); // 加载筛选条数据

      conditionDataSet.loadData(regularData); // 加载高级搜索面板数据

      newFilterDataSet.loadData(comparatorData); // 初始高级搜索

      dataSet.setState(ORIGINALVALUEOBJ, (0, _objectSpread3["default"])((0, _objectSpread3["default"])({}, newObj), {}, {
        advance: comparatorData
      })); // 加载模糊搜索数据

      if (menuRecord && menuRecord.get('queryList') && menuRecord.get('queryList').length) {
        var searchObj = menuRecord.get('queryList').find(function (ql) {
          return ql.fieldName === SEARCHTEXT;
        });
        searchTextValue = searchObj ? searchObj.value : null;
        dataSet.setState(SEARCHTEXT, searchTextValue); // 初始模糊搜索

        dataSet.setState(ORIGINALVALUEOBJ, (0, _objectSpread3["default"])((0, _objectSpread3["default"])({}, newObj), {}, {
          advance: comparatorData,
          fuzzy: searchTextValue
        }));
        dataSet.setQueryParameter(searchText, searchTextValue);
      }
    }
    /**
     * 初始筛选条数据源状态
     */

  }, {
    key: "initMenuDataSet",
    value: function () {
      var _initMenuDataSet = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4() {
        var _this6 = this;

        var _this$props7, queryDataSet, dataSet, dynamicFilterBar, searchCode, getConfig, searchCodes, menuDataSet, conditionDataSet, newFilterDataSet, optionDataSet, filterMenuDataSet, status, result, menuRecord, current;

        return _regenerator["default"].wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _this$props7 = this.props, queryDataSet = _this$props7.queryDataSet, dataSet = _this$props7.dataSet, dynamicFilterBar = _this$props7.dynamicFilterBar, searchCode = _this$props7.searchCode;
                getConfig = this.context.getConfig;
                searchCodes = dynamicFilterBar && dynamicFilterBar.searchCode || searchCode;

                if (!this.tableFilterAdapter) {
                  _context4.next = 25;
                  break;
                }

                menuDataSet = new _DataSet["default"]((0, _QuickFilterDataSet.QuickFilterDataSet)({
                  searchCode: searchCodes,
                  queryDataSet: queryDataSet,
                  tableFilterAdapter: this.tableFilterAdapter
                }), {
                  getConfig: getConfig
                });
                conditionDataSet = new _DataSet["default"]((0, _QuickFilterDataSet.ConditionDataSet)(), {
                  getConfig: getConfig
                });
                newFilterDataSet = new _DataSet["default"]((0, _QuickFilterDataSet.NewFilterDataSet)({
                  propFields: this.advancedSearchFieldProps
                }), {
                  getConfig: getConfig
                });
                optionDataSet = new _DataSet["default"]({
                  paging: false,
                  selection: _enum2.DataSetSelection.single,
                  fields: [{
                    // 是否租户默认配置
                    name: 'isTenant',
                    type: _enum2.FieldType.string,
                    transformResponse: function transformResponse(value) {
                      return value ? (0, _localeContext.$l)('Table', 'preset') : (0, _localeContext.$l)('Table', 'user');
                    },
                    group: true
                  }]
                }, {
                  getConfig: getConfig
                });
                filterMenuDataSet = new _DataSet["default"]({
                  autoCreate: true,
                  fields: [{
                    name: 'filterName',
                    type: _enum2.FieldType.string,
                    textField: 'searchName',
                    valueField: 'searchId',
                    options: optionDataSet,
                    ignore: _enum2.FieldIgnore.always
                  }]
                }, {
                  getConfig: getConfig
                });
                status = _enum2.RecordStatus.update;

                if (queryDataSet && queryDataSet.current && dataSet.getState(ORIGINALVALUEOBJ)) {
                  status = isEqualDynamicProps(dataSet.getState(ORIGINALVALUEOBJ).query, (0, _omit["default"])(queryDataSet.current.toData(), ['__dirty']), queryDataSet, queryDataSet.current) ? _enum2.RecordStatus.sync : _enum2.RecordStatus.update;
                } else {
                  status = _enum2.RecordStatus.sync;
                } // 初始化状态


                dataSet.setState(MENUDATASET, menuDataSet);
                dataSet.setState(CONDITIONDATASET, conditionDataSet);
                dataSet.setState(NEWFILTERDATASET, newFilterDataSet);
                dataSet.setState(OPTIONDATASET, optionDataSet);
                dataSet.setState(FILTERMENUDATASET, filterMenuDataSet);
                dataSet.setState(CONDITIONSTATUS, status); // dataSet.setState(SEARCHTEXT, null);

                _context4.next = 19;
                return menuDataSet.query();

              case 19:
                result = _context4.sent;
                dataSet.setState(MENURESULT, result);

                if (optionDataSet) {
                  optionDataSet.loadData(result);
                }

                menuRecord = menuDataSet.current;

                if (menuRecord) {
                  this.loadConditionData({
                    menuRecord: menuRecord,
                    conditionDataSet: conditionDataSet,
                    newFilterDataSet: newFilterDataSet,
                    dataSet: dataSet,
                    searchText: this.searchText
                  });
                }

                if (result && result.length) {
                  (0, _mobx.runInAction)(function () {
                    _this6.shouldLocateData = true;
                  });

                  if (queryDataSet && queryDataSet.fields && !this.tempFields) {
                    this.tempFields = queryDataSet.snapshot().dataSet.fields;
                  }
                } else {
                  current = filterMenuDataSet.current;
                  if (current) current.set('filterName', undefined);
                  (0, _mobx.runInAction)(function () {
                    _this6.shouldLocateData = true;
                  });
                }

              case 25:
                return _context4.abrupt("return", true);

              case 26:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function initMenuDataSet() {
        return _initMenuDataSet.apply(this, arguments);
      }

      return initMenuDataSet;
    }()
    /**
     * tableFilterSuffix 预留自定义区域
     */

  }, {
    key: "renderSuffix",
    value: function renderSuffix() {
      var _this$props8 = this.props,
          dynamicFilterBar = _this$props8.dynamicFilterBar,
          queryDataSet = _this$props8.queryDataSet,
          dataSet = _this$props8.dataSet,
          _this$props8$buttons = _this$props8.buttons,
          buttons = _this$props8$buttons === void 0 ? [] : _this$props8$buttons;
      var getConfig = this.context.getConfig;
      var prefixCls = this.prefixCls;
      var suffixes = dynamicFilterBar && dynamicFilterBar.suffixes || getConfig('tableFilterSuffix');
      var children = [];
      var suffixesDom = null;
      var tableButtons = buttons.length ? /*#__PURE__*/_react["default"].createElement(_TableButtons["default"], {
        key: "".concat(buttons.length, "-toolbar"),
        prefixCls: "".concat(prefixCls, "-dynamic-filter"),
        buttons: buttons
      }) : null;

      if (suffixes && suffixes.length) {
        suffixes.forEach(function (suffix) {
          if (suffix === 'filter') {
            children.push( /*#__PURE__*/_react["default"].createElement(_ColumnFilter["default"], {
              prefixCls: prefixCls
            }));
          } else if ( /*#__PURE__*/(0, _react.isValidElement)(suffix)) {
            children.push(suffix);
          } else if ((0, _isFunction["default"])(suffix)) {
            children.push(suffix({
              queryDataSet: queryDataSet,
              dataSet: dataSet
            }));
          }
        });
        suffixesDom = /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-dynamic-filter-bar-suffix")
        }, children);
      }

      return [tableButtons, suffixesDom];
    }
  }, {
    key: "getPrefix",
    value: function getPrefix() {
      var _this$props9 = this.props,
          dynamicFilterBar = _this$props9.dynamicFilterBar,
          queryDataSet = _this$props9.queryDataSet,
          dataSet = _this$props9.dataSet;
      var prefixCls = this.prefixCls;
      var prefixes = dynamicFilterBar && dynamicFilterBar.prefixes;
      var children = [];

      if (prefixes && prefixes.length) {
        prefixes.forEach(function (prefix) {
          if ((0, _isString["default"])(prefix) && prefix === 'filter') {
            children.push( /*#__PURE__*/_react["default"].createElement(_ColumnFilter["default"], {
              prefixCls: prefixCls
            }));
          } else if ( /*#__PURE__*/(0, _react.isValidElement)(prefix)) {
            children.push(prefix);
          } else if ((0, _isFunction["default"])(prefix)) {
            children.push(prefix({
              queryDataSet: queryDataSet,
              dataSet: dataSet
            }));
          }
        });
        return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-dynamic-filter-bar-prefix")
        }, children), /*#__PURE__*/_react["default"].createElement("span", {
          className: "".concat(prefixCls, "-filter-search-divide")
        }));
      }

      return null;
    }
    /**
     * 注入 refEditors
     * @param element
     * @param name
     */

  }, {
    key: "createFields",
    value: function createFields(element, name) {
      var _this7 = this;

      var props = {
        ref: function ref(node) {
          return _this7.refEditors.set(name, node);
        },
        border: false,
        clearButton: true,
        _inTable: true,
        showValidation: 'tooltip'
      };

      if ((0, _isUndefined["default"])(element.props.suffix) && ['Currency', 'ObserverNumberField', 'EmailField', 'UrlField', 'ObserverTextField'].includes(element.type.name)) {
        (0, _extends2["default"])(props, {
          suffix: /*#__PURE__*/_react["default"].createElement(_icon["default"], {
            type: "search"
          })
        });
      }

      return /*#__PURE__*/(0, _react.cloneElement)(element, props);
    }
    /**
     * 判断查询值是否为空
     * @param value
     */

  }, {
    key: "isEmpty",
    value: function isEmpty(value) {
      return (0, _mobx.isArrayLike)(value) ? !value.length : (0, _isEmpty3["default"])(value);
    }
  }, {
    key: "tableFilterAdapter",
    get: function get() {
      var _this$props10 = this.props,
          dynamicFilterBar = _this$props10.dynamicFilterBar,
          searchCode = _this$props10.searchCode;
      var getConfig = this.context.getConfig;
      var searchCodes = dynamicFilterBar && dynamicFilterBar.searchCode || searchCode;
      return searchCodes ? dynamicFilterBar && dynamicFilterBar.tableFilterAdapter || getConfig('tableFilterAdapter') : null;
    }
    /**
     * 是否单行操作
     */

  }, {
    key: "isSingleLineOpt",
    value: function isSingleLineOpt() {
      var fuzzyQuery = this.props.fuzzyQuery;
      return !(fuzzyQuery || this.tableFilterAdapter);
    }
    /**
     * 查询前修改提示及校验定位
     */

  }, {
    key: "modifiedCheckQuery",
    value: function () {
      var _modifiedCheckQuery = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5(fuzzyValue, fuzzyOldValue, refresh) {
        var _this$props11, dataSet, queryDataSet, fuzzyQueryOnly, _this$props11$onRefre, onRefresh, hasFocus, _iterator, _step, _step$value, key, value;

        return _regenerator["default"].wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _this$props11 = this.props, dataSet = _this$props11.dataSet, queryDataSet = _this$props11.queryDataSet, fuzzyQueryOnly = _this$props11.fuzzyQueryOnly, _this$props11$onRefre = _this$props11.onRefresh, onRefresh = _this$props11$onRefre === void 0 ? _noop["default"] : _this$props11$onRefre;
                _context5.next = 3;
                return dataSet.modifiedCheck(undefined, dataSet, 'query');

              case 3:
                if (!_context5.sent) {
                  _context5.next = 30;
                  break;
                }

                _context5.t1 = queryDataSet && queryDataSet.current;

                if (!_context5.t1) {
                  _context5.next = 9;
                  break;
                }

                _context5.next = 8;
                return queryDataSet.current.validate();

              case 8:
                _context5.t1 = _context5.sent;

              case 9:
                _context5.t0 = _context5.t1;

                if (_context5.t0) {
                  _context5.next = 12;
                  break;
                }

                _context5.t0 = fuzzyQueryOnly;

              case 12:
                if (!_context5.t0) {
                  _context5.next = 25;
                  break;
                }

                if (fuzzyValue) {
                  (0, _mobx.runInAction)(function () {
                    dataSet.setState(SEARCHTEXT, fuzzyValue || null);
                  });
                  dataSet.setQueryParameter(this.searchText, fuzzyValue);
                }

                if (!refresh) {
                  _context5.next = 22;
                  break;
                }

                _context5.next = 17;
                return onRefresh();

              case 17:
                _context5.t2 = _context5.sent;

                if (!(_context5.t2 !== false)) {
                  _context5.next = 20;
                  break;
                }

                dataSet.query();

              case 20:
                _context5.next = 23;
                break;

              case 22:
                dataSet.query();

              case 23:
                _context5.next = 28;
                break;

              case 25:
                hasFocus = false;
                _iterator = (0, _createForOfIteratorHelper2["default"])(this.refEditors.entries());

                try {
                  for (_iterator.s(); !(_step = _iterator.n()).done;) {
                    _step$value = (0, _slicedToArray2["default"])(_step.value, 2), key = _step$value[0], value = _step$value[1];

                    if (value && !value.valid && !hasFocus) {
                      this.refEditors.get(key).focus();
                      hasFocus = true;
                    }
                  }
                } catch (err) {
                  _iterator.e(err);
                } finally {
                  _iterator.f();
                }

              case 28:
                _context5.next = 32;
                break;

              case 30:
                (0, _mobx.runInAction)(function () {
                  dataSet.setState(SEARCHTEXT, fuzzyOldValue || null);
                });
                dataSet.setQueryParameter(this.searchText, fuzzyOldValue);

              case 32:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function modifiedCheckQuery(_x4, _x5, _x6) {
        return _modifiedCheckQuery.apply(this, arguments);
      }

      return modifiedCheckQuery;
    }()
  }, {
    key: "renderRefreshBtn",
    value: function renderRefreshBtn() {
      var _this8 = this;

      var prefixCls = this.prefixCls;
      return /*#__PURE__*/_react["default"].createElement("span", {
        className: "".concat(prefixCls, "-filter-menu-query"),
        onClick: function () {
          var _onClick = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6(e) {
            return _regenerator["default"].wrap(function _callee6$(_context6) {
              while (1) {
                switch (_context6.prev = _context6.next) {
                  case 0:
                    e.stopPropagation();
                    _context6.next = 3;
                    return _this8.modifiedCheckQuery(undefined, undefined, true);

                  case 3:
                  case "end":
                    return _context6.stop();
                }
              }
            }, _callee6);
          }));

          function onClick(_x7) {
            return _onClick.apply(this, arguments);
          }

          return onClick;
        }()
      }, /*#__PURE__*/_react["default"].createElement(_tooltip["default"], {
        title: (0, _localeContext.$l)('Table', 'refresh')
      }, /*#__PURE__*/_react["default"].createElement(_icon["default"], {
        type: "refresh"
      })));
    }
    /**
     * 渲染展开逻辑
     * @param hidden 是否隐藏全部
     */

  }, {
    key: "getExpandNode",
    value: function getExpandNode(hidden) {
      var _this9 = this;

      var prefixCls = this.prefixCls,
          refreshBtn = this.props.refreshBtn;
      if (!this.showExpandIcon && !hidden) return refreshBtn ? this.renderRefreshBtn() : null;
      return /*#__PURE__*/_react["default"].createElement("span", {
        className: "".concat(prefixCls, "-filter-menu-expand"),
        onClick: function onClick() {
          var refSingleWrapper = _this9.refSingleWrapper;

          if (refSingleWrapper) {
            var _refSingleWrapper$get = refSingleWrapper.getBoundingClientRect(),
                height = _refSingleWrapper$get.height;

            var _refSingleWrapper$chi = refSingleWrapper.children[0].children[0].getBoundingClientRect(),
                childHeight = _refSingleWrapper$chi.height;

            (0, _mobx.runInAction)(function () {
              _this9.expand = hidden ? height <= 0 : height <= childHeight + 18;
            });

            if (hidden && height) {
              // 收起全部
              refSingleWrapper.style.display = 'none';
            } else {
              refSingleWrapper.style.display = 'flex';
              refSingleWrapper.style.height = '';
              refSingleWrapper.style.overflow = '';
            }

            if (height > childHeight + 18 && !hidden) {
              // 收起留一行高度
              refSingleWrapper.style.height = (0, _UnitConvertor.pxToRem)(childHeight + 18, true) || '';
              refSingleWrapper.style.overflow = 'hidden';
            } else {
              refSingleWrapper.style.height = '';
              refSingleWrapper.style.overflow = '';
            }
          }
        }
      }, refreshBtn ? this.renderRefreshBtn() : null, this.expand ? /*#__PURE__*/_react["default"].createElement(_tooltip["default"], {
        title: (0, _localeContext.$l)('Table', 'collapse')
      }, /*#__PURE__*/_react["default"].createElement(_icon["default"], {
        type: "baseline-arrow_drop_up"
      })) : /*#__PURE__*/_react["default"].createElement(_tooltip["default"], {
        title: (0, _localeContext.$l)('Table', 'expand_button')
      }, /*#__PURE__*/_react["default"].createElement(_icon["default"], {
        type: "baseline-arrow_drop_down"
      })));
    }
    /**
     * 过滤比较符
     * @param record
     * @param optionRecord
     * @returns
     */

  }, {
    key: "optionsFilter",
    value: function optionsFilter(record, optionRecord) {
      if (!record.get(_QuickFilterDataSet.AdvancedFieldSet.fieldName)) return false;
      var dataSet = this.props.dataSet;
      var newFilterDataSet = dataSet.getState(NEWFILTERDATASET);
      var field = newFilterDataSet.getField(record.get(_QuickFilterDataSet.AdvancedFieldSet.fieldName), record);
      var type = field.get('type', record);

      var value = _Operator.OPERATOR[optionRecord.get('value').toUpperCase()];

      if (!_Operator.OPERATOR_TYPE[type.toUpperCase()]) {
        return _Operator.OPERATOR_TYPE.STRING.includes(value);
      }

      if (field.get('lookupCode', record) || (0, _isString["default"])(field.get('lookupUrl', record)) || type !== _enum2.FieldType.object && (field.get('lovCode', record) || field.getLookup(record) || field.get('options', record))) {
        return _Operator.OPERATOR_TYPE.LOOKUP.includes(value);
      }

      if (field.get('lovCode', record)) {
        return _Operator.OPERATOR_TYPE.LOV.includes(value);
      }

      return _Operator.OPERATOR_TYPE[type.toUpperCase()].includes(value);
    }
    /**
     * 高级筛选弹窗确认
     */

  }, {
    key: "handleFilterOk",
    value: function () {
      var _handleFilterOk = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee8() {
        var _this10 = this;

        var _this$props12, dataSet, autoQuery, newFilterDataSet, res, customizeExpTypeValidation;

        return _regenerator["default"].wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                _this$props12 = this.props, dataSet = _this$props12.dataSet, autoQuery = _this$props12.autoQuery;
                newFilterDataSet = dataSet.getState(NEWFILTERDATASET);
                _context8.next = 4;
                return newFilterDataSet.validate();

              case 4:
                res = _context8.sent;
                _context8.t0 = !this.refCustomizeExpTypeEditor;

                if (_context8.t0) {
                  _context8.next = 10;
                  break;
                }

                _context8.next = 9;
                return this.refCustomizeExpTypeEditor.checkValidity();

              case 9:
                _context8.t0 = _context8.sent;

              case 10:
                customizeExpTypeValidation = _context8.t0;

                if (res && customizeExpTypeValidation) {
                  (0, _mobx.runInAction)( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee7() {
                    var jsonData, status;
                    return _regenerator["default"].wrap(function _callee7$(_context7) {
                      while (1) {
                        switch (_context7.prev = _context7.next) {
                          case 0:
                            // 初始状态下移除空行
                            if (newFilterDataSet.length !== 1) {
                              newFilterDataSet.map(function (r) {
                                if (!r.get(_QuickFilterDataSet.AdvancedFieldSet.fieldName)) {
                                  newFilterDataSet.remove(r, true);
                                }

                                return null;
                              });
                            }

                            jsonData = newFilterDataSet.toJSONData();
                            processFilterParam(dataSet);
                            status = isEqualDynamicProps((0, _mobx.toJS)(dataSet.getState(ORIGINALVALUEOBJ).advance), jsonData, newFilterDataSet) ? dataSet.getState(CONDITIONSTATUS) : _enum2.RecordStatus.update; // 更新筛选条状态

                            _this10.setConditionStatus(status);

                            if (autoQuery) dataSet.query();
                            _this10.visible = false;

                          case 7:
                          case "end":
                            return _context7.stop();
                        }
                      }
                    }, _callee7);
                  })));
                }

              case 12:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function handleFilterOk() {
        return _handleFilterOk.apply(this, arguments);
      }

      return handleFilterOk;
    }()
    /**
     * 高级筛选弹窗取消
     */

  }, {
    key: "handleFilterCancel",
    value: function handleFilterCancel() {
      var _this11 = this;

      var dataSet = this.props.dataSet;
      var newFilterDataSet = dataSet.getState(NEWFILTERDATASET);
      var orgValue = dataSet.getState(ORIGINALVALUEOBJ).advance;
      newFilterDataSet.loadData(orgValue);
      this.setConditionStatus(dataSet.getState(CONDITIONSTATUS));
      (0, _mobx.runInAction)(function () {
        if (_this11.refCustomizeExpTypeEditor && _this11.refCustomizeExpTypeEditor.validationResults && _this11.refCustomizeExpTypeEditor.validationResults.length > 0) {
          _this11.refCustomizeExpTypeEditor.validationResults = undefined;
        }

        _this11.visible = false;
      });
    }
  }, {
    key: "setFilterVisiable",
    value: function setFilterVisiable() {
      var _this12 = this;

      (0, _mobx.autorun)(function () {
        if (_this12.visible) {
          document.addEventListener('mousedown', _this12.handleEmitFilterCancel);
          document.addEventListener('keydown', _this12.handleEmitFilterCancel);
        } else {
          document.removeEventListener('mousedown', _this12.handleEmitFilterCancel);
          document.removeEventListener('keydown', _this12.handleEmitFilterCancel);
        }
      });
    }
  }, {
    key: "isPopupChildren",
    value: function isPopupChildren(element) {
      var getConfig = this.context.getConfig;
      var proPreCls = getConfig('proPrefixCls');
      var popupClasses = ["".concat(proPreCls, "-popup"), "".concat(proPreCls, "-modal")];
      var hasPopupClass = popupClasses.some(function (cls) {
        return element && element.className.includes(cls);
      });

      if (hasPopupClass) {
        return true;
      }

      if (!hasPopupClass && element && element.parentElement && element.parentElement !== document.body) {
        return this.isPopupChildren(element.parentElement);
      }

      return false;
    }
  }, {
    key: "handleEmitFilterCancel",
    value: function handleEmitFilterCancel(e) {
      var target = e.target,
          type = e.type;

      switch (type) {
        case 'mousedown':
          {
            var _this$refAdvancedFilt;

            var container = (_this$refAdvancedFilt = this.refAdvancedFilterContainer) === null || _this$refAdvancedFilt === void 0 ? void 0 : _this$refAdvancedFilt.getPopupDomNode();
            var keepVisible = target === container || container.contains(target) || this.isPopupChildren(target);

            if (!keepVisible) {
              this.handleFilterCancel();
            }

            break;
          }

        case 'keydown':
          {
            if (e instanceof KeyboardEvent && (e.ctrlKey || e.metaKey) && e.key === '/') {
              this.handleFilterCancel();
            }

            break;
          }

        default:
          break;
      }
    }
  }, {
    key: "saveCustomizeExpTypeEditorRef",
    value: function saveCustomizeExpTypeEditorRef(node) {
      this.refCustomizeExpTypeEditor = node;
    }
  }, {
    key: "saveAdvancedFilterContainerRef",
    value: function saveAdvancedFilterContainerRef(node) {
      this.refAdvancedFilterContainer = node;
    }
    /**
     * 渲染高级筛选面板
     */

  }, {
    key: "getAdvancedFilter",
    value: function getAdvancedFilter() {
      var _this13 = this;

      var prefixCls = this.prefixCls,
          getConfig = this.context.getConfig;
      var _this$props13 = this.props,
          dataSet = _this$props13.dataSet,
          advancedSearchFields = _this$props13.advancedSearchFields;
      var tlsKey = getConfig('tlsKey');
      var newFilterDataSet = dataSet.getState(NEWFILTERDATASET);
      var menuDataSet = dataSet.getState(MENUDATASET);

      if (advancedSearchFields && advancedSearchFields.length && newFilterDataSet) {
        var _getConfig = this.context.getConfig;
        var selectOptions = this.advancedSearchFieldProps.map(function (fieldProps) {
          var name = fieldProps.name,
              label = fieldProps.label,
              bind = fieldProps.bind;
          if (bind) return null;
          var field = newFilterDataSet.getField(name);

          var hasBindProps = function hasBindProps(propsName) {
            return field && field.get(propsName) && field.get(propsName).bind;
          };

          if (field.get('bind') || hasBindProps('computedProps') || hasBindProps('dynamicProps') || field.get('name').includes(tlsKey)) {
            return null;
          }

          return /*#__PURE__*/_react["default"].createElement(_select["default"].Option, {
            key: "".concat(name, "_select_option"),
            value: name
          }, label || name);
        });

        var PopoverContent = /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_tooltip["default"], {
          theme: "light",
          title: dataSet.getState(EXPTYPE) === 'customize' ? (0, _localeContext.$l)('Table', 'ad_search_help') : null
        }, /*#__PURE__*/_react["default"].createElement(_select["default"], {
          isFlat: true,
          border: true,
          // dataSet={menuDataSet.current}
          // name="conExpression"
          value: dataSet.getState(EXPTYPE) ? dataSet.getState(EXPTYPE) : ['all', 'either'].includes(menuDataSet.current && menuDataSet.current.get('conExpression')) ? menuDataSet.current.get('conExpression') : "all",
          onChange: function onChange(value) {
            dataSet.setState(EXPTYPE, value);

            if (value !== 'customize') {
              dataSet.setState(SEARCHEXP, undefined);
            }

            if (menuDataSet.current) {
              menuDataSet.current.set('conExpression', value);
            }
          },
          clearButton: false,
          className: "".concat(prefixCls, "-new-filter-popover-select"),
          trigger: [_enum.Action.click, _enum.Action.focus]
        }, /*#__PURE__*/_react["default"].createElement(_select["default"].Option, {
          value: "all"
        }, (0, _localeContext.$l)('Table', 'ad_search_all')), /*#__PURE__*/_react["default"].createElement(_select["default"].Option, {
          value: "either"
        }, (0, _localeContext.$l)('Table', 'ad_search_any')), /*#__PURE__*/_react["default"].createElement(_select["default"].Option, {
          value: "customize"
        }, (0, _localeContext.$l)('Table', 'ad_search_custom'), /*#__PURE__*/_react["default"].createElement(_tooltip["default"], {
          theme: "light",
          title: (0, _localeContext.$l)('Table', 'ad_search_help')
        }, /*#__PURE__*/_react["default"].createElement(_icon["default"], {
          className: "".concat(prefixCls, "-new-filter-popover-select-icon"),
          type: "help_outline"
        }))))), dataSet.getState(EXPTYPE) === 'customize' ? /*#__PURE__*/_react["default"].createElement(_textField["default"], {
          ref: this.saveCustomizeExpTypeEditorRef,
          clearButton: true,
          validator: function validator(value) {
            return (0, _isNil["default"])(value) ? (0, _localeContext.$l)('Table', 'ad_search_validation') : true;
          },
          value: dataSet.getState(SEARCHEXP) ? dataSet.getState(SEARCHEXP) : menuDataSet.current && menuDataSet.current.get('conExpression') !== 'customize' ? menuDataSet.current.get('conExpression') : undefined,
          onChange: function onChange(value) {
            dataSet.setState(SEARCHEXP, value);

            if (menuDataSet.current) {
              menuDataSet.current.set('conExpression', value);
            }
          },
          className: (0, _classnames["default"])("".concat(prefixCls, "-new-filter-popover-input"), "".concat(_getConfig('proPrefixCls'), "-input-required"), "".concat(_getConfig('proPrefixCls'), "-input-required-colors")),
          placeholder: (0, _localeContext.$l)('Table', 'ad_search_placeholder'),
          showValidation: _enum7.ShowValidation.tooltip
        }) : null, newFilterDataSet.length > 0 && /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-new-filter-popover-line")
        }), /*#__PURE__*/_react["default"].createElement(_tree["default"], {
          key: "__filter",
          dataSet: newFilterDataSet,
          showLine: {
            showLeafIcon: false
          },
          className: "".concat(prefixCls, "-new-filter-popover-tree"),
          onTreeNode: function onTreeNode() {
            return {
              className: "".concat(prefixCls, "-new-filter-popover-tree-node")
            };
          },
          showIcon: true,
          icon: function icon(props) {
            return /*#__PURE__*/_react["default"].createElement(_tag["default"], {
              className: "".concat(prefixCls, "-new-filter-popover-item-tag")
            }, Number(props.pos.split('0-')[1]) + 1);
          },
          renderer: function renderer(_ref10) {
            var record = _ref10.record;
            if (!record) return null;
            var comparator = record.get(_QuickFilterDataSet.AdvancedFieldSet.comparator);
            var fieldName = record.get(_QuickFilterDataSet.AdvancedFieldSet.fieldName);
            var field = record.getField(fieldName);
            var disabled = [_Operator.OPERATOR.IS_NULL.value, _Operator.OPERATOR.IS_NOT_NULL.value].includes(comparator);

            var valueFieldDom = /*#__PURE__*/_react["default"].createElement(_textField["default"], {
              style: {
                width: 192
              },
              disabled: true
            });

            if (field && !field.get('bind', record) && !fieldName.includes(tlsKey)) {
              var editor = (0, _utils3.getEditorByField)(field, record, true);
              var shouldUseClick = false;

              if ('viewMode' in editor.props && editor.props.viewMode === _enum8.TriggerViewMode.popup) {
                shouldUseClick = true;
              }

              var fieldValue = record.get(fieldName);
              var maxTagTextLength = field.get('multiple') && fieldValue && fieldValue.length > 1 ? 3 : 7;
              valueFieldDom = /*#__PURE__*/(0, _react.cloneElement)(editor, {
                help: '',
                key: fieldName,
                name: fieldName,
                record: record,
                style: {
                  width: 192
                },
                disabled: disabled,
                showValidation: _enum7.ShowValidation.tooltip,
                trigger: shouldUseClick ? [_enum.Action.click, _enum.Action.focus] : undefined,
                maxTagCount: 1,
                maxTagTextLength: maxTagTextLength,
                maxTagPlaceholder: function maxTagPlaceholder(restValues) {
                  return "+".concat(restValues.length);
                }
              });
            }

            return /*#__PURE__*/_react["default"].createElement("div", {
              className: "".concat(prefixCls, "-new-filter-popover-item"),
              key: "".concat(record.index, "_option")
            }, /*#__PURE__*/_react["default"].createElement(_select["default"], {
              name: _QuickFilterDataSet.AdvancedFieldSet.fieldName,
              style: {
                width: 120
              },
              record: record,
              placeholder: (0, _localeContext.$l)('Lov', 'choose'),
              optionTooltip: _enum4.Tooltip.overflow,
              trigger: [_enum.Action.click, _enum.Action.focus],
              showValidation: _enum7.ShowValidation.tooltip
            }, selectOptions), /*#__PURE__*/_react["default"].createElement(_select["default"], {
              name: _QuickFilterDataSet.AdvancedFieldSet.comparator,
              renderer: function renderer(_ref11) {
                var value = _ref11.value,
                    text = _ref11.text;
                return value ? (0, _localeContext.$l)('Operator', value.toLowerCase()) : text;
              },
              optionRenderer: function optionRenderer(_ref12) {
                var value = _ref12.value,
                    text = _ref12.text;
                return value ? (0, _localeContext.$l)('Operator', value.toLowerCase()) : text;
              },
              style: {
                width: 88
              },
              dropdownMatchSelectWidth: false,
              optionTooltip: _enum4.Tooltip.overflow,
              record: record,
              disabled: !record.get(_QuickFilterDataSet.AdvancedFieldSet.fieldName),
              optionsFilter: function optionsFilter(optionRecord) {
                return _this13.optionsFilter(record, optionRecord);
              },
              trigger: [_enum.Action.click, _enum.Action.focus],
              showValidation: _enum7.ShowValidation.tooltip
            }), valueFieldDom, /*#__PURE__*/_react["default"].createElement(_button["default"], {
              funcType: _enum6.FuncType.link,
              icon: "delete_black-o",
              color: _enum6.ButtonColor.primary,
              onClick: function onClick() {
                if (newFilterDataSet.length === 1) {
                  newFilterDataSet.removeAll();
                } else {
                  newFilterDataSet.remove(record);
                }
              }
            }));
          }
        }), /*#__PURE__*/_react["default"].createElement(_button["default"], {
          funcType: _enum6.FuncType.link,
          icon: "add",
          color: _enum6.ButtonColor.primary,
          onClick: function onClick() {
            newFilterDataSet.create();
          }
        }, (0, _localeContext.$l)('Table', 'ad_search_add')), /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-new-filter-popover-footer")
        }, /*#__PURE__*/_react["default"].createElement(_button["default"], {
          onClick: this.handleFilterCancel
        }, (0, _localeContext.$l)('Modal', 'cancel')), /*#__PURE__*/_react["default"].createElement(_button["default"], {
          onClick: this.handleFilterOk,
          color: _enum6.ButtonColor.primary
        }, (0, _localeContext.$l)('Modal', 'ok'))));

        return /*#__PURE__*/_react["default"].createElement(_popover["default"], {
          title: (0, _localeContext.$l)('Table', 'ad_search_title'),
          content: PopoverContent,
          overlayClassName: "".concat(prefixCls, "-new-filter-popover"),
          trigger: "click",
          visible: this.visible,
          ref: this.saveAdvancedFilterContainerRef
        }, /*#__PURE__*/_react["default"].createElement(_button["default"], {
          funcType: _enum6.FuncType.link,
          className: "".concat(prefixCls, "-new-filter-popover-icon"),
          icon: "filter2",
          color: newFilterDataSet && newFilterDataSet.some(function (r) {
            return r.status !== 'sync';
          }) ? _enum6.ButtonColor.primary : _enum6.ButtonColor.dark,
          onClick: function onClick() {
            if (!newFilterDataSet.length) {
              newFilterDataSet.create();
            }

            (0, _mobx.runInAction)(function () {
              _this13.visible = true;
            });
          }
        }));
      }

      return null;
    }
    /**
     * 渲染模糊搜索
     */

  }, {
    key: "getFuzzyQuery",
    value: function getFuzzyQuery() {
      var _this14 = this;

      var _this$props14 = this.props,
          dataSet = _this$props14.dataSet,
          fuzzyQuery = _this$props14.fuzzyQuery,
          fuzzyQueryPlaceholder = _this$props14.fuzzyQueryPlaceholder,
          _this$props14$onReset = _this$props14.onReset,
          onReset = _this$props14$onReset === void 0 ? _noop["default"] : _this$props14$onReset;
      var prefixCls = this.prefixCls;
      var placeholder = fuzzyQueryPlaceholder || (0, _localeContext.$l)('Table', 'enter_search_content');
      var fuzzyValue = dataSet.getState(ORIGINALVALUEOBJ) && dataSet.getState(ORIGINALVALUEOBJ).fuzzy;
      if (!fuzzyQuery) return null;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-filter-search")
      }, /*#__PURE__*/_react["default"].createElement(_textField["default"], {
        style: {
          width: 280
        },
        clearButton: true,
        placeholder: placeholder,
        prefix: /*#__PURE__*/_react["default"].createElement(_icon["default"], {
          type: "search"
        }),
        value: dataSet.getState(SEARCHTEXT),
        valueChangeAction: _enum3.ValueChangeAction.input,
        waitType: _enum4.WaitType.debounce,
        wait: 500,
        onChange: function onChange(value, oldValue) {
          _this14.handleQuery(undefined, value, oldValue);

          dataSet.setState(SEARCHTEXT, value);
          dataSet.setQueryParameter(_this14.searchText, value);

          _this14.setConditionStatus(value === fuzzyValue ? _enum2.RecordStatus.sync : _enum2.RecordStatus.update);
        },
        onClear: function onClear() {
          (0, _mobx.runInAction)(function () {
            dataSet.setState(SEARCHTEXT, null);
          });
          onReset();
        }
      }));
    }
    /**
     * 渲染重置按钮
     */

  }, {
    key: "getResetButton",
    value: function getResetButton() {
      var _this15 = this;

      var _this$props15 = this.props,
          queryDataSet = _this$props15.queryDataSet,
          dataSet = _this$props15.dataSet,
          autoQueryAfterReset = _this$props15.autoQueryAfterReset,
          _this$props15$onReset = _this$props15.onReset,
          onReset = _this$props15$onReset === void 0 ? _noop["default"] : _this$props15$onReset;
      var prefixCls = this.prefixCls;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-filter-buttons")
      }, dataSet.getState(CONDITIONSTATUS) === _enum2.RecordStatus.update && /*#__PURE__*/_react["default"].createElement(_button["default"], {
        onClick: function onClick() {
          var shouldQuery = false;

          if (queryDataSet) {
            var current = queryDataSet.current;

            if (current) {
              var orgObj = dataSet.getState(ORIGINALVALUEOBJ);
              shouldQuery = dataSet.getState(SEARCHTEXT) !== orgObj.fuzzy || !isEqualDynamicProps(orgObj.query, (0, _omit["default"])(current.toData(), ['__dirty']), queryDataSet, current);
              dataSet.setState(SEARCHTEXT, orgObj.fuzzy);
              dataSet.setQueryParameter(_this15.searchText, orgObj.fuzzy);
              current.reset();
              dataSet.setState(SELECTFIELDS, (0, _toConsumableArray2["default"])(_this15.originalConditionFields));
            }
          }

          _this15.setConditionStatus(_enum2.RecordStatus.sync);

          onReset();

          if (autoQueryAfterReset && shouldQuery) {
            _this15.handleQuery();
          }
        }
      }, (0, _localeContext.$l)('Table', 'reset_button')));
    }
    /**
     * 筛选头
     * fuzzyQuery + quickFilterMenu + resetButton + buttons
     */

  }, {
    key: "getFilterMenu",
    value: function getFilterMenu() {
      var _this$props16 = this.props,
          defaultActiveKey = _this$props16.defaultActiveKey,
          queryFields = _this$props16.queryFields,
          queryDataSet = _this$props16.queryDataSet,
          dataSet = _this$props16.dataSet,
          dynamicFilterBar = _this$props16.dynamicFilterBar,
          searchCode = _this$props16.searchCode,
          autoQuery = _this$props16.autoQuery,
          fuzzyQueryOnly = _this$props16.fuzzyQueryOnly,
          sortableFieldNames = _this$props16.sortableFieldNames;
      var prefixCls = this.prefixCls;
      var prefix = this.getPrefix();
      var suffix = this.renderSuffix();
      var fuzzyQuery = this.getFuzzyQuery();
      var advancedFilter = this.getAdvancedFilter();

      if (fuzzyQueryOnly) {
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-filter-menu")
        }, prefix, advancedFilter, fuzzyQuery, suffix);
      }

      if (queryDataSet && queryFields.length) {
        var searchCodes = dynamicFilterBar && dynamicFilterBar.searchCode || searchCode;
        var quickFilterMenu = this.tableFilterAdapter && searchCodes ? /*#__PURE__*/_react["default"].createElement(_QuickFilterMenuContext["default"].Provider, {
          value: {
            tempQueryFields: this.tempFields,
            autoQuery: autoQuery,
            prefixCls: prefixCls,
            expand: this.expand,
            dataSet: dataSet,
            queryDataSet: queryDataSet,
            refEditors: this.refEditors,
            onChange: this.handleSelect,
            conditionStatus: dataSet.getState(CONDITIONSTATUS),
            onStatusChange: this.setConditionStatus,
            selectFields: dataSet.getState(SELECTFIELDS),
            onOriginalChange: this.setOriginalConditionFields,
            menuDataSet: dataSet.getState(MENUDATASET),
            filterMenuDataSet: dataSet.getState(FILTERMENUDATASET),
            conditionDataSet: dataSet.getState(CONDITIONDATASET),
            newFilterDataSet: dataSet.getState(NEWFILTERDATASET),
            optionDataSet: dataSet.getState(OPTIONDATASET),
            shouldLocateData: this.shouldLocateData,
            initConditionFields: this.initConditionFields,
            sortableFieldNames: sortableFieldNames,
            searchText: this.searchText,
            loadConditionData: this.loadConditionData,
            defaultActiveKey: defaultActiveKey
          }
        }, /*#__PURE__*/_react["default"].createElement(_QuickFilterMenu["default"], null)) : null;
        var resetButton = this.isSingleLineOpt() || this.tableFilterAdapter ? null : this.getResetButton();
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-filter-menu")
        }, prefix, fuzzyQuery, advancedFilter, quickFilterMenu, resetButton, this.isSingleLineOpt() ? null : /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("span", {
          className: "".concat(prefixCls, "-filter-search-divide")
        }), this.getExpandNode(true)), suffix);
      }
    }
    /**
     * 查询字段初始顺序
     * 排除动态属性影响
     */

  }, {
    key: "originOrderQueryFields",
    get: function get() {
      var queryDataSet = this.props.queryDataSet;
      var getConfig = this.context.getConfig;
      var result = [];
      var tlsKey = getConfig('tlsKey');

      if (queryDataSet) {
        var fields = queryDataSet.fields,
            _queryDataSet$props$f = queryDataSet.props.fields,
            propFields = _queryDataSet$props$f === void 0 ? [] : _queryDataSet$props$f;
        var cloneFields = fields.toJS();
        propFields.forEach(function (_ref13) {
          var name = _ref13.name;

          if (name) {
            var field = cloneFields.get(name);

            var hasBindProps = function hasBindProps(propsName) {
              return field && field.get(propsName) && field.get(propsName).bind;
            };

            if (field && !field.get('bind') && !hasBindProps('computedProps') && !hasBindProps('dynamicProps') && !field.get('name').includes(tlsKey)) {
              result.push(field);
            }
          }
        });
      }

      return result;
    }
    /**
     * 获取模糊搜索字段参数名
     */

  }, {
    key: "searchText",
    get: function get() {
      var dynamicFilterBar = this.props.dynamicFilterBar;
      var getConfig = this.context.getConfig;
      return dynamicFilterBar && dynamicFilterBar.searchText || getConfig('tableFilterSearchText') || 'params';
    }
  }, {
    key: "handleHelpMouseEnter",
    value: function handleHelpMouseEnter(e, help) {
      var target = e.target;
      var _this$context = this.context,
          getTooltipTheme = _this$context.getTooltipTheme,
          getTooltipPlacement = _this$context.getTooltipPlacement;
      (0, _singleton.show)(target, {
        title: help,
        theme: getTooltipTheme('help'),
        placement: getTooltipPlacement('help')
      });
      this.isTooltipShown = true;
    }
  }, {
    key: "handleHelpMouseLeave",
    value: function handleHelpMouseLeave() {
      (0, _singleton.hide)();
    }
  }, {
    key: "renderTooltipHelp",
    value: function renderTooltipHelp(help) {
      var _this16 = this;

      if (help) {
        return /*#__PURE__*/_react["default"].createElement(_icon["default"], {
          type: "help",
          onMouseEnter: function onMouseEnter(e) {
            return _this16.handleHelpMouseEnter(e, help);
          },
          onMouseLeave: this.handleHelpMouseLeave
        });
      }
    }
    /**
     * 渲染查询项 label
     * @param param
     * @returns
     */

  }, {
    key: "getLabel",
    value: function getLabel(_ref14) {
      var field = _ref14.field,
          value = _ref14.value,
          record = _ref14.record,
          placeholder = _ref14.placeholder;

      if (value) {
        return field.get('label', record);
      }

      return field.get('label', record) || placeholder;
    }
    /**
     * 渲染查询条
     */

  }, {
    key: "getQueryBar",
    value: function getQueryBar() {
      var _this17 = this;

      var getConfig = this.context.getConfig;
      var _this$props17 = this.props,
          _this$props17$queryFi = _this$props17.queryFieldsLimit,
          queryFieldsLimit = _this$props17$queryFi === void 0 ? 3 : _this$props17$queryFi,
          queryFields = _this$props17.queryFields,
          queryDataSet = _this$props17.queryDataSet,
          dataSet = _this$props17.dataSet,
          fuzzyQueryOnly = _this$props17.fuzzyQueryOnly;
      var menuDataSet = dataSet.getState(MENUDATASET);
      var isTenant = menuDataSet && menuDataSet.current && menuDataSet.current.get('isTenant');
      var fieldsLimit = queryFieldsLimit;

      if (isTenant) {
        fieldsLimit = 0;
      }

      var prefixCls = this.prefixCls;
      var selectFields = dataSet.getState(SELECTFIELDS) || [];

      if (fuzzyQueryOnly) {
        return /*#__PURE__*/_react["default"].createElement("div", {
          key: "query_bar",
          className: "".concat(prefixCls, "-dynamic-filter-bar")
        }, this.getFilterMenu());
      }

      if (queryDataSet && queryFields.length) {
        var singleLineModeAction = this.isSingleLineOpt() ? /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-dynamic-filter-bar-single-action")
        }, this.getResetButton(), this.getExpandNode(false)) : null;
        return /*#__PURE__*/_react["default"].createElement("div", {
          key: "query_bar",
          className: "".concat(prefixCls, "-dynamic-filter-bar")
        }, this.getFilterMenu(), /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-dynamic-filter-single-wrapper"),
          ref: function ref(node) {
            return _this17.refSingleWrapper = node;
          }
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-filter-wrapper")
        }, this.queryFields.slice(0, fieldsLimit).map(function (element) {
          var _classNames;

          var _element$props = element.props,
              name = _element$props.name,
              hidden = _element$props.hidden,
              showHelp = _element$props.showHelp,
              disabled = _element$props.disabled,
              help = _element$props.help,
              placeholder = _element$props.placeholder;

          var isLabelShowHelp = (showHelp || getConfig('showHelp')) === _enum5.ShowHelp.label;

          if (hidden) return null;
          var queryField = queryDataSet.getField(name);
          if (!queryField) return null;
          var isRequired = queryField && queryField.get('required');
          var validationMessage = queryField && queryField.getValidationMessage(queryDataSet.current);
          var hasValue = !_this17.isEmpty(queryDataSet.current && queryDataSet.current.get(name));

          var label = _this17.getLabel({
            field: queryField,
            value: hasValue,
            placeholder: placeholder,
            record: queryDataSet.current
          });

          var isDisabled = disabled || queryField && queryField.get('disabled', queryDataSet.current);
          var itemContentClassName = (0, _classnames["default"])("".concat(prefixCls, "-filter-content"), (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-filter-content-disabled"), isDisabled), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-filter-content-required"), isRequired), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-filter-content-has-value"), hasValue), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-filter-content-invalid"), validationMessage), _classNames));
          return /*#__PURE__*/_react["default"].createElement("div", {
            className: itemContentClassName,
            key: name,
            onMouseDown: function onMouseDown() {
              if (!isDisabled) {
                var editor = _this17.refEditors.get(name);

                if (editor) {
                  (0, _defer["default"])(function () {
                    _this17.refEditors.get(name).focus();
                  }, 50);
                }
              }
            },
            onClick: function onClick() {
              if (!isDisabled) {
                var filterItem = _this17.refFilterItems.get(name);

                if (filterItem) {
                  if (!filterItem.className.includes("c7n-pro-lov-click")) {
                    filterItem.className += ' c7n-pro-lov-click';
                  }
                }
              }
            },
            onBlur: function onBlur() {
              var filterItem = _this17.refFilterItems.get(name);

              if (filterItem && filterItem.className.includes("c7n-pro-lov-click")) {
                filterItem.className = filterItem.className.split(" c7n-pro-lov-click")[0];
              }
            },
            onMouseEnter: function onMouseEnter(e) {
              if (validationMessage) {
                var currentTarget = e.currentTarget;
                (0, _singleton.show)(currentTarget, {
                  title: (0, _utils2.renderValidationMessage)(validationMessage, true),
                  theme: 'light',
                  placement: 'top'
                });
                _this17.isTooltipShown = true;
              }
            },
            onMouseLeave: function onMouseLeave() {
              (0, _singleton.hide)();
            }
          }, /*#__PURE__*/_react["default"].createElement("span", {
            className: "".concat(prefixCls, "-filter-label")
          }, label, isLabelShowHelp ? _this17.renderTooltipHelp(help || queryField && queryField.get('help', queryDataSet.current)) : null), /*#__PURE__*/_react["default"].createElement("span", {
            className: (0, _classnames["default"])("".concat(prefixCls, "-filter-item"), (0, _defineProperty2["default"])({}, "".concat(prefixCls, "-filter-item-has-value"), hasValue)),
            ref: function ref(node) {
              return _this17.refFilterItems.set(name, node);
            }
          }, _this17.createFields(element, name)));
        }), this.queryFields.slice(fieldsLimit).map(function (element) {
          var _classNames3;

          var _element$props2 = element.props,
              name = _element$props2.name,
              hidden = _element$props2.hidden,
              showHelp = _element$props2.showHelp,
              disabled = _element$props2.disabled,
              help = _element$props2.help,
              placeholder = _element$props2.placeholder;

          var isLabelShowHelp = (showHelp || getConfig('showHelp')) === _enum5.ShowHelp.label;

          if (hidden) return null;
          var queryField = queryDataSet.getField(name);
          if (!queryField) return null;
          var isRequired = queryField && queryField.get('required');
          var validationMessage = queryField && queryField.getValidationMessage(queryDataSet.current);
          var hasValue = !_this17.isEmpty(queryDataSet.current && queryDataSet.current.get(name));

          var label = _this17.getLabel({
            field: queryField,
            value: hasValue,
            placeholder: placeholder,
            record: queryDataSet.current
          });

          var isDisabled = disabled || queryField && queryField.get('disabled', queryDataSet.current);
          var itemContentClassName = (0, _classnames["default"])("".concat(prefixCls, "-filter-content"), (_classNames3 = {}, (0, _defineProperty2["default"])(_classNames3, "".concat(prefixCls, "-filter-content-disabled"), isDisabled), (0, _defineProperty2["default"])(_classNames3, "".concat(prefixCls, "-filter-content-required"), isRequired), (0, _defineProperty2["default"])(_classNames3, "".concat(prefixCls, "-filter-content-has-value"), hasValue), (0, _defineProperty2["default"])(_classNames3, "".concat(prefixCls, "-filter-content-invalid"), validationMessage), _classNames3));

          if (selectFields.includes(name)) {
            return /*#__PURE__*/_react["default"].createElement("div", {
              className: itemContentClassName,
              key: name,
              onMouseDown: function onMouseDown() {
                if (!isDisabled) {
                  var editor = _this17.refEditors.get(name);

                  if (editor) {
                    (0, _defer["default"])(function () {
                      _this17.refEditors.get(name).focus();
                    }, 50);
                  }
                }
              },
              onClick: function onClick() {
                if (!isDisabled) {
                  var filterItem = _this17.refFilterItems.get(name);

                  if (filterItem) {
                    if (!filterItem.className.includes("c7n-pro-lov-click")) {
                      filterItem.className += ' c7n-pro-lov-click';
                    }
                  }
                }
              },
              onBlur: function onBlur() {
                var filterItem = _this17.refFilterItems.get(name);

                if (filterItem && filterItem.className.includes("c7n-pro-lov-click")) {
                  filterItem.className = filterItem.className.split(" c7n-pro-lov-click")[0];
                }
              },
              onMouseEnter: function onMouseEnter(e) {
                if (validationMessage) {
                  var currentTarget = e.currentTarget;
                  (0, _singleton.show)(currentTarget, {
                    title: (0, _utils2.renderValidationMessage)(validationMessage, true),
                    theme: 'light',
                    placement: 'top'
                  });
                  _this17.isTooltipShown = true;
                }
              },
              onMouseLeave: function onMouseLeave() {
                (0, _singleton.hide)();
              }
            }, /*#__PURE__*/_react["default"].createElement(_icon["default"], {
              type: "cancel",
              className: "".concat(prefixCls, "-filter-item-close"),
              onMouseDown: function onMouseDown(e) {
                e.stopPropagation();
              },
              onClick: function onClick() {
                _this17.handleUnSelect([name]);
              }
            }), /*#__PURE__*/_react["default"].createElement("span", {
              className: "".concat(prefixCls, "-filter-label")
            }, label, isLabelShowHelp ? _this17.renderTooltipHelp(help || queryField && queryField.get('help', queryDataSet.current)) : null), /*#__PURE__*/_react["default"].createElement("span", {
              className: (0, _classnames["default"])("".concat(prefixCls, "-filter-item"), (0, _defineProperty2["default"])({}, "".concat(prefixCls, "-filter-item-has-value"), hasValue)),
              ref: function ref(node) {
                return _this17.refFilterItems.set(name, node);
              }
            }, _this17.createFields(element, name)));
          }

          return null;
        }), fieldsLimit < this.queryFields.length && /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-filter-item")
        }, /*#__PURE__*/_react["default"].createElement(_dropdown["default"], {
          visible: !this.fieldSelectHidden,
          overlay: /*#__PURE__*/_react["default"].createElement("div", {
            role: "none",
            ref: function ref(node) {
              return _this17.refDropdown = node;
            },
            onClick: function onClick(e) {
              e.stopPropagation();
            }
          }, /*#__PURE__*/_react["default"].createElement(_FieldList["default"], {
            groups: [{
              title: (0, _localeContext.$l)('Table', 'predefined_fields'),
              fields: isTenant ? (0, _toConsumableArray2["default"])(queryDataSet.fields.values()) : this.originOrderQueryFields.slice(fieldsLimit)
            }],
            prefixCls: "".concat(prefixCls, "-filter-list") || 'c7n-pro-table-filter-list',
            closeMenu: function closeMenu() {
              return (0, _mobx.runInAction)(function () {
                return _this17.fieldSelectHidden = true;
              });
            },
            value: selectFields,
            onSelect: this.handleSelect,
            onUnSelect: this.handleUnSelect
          })),
          trigger: [_enum.Action.click]
        }, /*#__PURE__*/_react["default"].createElement("span", {
          className: "".concat(prefixCls, "-add-fields"),
          onMouseDown: function onMouseDown(e) {
            e.nativeEvent.stopImmediatePropagation();
            (0, _mobx.runInAction)(function () {
              _this17.fieldSelectHidden = false;
            });
          }
        }, /*#__PURE__*/_react["default"].createElement(_icon["default"], {
          type: "add"
        }), (0, _localeContext.$l)('Table', 'add_filter'))))), singleLineModeAction));
      }

      return null;
    }
    /**
     *
     * @param collapse
     * @param value 模糊查询参数
     */

  }, {
    key: "handleQuery",
    value: function () {
      var _handleQuery = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee9(collapse, value, oldValue) {
        var _this$props18, _this$props18$onQuery, onQuery, autoQuery;

        return _regenerator["default"].wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                _this$props18 = this.props, _this$props18$onQuery = _this$props18.onQuery, onQuery = _this$props18$onQuery === void 0 ? _noop["default"] : _this$props18$onQuery, autoQuery = _this$props18.autoQuery;

                if (!autoQuery) {
                  _context9.next = 4;
                  break;
                }

                _context9.next = 4;
                return this.modifiedCheckQuery(value, oldValue);

              case 4:
                if (!collapse) {
                  onQuery();
                }

              case 5:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function handleQuery(_x8, _x9, _x10) {
        return _handleQuery.apply(this, arguments);
      }

      return handleQuery;
    }()
  }, {
    key: "render",
    value: function render() {
      var _this$props19 = this.props,
          summaryBar = _this$props19.summaryBar,
          buttons = _this$props19.buttons;
      var prefixCls = this.prefixCls;
      var queryBar = this.getQueryBar();

      if (queryBar) {
        return [queryBar, summaryBar];
      }

      return /*#__PURE__*/_react["default"].createElement(_TableButtons["default"], {
        key: "toolbar",
        prefixCls: "".concat(prefixCls, "-dynamic-filter-buttons"),
        buttons: buttons
      }, summaryBar);
    }
  }], [{
    key: "contextType",
    get: function get() {
      return _ConfigContext["default"];
    }
  }]);
  return TableDynamicFilterBar;
}(_react.Component);

TableDynamicFilterBar.defaultProps = {
  queryFieldsLimit: 3,
  autoQueryAfterReset: true,
  fuzzyQuery: true,
  fuzzyQueryOnly: false,
  autoQuery: true,
  refreshBtn: true,
  buttons: []
};
(0, _tslib.__decorate)([_mobx.observable], TableDynamicFilterBar.prototype, "moreFields", void 0);
(0, _tslib.__decorate)([_mobx.observable], TableDynamicFilterBar.prototype, "fieldSelectHidden", void 0);
(0, _tslib.__decorate)([_mobx.observable], TableDynamicFilterBar.prototype, "expand", void 0);
(0, _tslib.__decorate)([_mobx.observable], TableDynamicFilterBar.prototype, "visible", void 0);
(0, _tslib.__decorate)([_mobx.observable], TableDynamicFilterBar.prototype, "shouldLocateData", void 0);
(0, _tslib.__decorate)([_mobx.observable], TableDynamicFilterBar.prototype, "showExpandIcon", void 0);
(0, _tslib.__decorate)([_mobx.action], TableDynamicFilterBar.prototype, "handleMouseDownOut", void 0);
(0, _tslib.__decorate)([_autobind["default"]], TableDynamicFilterBar.prototype, "handleDataSetQuery", null);
(0, _tslib.__decorate)([_autobind["default"]], TableDynamicFilterBar.prototype, "handleDataSetValidate", null);
(0, _tslib.__decorate)([_autobind["default"], _mobx.action], TableDynamicFilterBar.prototype, "setConditionStatus", null);
(0, _tslib.__decorate)([_mobx.action], TableDynamicFilterBar.prototype, "setOriginalConditionFields", void 0);
(0, _tslib.__decorate)([_autobind["default"]], TableDynamicFilterBar.prototype, "handleDataSetUpdate", null);
(0, _tslib.__decorate)([_autobind["default"]], TableDynamicFilterBar.prototype, "handleDataSetCreate", null);
(0, _tslib.__decorate)([_autobind["default"]], TableDynamicFilterBar.prototype, "handleDataSetReset", null);
(0, _tslib.__decorate)([_autobind["default"]], TableDynamicFilterBar.prototype, "handleDataSetLoad", null);
(0, _tslib.__decorate)([_autobind["default"], _mobx.action], TableDynamicFilterBar.prototype, "initConditionFields", null);
(0, _tslib.__decorate)([_autobind["default"]], TableDynamicFilterBar.prototype, "initMenuDataSet", null);
(0, _tslib.__decorate)([_mobx.action], TableDynamicFilterBar.prototype, "handleSelect", void 0);
(0, _tslib.__decorate)([_mobx.action], TableDynamicFilterBar.prototype, "handleUnSelect", void 0);
(0, _tslib.__decorate)([_autobind["default"]], TableDynamicFilterBar.prototype, "handleFilterOk", null);
(0, _tslib.__decorate)([_autobind["default"]], TableDynamicFilterBar.prototype, "handleFilterCancel", null);
(0, _tslib.__decorate)([_autobind["default"]], TableDynamicFilterBar.prototype, "setFilterVisiable", null);
(0, _tslib.__decorate)([_autobind["default"]], TableDynamicFilterBar.prototype, "isPopupChildren", null);
(0, _tslib.__decorate)([_autobind["default"]], TableDynamicFilterBar.prototype, "handleEmitFilterCancel", null);
(0, _tslib.__decorate)([_autobind["default"]], TableDynamicFilterBar.prototype, "saveCustomizeExpTypeEditorRef", null);
(0, _tslib.__decorate)([_autobind["default"]], TableDynamicFilterBar.prototype, "saveAdvancedFilterContainerRef", null);
(0, _tslib.__decorate)([_autobind["default"]], TableDynamicFilterBar.prototype, "handleHelpMouseEnter", null);
(0, _tslib.__decorate)([_autobind["default"]], TableDynamicFilterBar.prototype, "handleHelpMouseLeave", null);
(0, _tslib.__decorate)([_autobind["default"]], TableDynamicFilterBar.prototype, "handleQuery", null);
TableDynamicFilterBar = (0, _tslib.__decorate)([_mobxReact.observer], TableDynamicFilterBar);
var _default = TableDynamicFilterBar;
exports["default"] = _default;
//# sourceMappingURL=TableDynamicFilterBar.js.map
