import { AxiosRequestConfig } from 'axios';
import { DataSetProps, DataToJSON } from '../../../data-set/interface';
export declare const ConditionDataSet: () => DataSetProps;
export declare enum AdvancedFieldSet {
    fieldName = "__fieldName__",
    comparator = "__comparator__",
    tableName = "__tableName__",
    alias = "__alias__",
    source = "__source__",
    conditionType = "__conditionType__"
}
export declare const NewFilterDataSet: ({ propFields }: {
    propFields: any;
}) => {
    paging: boolean;
    selection: boolean;
    autoCreate: boolean;
    primaryKey: string;
    autoQuery: boolean;
    fields: any[];
    dataToJSON: DataToJSON;
    events: {
        update: ({ record, name, oldValue }: {
            record: any;
            name: any;
            oldValue: any;
        }) => void;
    };
};
export declare const QuickFilterDataSet: ({ searchCode, queryDataSet, tableFilterAdapter }: {
    searchCode: any;
    queryDataSet: any;
    tableFilterAdapter: any;
}) => {
    paging: boolean;
    autoQuery: boolean;
    autoLocateFirst: boolean;
    primaryKey: string;
    transport: {
        adapter: (config: AxiosRequestConfig, type: string) => AxiosRequestConfig;
    };
    fields: ({
        name: string;
        label: string;
        type: string;
        maxLength: number;
        required: boolean;
        defaultValue?: undefined;
        transformResponse?: undefined;
        transformRequest?: undefined;
        falseValue?: undefined;
        trueValue?: undefined;
    } | {
        name: string;
        type: string;
        label?: undefined;
        maxLength?: undefined;
        required?: undefined;
        defaultValue?: undefined;
        transformResponse?: undefined;
        transformRequest?: undefined;
        falseValue?: undefined;
        trueValue?: undefined;
    } | {
        name: string;
        type: string;
        defaultValue: string;
        transformResponse: (value: any) => any;
        transformRequest: (value: any) => any;
        label?: undefined;
        maxLength?: undefined;
        required?: undefined;
        falseValue?: undefined;
        trueValue?: undefined;
    } | {
        name: string;
        type: string;
        falseValue: number;
        trueValue: number;
        label: string;
        maxLength?: undefined;
        required?: undefined;
        defaultValue?: undefined;
        transformResponse?: undefined;
        transformRequest?: undefined;
    } | {
        name: string;
        type: string;
        defaultValue: any;
        label?: undefined;
        maxLength?: undefined;
        required?: undefined;
        transformResponse?: undefined;
        transformRequest?: undefined;
        falseValue?: undefined;
        trueValue?: undefined;
    } | {
        name: string;
        type: string;
        falseValue: number;
        trueValue: number;
        defaultValue: number;
        transformResponse: (value: any) => 1 | 0;
        label: string;
        maxLength?: undefined;
        required?: undefined;
        transformRequest?: undefined;
    } | {
        name: string;
        type: string;
        falseValue: number;
        trueValue: number;
        label?: undefined;
        maxLength?: undefined;
        required?: undefined;
        defaultValue?: undefined;
        transformResponse?: undefined;
        transformRequest?: undefined;
    })[];
};
